
/* GENERATED CODE... DO NOT EDIT */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Copyright (C) 2012 Lanedo GmbH
 */


#include <string.h>

#include "qmi-oma.h"
#include "qmi-enum-types.h"
#include "qmi-enum-types-private.h"
#include "qmi-flags64-types.h"
#include "qmi-error-types.h"
#include "qmi-device.h"
#include "qmi-utils.h"

#define QMI_STATUS_SUCCESS 0x0000
#define QMI_STATUS_FAILURE 0x0001


typedef enum {
    QMI_MESSAGE_OMA_RESET = 0x0000,
    QMI_MESSAGE_OMA_SET_EVENT_REPORT = 0x0001,
    QMI_MESSAGE_OMA_START_SESSION = 0x0020,
    QMI_MESSAGE_OMA_CANCEL_SESSION = 0x0021,
    QMI_MESSAGE_OMA_GET_SESSION_INFO = 0x0022,
    QMI_MESSAGE_OMA_SEND_SELECTION = 0x0023,
    QMI_MESSAGE_OMA_GET_FEATURE_SETTING = 0x0024,
    QMI_MESSAGE_OMA_SET_FEATURE_SETTING = 0x0025,
} QmiMessageOma;


typedef enum {
    QMI_INDICATION_OMA_EVENT_REPORT = 0x0001,
} QmiIndicationOma;


/*****************************************************************************/
/* REQUEST/RESPONSE: Qmi Message OMA Reset */


/* --- Input -- */

/* Note: no fields in the Input container */

static QmiMessage *
__qmi_message_oma_reset_request_create (
    guint8 transaction_id,
    guint8 cid,
    gpointer unused,
    GError **error)
{
    QmiMessage *self;

    self = qmi_message_new (QMI_SERVICE_OMA,
                            cid,
                            transaction_id,
                            QMI_MESSAGE_OMA_RESET);

    return self;
}

/* --- Output -- */

/**
 * QmiMessageResult:
 * @error_status: a #guint16.
 * @error_code: a #guint16.
 *
 * A QmiMessageResult struct.
 */
typedef struct _QmiMessageResult {
    guint16 error_status;
    guint16 error_code;
} QmiMessageResult;

struct _QmiMessageOmaResetOutput {
    volatile gint ref_count;

    /* Result */
    gboolean arg_result_set;
    QmiMessageResult arg_result;
};

#define QMI_MESSAGE_OMA_RESET_OUTPUT_TLV_RESULT 0x02

/**
 * qmi_message_oma_reset_output_get_result:
 * @self: a QmiMessageOmaResetOutput.
 * @error: Return location for error or %NULL.
 *
 * Get the result of the QMI operation.
 *
 * Returns: %TRUE if the QMI operation succeeded, %FALSE if @error is set.
 */
gboolean
qmi_message_oma_reset_output_get_result (
    QmiMessageOmaResetOutput *self,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    /* We should always have a result set in the response message */
    if (!self->arg_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_MESSAGE,
                     "No 'Result' field given in the message");
        return FALSE;
    }

    if (self->arg_result.error_status == QMI_STATUS_SUCCESS) {
        /* Operation succeeded */
        return TRUE;
    }

    /* Report a QMI protocol error */
    g_set_error (error,
                 QMI_PROTOCOL_ERROR,
                 (QmiProtocolError) self->arg_result.error_code,
                 "QMI protocol error (%u): '%s'",
                 self->arg_result.error_code,
                 qmi_protocol_error_get_string ((QmiProtocolError) self->arg_result.error_code));
    return FALSE;
}

GType
qmi_message_oma_reset_output_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageOmaResetOutput"),
                                          (GBoxedCopyFunc) qmi_message_oma_reset_output_ref,
                                          (GBoxedFreeFunc) qmi_message_oma_reset_output_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_oma_reset_output_ref:
 * @self: a #QmiMessageOmaResetOutput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageOmaResetOutput *
qmi_message_oma_reset_output_ref (QmiMessageOmaResetOutput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_oma_reset_output_unref:
 * @self: a #QmiMessageOmaResetOutput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_oma_reset_output_unref (QmiMessageOmaResetOutput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessageOmaResetOutput, self);
    }
}

static gboolean
qmi_message_result_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    static const guint expected_len = 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Result' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    return TRUE;
}

static gchar *
qmi_message_result_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (self,
                                      QMI_MESSAGE_OMA_RESET_OUTPUT_TLV_RESULT,
                                      &buffer_len);
    if (buffer) {
        GString *printable;
        guint16 error_status;
        guint16 error_code;

        printable = g_string_new ("");
        qmi_utils_read_guint16_from_buffer (
            &buffer,
            &buffer_len,
            QMI_ENDIAN_LITTLE,
            &error_status);
        qmi_utils_read_guint16_from_buffer (
            &buffer,
            &buffer_len,
            QMI_ENDIAN_LITTLE,
            &error_code);

        g_warn_if_fail (buffer_len == 0);

        if (error_status == QMI_STATUS_SUCCESS)
            g_string_append (printable, "SUCCESS");
        else
            g_string_append_printf (printable,
                                    "FAILURE: %s",
                                    qmi_protocol_error_get_string ((QmiProtocolError) error_code));

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

struct message_reset_context {
    QmiMessage *self;
    const gchar *line_prefix;
    GString *printable;
};

static void
message_reset_get_tlv_printable (
    guint8 type,
    const guint8 *value,
    gsize length,
    struct message_reset_context *ctx)
{
    const gchar *tlv_type_str = NULL;
    gchar *translated_value;

    if (!qmi_message_is_response (ctx->self)) {
        switch (type) {
        default:
            break;
        }
    } else {
        switch (type) {
        case QMI_MESSAGE_OMA_RESET_OUTPUT_TLV_RESULT:
            tlv_type_str = "Result";
            translated_value = qmi_message_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    }

    if (!tlv_type_str) {
        gchar *value_str = NULL;

        value_str = qmi_message_get_tlv_printable (ctx->self,
                                                   ctx->line_prefix,
                                                   type,
                                                   value,
                                                   length);
        g_string_append (ctx->printable, value_str);
        g_free (value_str);
    } else {
        gchar *value_hex;

        value_hex = __qmi_utils_str_hex (value, length, ':');
        g_string_append_printf (ctx->printable,
                                "%sTLV:\n"
                                "%s  type       = \"%s\" (0x%02x)\n"
                                "%s  length     = %" G_GSIZE_FORMAT "\n"
                                "%s  value      = %s\n"
                                "%s  translated = %s\n",
                                ctx->line_prefix,
                                ctx->line_prefix, tlv_type_str, type,
                                ctx->line_prefix, length,
                                ctx->line_prefix, value_hex,
                                ctx->line_prefix, translated_value ? translated_value : "");
        g_free (value_hex);
        g_free (translated_value);
    }
}

static gchar *
message_reset_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    GString *printable;

    printable = g_string_new ("");
    g_string_append_printf (printable,
                            "%s  message     = \"Reset\" (0x0000)\n",
                            line_prefix);

    {
        struct message_reset_context ctx;
        ctx.self = self;
        ctx.line_prefix = line_prefix;
        ctx.printable = printable;
        qmi_message_foreach_raw_tlv (self,
                                     (QmiMessageForeachRawTlvFn)message_reset_get_tlv_printable,
                                     &ctx);
    }

    return g_string_free (printable, FALSE);
}

static QmiMessageOmaResetOutput *
__qmi_message_oma_reset_response_parse (
    QmiMessage *message,
    GError **error)
{
    QmiMessageOmaResetOutput *self;

    g_return_val_if_fail (qmi_message_get_message_id (message) == QMI_MESSAGE_OMA_RESET, NULL);

    self = g_slice_new0 (QmiMessageOmaResetOutput);
    self->ref_count = 1;

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_OMA_RESET_OUTPUT_TLV_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_result_validate (buffer, buffer_len)) {
                self->arg_result_set = TRUE;

                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_status));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_code));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Result' TLV", buffer_len);
                }
            } else {
                g_set_error (error,
                             QMI_CORE_ERROR,
                             QMI_CORE_ERROR_TLV_NOT_FOUND,
                             "Couldn't get the Result TLV: Not found");
                qmi_message_oma_reset_output_unref (self);
                return NULL;
            }

        }
    } while (0);

    return self;
}

/*****************************************************************************/
/* REQUEST/RESPONSE: Qmi Message OMA Set Event Report */


/* --- Input -- */

struct _QmiMessageOmaSetEventReportInput {
    volatile gint ref_count;

    /* Session State Reporting */
    gboolean arg_session_state_reporting_set;
    guint8 arg_session_state_reporting;

    /* Network Initiated Alert Reporting */
    gboolean arg_network_initiated_alert_reporting_set;
    guint8 arg_network_initiated_alert_reporting;
};

#define QMI_MESSAGE_OMA_SET_EVENT_REPORT_INPUT_TLV_SESSION_STATE_REPORTING 0x11
#define QMI_MESSAGE_OMA_SET_EVENT_REPORT_INPUT_TLV_NETWORK_INITIATED_ALERT_REPORTING 0x10

/**
 * qmi_message_oma_set_event_report_input_get_session_state_reporting:
 * @self: a #QmiMessageOmaSetEventReportInput.
 * @session_state_reporting: a placeholder for the output #gboolean, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Session State Reporting' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_oma_set_event_report_input_get_session_state_reporting (
    QmiMessageOmaSetEventReportInput *self,
    gboolean *session_state_reporting,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_session_state_reporting_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Session State Reporting' was not found in the message");
        return FALSE;
    }

    if (session_state_reporting)
        *session_state_reporting = (gboolean)(self->arg_session_state_reporting);

    return TRUE;
}

/**
 * qmi_message_oma_set_event_report_input_set_session_state_reporting:
 * @self: a #QmiMessageOmaSetEventReportInput.
 * @session_state_reporting: a #gboolean.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Session State Reporting' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_oma_set_event_report_input_set_session_state_reporting (
    QmiMessageOmaSetEventReportInput *self,
    gboolean session_state_reporting,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_session_state_reporting = (guint8)(session_state_reporting);
    self->arg_session_state_reporting_set = TRUE;

    return TRUE;
}

/**
 * qmi_message_oma_set_event_report_input_get_network_initiated_alert_reporting:
 * @self: a #QmiMessageOmaSetEventReportInput.
 * @network_initiated_alert_reporting: a placeholder for the output #gboolean, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Network Initiated Alert Reporting' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_oma_set_event_report_input_get_network_initiated_alert_reporting (
    QmiMessageOmaSetEventReportInput *self,
    gboolean *network_initiated_alert_reporting,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_network_initiated_alert_reporting_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Network Initiated Alert Reporting' was not found in the message");
        return FALSE;
    }

    if (network_initiated_alert_reporting)
        *network_initiated_alert_reporting = (gboolean)(self->arg_network_initiated_alert_reporting);

    return TRUE;
}

/**
 * qmi_message_oma_set_event_report_input_set_network_initiated_alert_reporting:
 * @self: a #QmiMessageOmaSetEventReportInput.
 * @network_initiated_alert_reporting: a #gboolean.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Network Initiated Alert Reporting' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_oma_set_event_report_input_set_network_initiated_alert_reporting (
    QmiMessageOmaSetEventReportInput *self,
    gboolean network_initiated_alert_reporting,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_network_initiated_alert_reporting = (guint8)(network_initiated_alert_reporting);
    self->arg_network_initiated_alert_reporting_set = TRUE;

    return TRUE;
}

GType
qmi_message_oma_set_event_report_input_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageOmaSetEventReportInput"),
                                          (GBoxedCopyFunc) qmi_message_oma_set_event_report_input_ref,
                                          (GBoxedFreeFunc) qmi_message_oma_set_event_report_input_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_oma_set_event_report_input_ref:
 * @self: a #QmiMessageOmaSetEventReportInput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageOmaSetEventReportInput *
qmi_message_oma_set_event_report_input_ref (QmiMessageOmaSetEventReportInput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_oma_set_event_report_input_unref:
 * @self: a #QmiMessageOmaSetEventReportInput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_oma_set_event_report_input_unref (QmiMessageOmaSetEventReportInput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessageOmaSetEventReportInput, self);
    }
}

/**
 * qmi_message_oma_set_event_report_input_new:
 *
 * Allocates a new #QmiMessageOmaSetEventReportInput.
 *
 * Returns: the newly created #QmiMessageOmaSetEventReportInput. The returned value should be freed with qmi_message_oma_set_event_report_input_unref().
 */
QmiMessageOmaSetEventReportInput *
qmi_message_oma_set_event_report_input_new (void)
{
    QmiMessageOmaSetEventReportInput *self;

    self = g_slice_new0 (QmiMessageOmaSetEventReportInput);
    self->ref_count = 1;
    return self;
}

static QmiMessage *
__qmi_message_oma_set_event_report_request_create (
    guint8 transaction_id,
    guint8 cid,
    QmiMessageOmaSetEventReportInput *input,
    GError **error)
{
    QmiMessage *self;

    self = qmi_message_new (QMI_SERVICE_OMA,
                            cid,
                            transaction_id,
                            QMI_MESSAGE_OMA_SET_EVENT_REPORT);

    /* All TLVs are optional, we allow NULL input */
    if (!input)
        return self;

    /* Try to add the 'Session State Reporting' TLV */
    if (input->arg_session_state_reporting_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        if (buffer_len < 1)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_EVENT_REPORT_INPUT_TLV_SESSION_STATE_REPORTING;
        else {
            guint8 tmp;

            tmp = (guint8)input->arg_session_state_reporting;
            /* Write the guint8 variable to the buffer */
            qmi_utils_write_guint8_to_buffer (
                &buffer_aux,
                &buffer_len,
                &tmp);
        }

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_EVENT_REPORT_INPUT_TLV_SESSION_STATE_REPORTING:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_EVENT_REPORT_INPUT_TLV_SESSION_STATE_REPORTING;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_OMA_SET_EVENT_REPORT_INPUT_TLV_SESSION_STATE_REPORTING,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_EVENT_REPORT_INPUT_TLV_SESSION_STATE_REPORTING:
            g_prefix_error (error, "Couldn't set the Session State Reporting TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    }

    /* Try to add the 'Network Initiated Alert Reporting' TLV */
    if (input->arg_network_initiated_alert_reporting_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        if (buffer_len < 1)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_EVENT_REPORT_INPUT_TLV_NETWORK_INITIATED_ALERT_REPORTING;
        else {
            guint8 tmp;

            tmp = (guint8)input->arg_network_initiated_alert_reporting;
            /* Write the guint8 variable to the buffer */
            qmi_utils_write_guint8_to_buffer (
                &buffer_aux,
                &buffer_len,
                &tmp);
        }

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_EVENT_REPORT_INPUT_TLV_NETWORK_INITIATED_ALERT_REPORTING:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_EVENT_REPORT_INPUT_TLV_NETWORK_INITIATED_ALERT_REPORTING;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_OMA_SET_EVENT_REPORT_INPUT_TLV_NETWORK_INITIATED_ALERT_REPORTING,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_EVENT_REPORT_INPUT_TLV_NETWORK_INITIATED_ALERT_REPORTING:
            g_prefix_error (error, "Couldn't set the Network Initiated Alert Reporting TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    }

    return self;
}

/* --- Output -- */

struct _QmiMessageOmaSetEventReportOutput {
    volatile gint ref_count;

    /* Result */
    gboolean arg_result_set;
    QmiMessageResult arg_result;
};

#define QMI_MESSAGE_OMA_SET_EVENT_REPORT_OUTPUT_TLV_RESULT 0x02

/**
 * qmi_message_oma_set_event_report_output_get_result:
 * @self: a QmiMessageOmaSetEventReportOutput.
 * @error: Return location for error or %NULL.
 *
 * Get the result of the QMI operation.
 *
 * Returns: %TRUE if the QMI operation succeeded, %FALSE if @error is set.
 */
gboolean
qmi_message_oma_set_event_report_output_get_result (
    QmiMessageOmaSetEventReportOutput *self,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    /* We should always have a result set in the response message */
    if (!self->arg_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_MESSAGE,
                     "No 'Result' field given in the message");
        return FALSE;
    }

    if (self->arg_result.error_status == QMI_STATUS_SUCCESS) {
        /* Operation succeeded */
        return TRUE;
    }

    /* Report a QMI protocol error */
    g_set_error (error,
                 QMI_PROTOCOL_ERROR,
                 (QmiProtocolError) self->arg_result.error_code,
                 "QMI protocol error (%u): '%s'",
                 self->arg_result.error_code,
                 qmi_protocol_error_get_string ((QmiProtocolError) self->arg_result.error_code));
    return FALSE;
}

GType
qmi_message_oma_set_event_report_output_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageOmaSetEventReportOutput"),
                                          (GBoxedCopyFunc) qmi_message_oma_set_event_report_output_ref,
                                          (GBoxedFreeFunc) qmi_message_oma_set_event_report_output_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_oma_set_event_report_output_ref:
 * @self: a #QmiMessageOmaSetEventReportOutput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageOmaSetEventReportOutput *
qmi_message_oma_set_event_report_output_ref (QmiMessageOmaSetEventReportOutput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_oma_set_event_report_output_unref:
 * @self: a #QmiMessageOmaSetEventReportOutput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_oma_set_event_report_output_unref (QmiMessageOmaSetEventReportOutput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessageOmaSetEventReportOutput, self);
    }
}

static gboolean
qmi_message_oma_set_event_report_input_session_state_reporting_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Session State Reporting' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Session State Reporting' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_oma_set_event_report_input_session_state_reporting_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_OMA_SET_EVENT_REPORT_INPUT_TLV_SESSION_STATE_REPORTING,
                                      &buffer_len);
    if (buffer && qmi_message_oma_set_event_report_input_session_state_reporting_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%s", tmp ? "yes" : "no");
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Session State Reporting' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_oma_set_event_report_input_network_initiated_alert_reporting_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Network Initiated Alert Reporting' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Network Initiated Alert Reporting' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_oma_set_event_report_input_network_initiated_alert_reporting_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_OMA_SET_EVENT_REPORT_INPUT_TLV_NETWORK_INITIATED_ALERT_REPORTING,
                                      &buffer_len);
    if (buffer && qmi_message_oma_set_event_report_input_network_initiated_alert_reporting_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%s", tmp ? "yes" : "no");
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Network Initiated Alert Reporting' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

struct message_set_event_report_context {
    QmiMessage *self;
    const gchar *line_prefix;
    GString *printable;
};

static void
message_set_event_report_get_tlv_printable (
    guint8 type,
    const guint8 *value,
    gsize length,
    struct message_set_event_report_context *ctx)
{
    const gchar *tlv_type_str = NULL;
    gchar *translated_value;

    if (!qmi_message_is_response (ctx->self)) {
        switch (type) {
        case QMI_MESSAGE_OMA_SET_EVENT_REPORT_INPUT_TLV_SESSION_STATE_REPORTING:
            tlv_type_str = "Session State Reporting";
            translated_value = qmi_message_oma_set_event_report_input_session_state_reporting_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_OMA_SET_EVENT_REPORT_INPUT_TLV_NETWORK_INITIATED_ALERT_REPORTING:
            tlv_type_str = "Network Initiated Alert Reporting";
            translated_value = qmi_message_oma_set_event_report_input_network_initiated_alert_reporting_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    } else {
        switch (type) {
        case QMI_MESSAGE_OMA_SET_EVENT_REPORT_OUTPUT_TLV_RESULT:
            tlv_type_str = "Result";
            translated_value = qmi_message_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    }

    if (!tlv_type_str) {
        gchar *value_str = NULL;

        value_str = qmi_message_get_tlv_printable (ctx->self,
                                                   ctx->line_prefix,
                                                   type,
                                                   value,
                                                   length);
        g_string_append (ctx->printable, value_str);
        g_free (value_str);
    } else {
        gchar *value_hex;

        value_hex = __qmi_utils_str_hex (value, length, ':');
        g_string_append_printf (ctx->printable,
                                "%sTLV:\n"
                                "%s  type       = \"%s\" (0x%02x)\n"
                                "%s  length     = %" G_GSIZE_FORMAT "\n"
                                "%s  value      = %s\n"
                                "%s  translated = %s\n",
                                ctx->line_prefix,
                                ctx->line_prefix, tlv_type_str, type,
                                ctx->line_prefix, length,
                                ctx->line_prefix, value_hex,
                                ctx->line_prefix, translated_value ? translated_value : "");
        g_free (value_hex);
        g_free (translated_value);
    }
}

static gchar *
message_set_event_report_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    GString *printable;

    printable = g_string_new ("");
    g_string_append_printf (printable,
                            "%s  message     = \"Set Event Report\" (0x0001)\n",
                            line_prefix);

    {
        struct message_set_event_report_context ctx;
        ctx.self = self;
        ctx.line_prefix = line_prefix;
        ctx.printable = printable;
        qmi_message_foreach_raw_tlv (self,
                                     (QmiMessageForeachRawTlvFn)message_set_event_report_get_tlv_printable,
                                     &ctx);
    }

    return g_string_free (printable, FALSE);
}

static QmiMessageOmaSetEventReportOutput *
__qmi_message_oma_set_event_report_response_parse (
    QmiMessage *message,
    GError **error)
{
    QmiMessageOmaSetEventReportOutput *self;

    g_return_val_if_fail (qmi_message_get_message_id (message) == QMI_MESSAGE_OMA_SET_EVENT_REPORT, NULL);

    self = g_slice_new0 (QmiMessageOmaSetEventReportOutput);
    self->ref_count = 1;

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_OMA_SET_EVENT_REPORT_OUTPUT_TLV_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_result_validate (buffer, buffer_len)) {
                self->arg_result_set = TRUE;

                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_status));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_code));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Result' TLV", buffer_len);
                }
            } else {
                g_set_error (error,
                             QMI_CORE_ERROR,
                             QMI_CORE_ERROR_TLV_NOT_FOUND,
                             "Couldn't get the Result TLV: Not found");
                qmi_message_oma_set_event_report_output_unref (self);
                return NULL;
            }

        }
    } while (0);

    return self;
}

/*****************************************************************************/
/* INDICATION: Qmi Indication OMA Event Report */


/* --- Output -- */

struct _QmiIndicationOmaEventReportOutput {
    volatile gint ref_count;

    /* Session Fail Reason */
    gboolean arg_session_fail_reason_set;
    guint8 arg_session_fail_reason;

    /* Session State */
    gboolean arg_session_state_set;
    guint8 arg_session_state;

    /* Network Initiated Alert */
    gboolean arg_network_initiated_alert_set;
    guint8 arg_network_initiated_alert_session_type;
    guint16 arg_network_initiated_alert_session_id;
};

#define QMI_INDICATION_OMA_EVENT_REPORT_OUTPUT_TLV_SESSION_FAIL_REASON 0x12
#define QMI_INDICATION_OMA_EVENT_REPORT_OUTPUT_TLV_SESSION_STATE 0x11
#define QMI_INDICATION_OMA_EVENT_REPORT_OUTPUT_TLV_NETWORK_INITIATED_ALERT 0x10

/**
 * qmi_indication_oma_event_report_output_get_session_fail_reason:
 * @self: a #QmiIndicationOmaEventReportOutput.
 * @session_fail_reason: a placeholder for the output #QmiOmaSessionFailedReason, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Session Fail Reason' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_indication_oma_event_report_output_get_session_fail_reason (
    QmiIndicationOmaEventReportOutput *self,
    QmiOmaSessionFailedReason *session_fail_reason,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_session_fail_reason_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Session Fail Reason' was not found in the message");
        return FALSE;
    }

    if (session_fail_reason)
        *session_fail_reason = (QmiOmaSessionFailedReason)(self->arg_session_fail_reason);

    return TRUE;
}

/**
 * qmi_indication_oma_event_report_output_get_session_state:
 * @self: a #QmiIndicationOmaEventReportOutput.
 * @session_state: a placeholder for the output #QmiOmaSessionState, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Session State' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_indication_oma_event_report_output_get_session_state (
    QmiIndicationOmaEventReportOutput *self,
    QmiOmaSessionState *session_state,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_session_state_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Session State' was not found in the message");
        return FALSE;
    }

    if (session_state)
        *session_state = (QmiOmaSessionState)(self->arg_session_state);

    return TRUE;
}

/**
 * qmi_indication_oma_event_report_output_get_network_initiated_alert:
 * @self: a #QmiIndicationOmaEventReportOutput.
 * @network_initiated_alert_session_type: a placeholder for the output #QmiOmaSessionType, or %NULL if not required.
 * @network_initiated_alert_session_id: a placeholder for the output #guint16, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Network Initiated Alert' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_indication_oma_event_report_output_get_network_initiated_alert (
    QmiIndicationOmaEventReportOutput *self,
    QmiOmaSessionType *network_initiated_alert_session_type,
    guint16 *network_initiated_alert_session_id,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_network_initiated_alert_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Network Initiated Alert' was not found in the message");
        return FALSE;
    }

    if (network_initiated_alert_session_type)
        *network_initiated_alert_session_type = (QmiOmaSessionType)(self->arg_network_initiated_alert_session_type);
    if (network_initiated_alert_session_id)
        *network_initiated_alert_session_id = self->arg_network_initiated_alert_session_id;

    return TRUE;
}

GType
qmi_indication_oma_event_report_output_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiIndicationOmaEventReportOutput"),
                                          (GBoxedCopyFunc) qmi_indication_oma_event_report_output_ref,
                                          (GBoxedFreeFunc) qmi_indication_oma_event_report_output_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_indication_oma_event_report_output_ref:
 * @self: a #QmiIndicationOmaEventReportOutput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiIndicationOmaEventReportOutput *
qmi_indication_oma_event_report_output_ref (QmiIndicationOmaEventReportOutput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_indication_oma_event_report_output_unref:
 * @self: a #QmiIndicationOmaEventReportOutput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_indication_oma_event_report_output_unref (QmiIndicationOmaEventReportOutput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiIndicationOmaEventReportOutput, self);
    }
}

static gboolean
qmi_indication_oma_event_report_output_session_fail_reason_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Session Fail Reason' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Session Fail Reason' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_indication_oma_event_report_output_session_fail_reason_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_INDICATION_OMA_EVENT_REPORT_OUTPUT_TLV_SESSION_FAIL_REASON,
                                      &buffer_len);
    if (buffer && qmi_indication_oma_event_report_output_session_fail_reason_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_OMA_SESSION_FAILED_REASON_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_oma_session_failed_reason_get_string ((QmiOmaSessionFailedReason)tmp));
#elif defined  __QMI_OMA_SESSION_FAILED_REASON_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_oma_session_failed_reason_build_string_from_mask ((QmiOmaSessionFailedReason)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiOmaSessionFailedReason
#endif
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Session Fail Reason' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_indication_oma_event_report_output_session_state_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Session State' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Session State' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_indication_oma_event_report_output_session_state_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_INDICATION_OMA_EVENT_REPORT_OUTPUT_TLV_SESSION_STATE,
                                      &buffer_len);
    if (buffer && qmi_indication_oma_event_report_output_session_state_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_OMA_SESSION_STATE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_oma_session_state_get_string ((QmiOmaSessionState)tmp));
#elif defined  __QMI_OMA_SESSION_STATE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_oma_session_state_build_string_from_mask ((QmiOmaSessionState)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiOmaSessionState
#endif
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Session State' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_indication_oma_event_report_output_network_initiated_alert_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;
    expected_len += 2;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Network Initiated Alert' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Network Initiated Alert' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_indication_oma_event_report_output_network_initiated_alert_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_INDICATION_OMA_EVENT_REPORT_OUTPUT_TLV_NETWORK_INITIATED_ALERT,
                                      &buffer_len);
    if (buffer && qmi_indication_oma_event_report_output_network_initiated_alert_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " session_type = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_OMA_SESSION_TYPE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_oma_session_type_get_string ((QmiOmaSessionType)tmp));
#elif defined  __QMI_OMA_SESSION_TYPE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_oma_session_type_build_string_from_mask ((QmiOmaSessionType)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiOmaSessionType
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " session_id = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Network Initiated Alert' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

struct indication_event_report_context {
    QmiMessage *self;
    const gchar *line_prefix;
    GString *printable;
};

static void
indication_event_report_get_tlv_printable (
    guint8 type,
    const guint8 *value,
    gsize length,
    struct indication_event_report_context *ctx)
{
    const gchar *tlv_type_str = NULL;
    gchar *translated_value;

    {
        switch (type) {
        case QMI_INDICATION_OMA_EVENT_REPORT_OUTPUT_TLV_SESSION_FAIL_REASON:
            tlv_type_str = "Session Fail Reason";
            translated_value = qmi_indication_oma_event_report_output_session_fail_reason_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_INDICATION_OMA_EVENT_REPORT_OUTPUT_TLV_SESSION_STATE:
            tlv_type_str = "Session State";
            translated_value = qmi_indication_oma_event_report_output_session_state_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_INDICATION_OMA_EVENT_REPORT_OUTPUT_TLV_NETWORK_INITIATED_ALERT:
            tlv_type_str = "Network Initiated Alert";
            translated_value = qmi_indication_oma_event_report_output_network_initiated_alert_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    }

    if (!tlv_type_str) {
        gchar *value_str = NULL;

        value_str = qmi_message_get_tlv_printable (ctx->self,
                                                   ctx->line_prefix,
                                                   type,
                                                   value,
                                                   length);
        g_string_append (ctx->printable, value_str);
        g_free (value_str);
    } else {
        gchar *value_hex;

        value_hex = __qmi_utils_str_hex (value, length, ':');
        g_string_append_printf (ctx->printable,
                                "%sTLV:\n"
                                "%s  type       = \"%s\" (0x%02x)\n"
                                "%s  length     = %" G_GSIZE_FORMAT "\n"
                                "%s  value      = %s\n"
                                "%s  translated = %s\n",
                                ctx->line_prefix,
                                ctx->line_prefix, tlv_type_str, type,
                                ctx->line_prefix, length,
                                ctx->line_prefix, value_hex,
                                ctx->line_prefix, translated_value ? translated_value : "");
        g_free (value_hex);
        g_free (translated_value);
    }
}

static gchar *
indication_event_report_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    GString *printable;

    printable = g_string_new ("");
    g_string_append_printf (printable,
                            "%s  message     = \"Event Report\" (0x0001)\n",
                            line_prefix);

    {
        struct indication_event_report_context ctx;
        ctx.self = self;
        ctx.line_prefix = line_prefix;
        ctx.printable = printable;
        qmi_message_foreach_raw_tlv (self,
                                     (QmiMessageForeachRawTlvFn)indication_event_report_get_tlv_printable,
                                     &ctx);
    }

    return g_string_free (printable, FALSE);
}

static QmiIndicationOmaEventReportOutput *
__qmi_indication_oma_event_report_indication_parse (
    QmiMessage *message,
    GError **error)
{
    QmiIndicationOmaEventReportOutput *self;

    g_return_val_if_fail (qmi_message_get_message_id (message) == QMI_INDICATION_OMA_EVENT_REPORT, NULL);

    self = g_slice_new0 (QmiIndicationOmaEventReportOutput);
    self->ref_count = 1;

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_INDICATION_OMA_EVENT_REPORT_OUTPUT_TLV_SESSION_FAIL_REASON,
                                              &buffer_len);
            if (buffer && qmi_indication_oma_event_report_output_session_fail_reason_validate (buffer, buffer_len)) {
                self->arg_session_fail_reason_set = TRUE;

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_session_fail_reason = (QmiOmaSessionFailedReason)tmp;
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Session Fail Reason' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_INDICATION_OMA_EVENT_REPORT_OUTPUT_TLV_SESSION_STATE,
                                              &buffer_len);
            if (buffer && qmi_indication_oma_event_report_output_session_state_validate (buffer, buffer_len)) {
                self->arg_session_state_set = TRUE;

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_session_state = (QmiOmaSessionState)tmp;
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Session State' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_INDICATION_OMA_EVENT_REPORT_OUTPUT_TLV_NETWORK_INITIATED_ALERT,
                                              &buffer_len);
            if (buffer && qmi_indication_oma_event_report_output_network_initiated_alert_validate (buffer, buffer_len)) {
                self->arg_network_initiated_alert_set = TRUE;

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_network_initiated_alert_session_type = (QmiOmaSessionType)tmp;
                }
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_network_initiated_alert_session_id));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Network Initiated Alert' TLV", buffer_len);
                }
            }

        }
    } while (0);

    return self;
}

/*****************************************************************************/
/* REQUEST/RESPONSE: Qmi Message OMA Start Session */


/* --- Input -- */

struct _QmiMessageOmaStartSessionInput {
    volatile gint ref_count;

    /* Session Type */
    gboolean arg_session_type_set;
    guint8 arg_session_type;
};

#define QMI_MESSAGE_OMA_START_SESSION_INPUT_TLV_SESSION_TYPE 0x10

/**
 * qmi_message_oma_start_session_input_get_session_type:
 * @self: a #QmiMessageOmaStartSessionInput.
 * @session_type: a placeholder for the output #QmiOmaSessionType, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Session Type' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_oma_start_session_input_get_session_type (
    QmiMessageOmaStartSessionInput *self,
    QmiOmaSessionType *session_type,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_session_type_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Session Type' was not found in the message");
        return FALSE;
    }

    if (session_type)
        *session_type = (QmiOmaSessionType)(self->arg_session_type);

    return TRUE;
}

/**
 * qmi_message_oma_start_session_input_set_session_type:
 * @self: a #QmiMessageOmaStartSessionInput.
 * @session_type: a #QmiOmaSessionType.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Session Type' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_oma_start_session_input_set_session_type (
    QmiMessageOmaStartSessionInput *self,
    QmiOmaSessionType session_type,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_session_type = (guint8)(session_type);
    self->arg_session_type_set = TRUE;

    return TRUE;
}

GType
qmi_message_oma_start_session_input_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageOmaStartSessionInput"),
                                          (GBoxedCopyFunc) qmi_message_oma_start_session_input_ref,
                                          (GBoxedFreeFunc) qmi_message_oma_start_session_input_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_oma_start_session_input_ref:
 * @self: a #QmiMessageOmaStartSessionInput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageOmaStartSessionInput *
qmi_message_oma_start_session_input_ref (QmiMessageOmaStartSessionInput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_oma_start_session_input_unref:
 * @self: a #QmiMessageOmaStartSessionInput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_oma_start_session_input_unref (QmiMessageOmaStartSessionInput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessageOmaStartSessionInput, self);
    }
}

/**
 * qmi_message_oma_start_session_input_new:
 *
 * Allocates a new #QmiMessageOmaStartSessionInput.
 *
 * Returns: the newly created #QmiMessageOmaStartSessionInput. The returned value should be freed with qmi_message_oma_start_session_input_unref().
 */
QmiMessageOmaStartSessionInput *
qmi_message_oma_start_session_input_new (void)
{
    QmiMessageOmaStartSessionInput *self;

    self = g_slice_new0 (QmiMessageOmaStartSessionInput);
    self->ref_count = 1;
    return self;
}

static QmiMessage *
__qmi_message_oma_start_session_request_create (
    guint8 transaction_id,
    guint8 cid,
    QmiMessageOmaStartSessionInput *input,
    GError **error)
{
    QmiMessage *self;

    self = qmi_message_new (QMI_SERVICE_OMA,
                            cid,
                            transaction_id,
                            QMI_MESSAGE_OMA_START_SESSION);

    /* All TLVs are optional, we allow NULL input */
    if (!input)
        return self;

    /* Try to add the 'Session Type' TLV */
    if (input->arg_session_type_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        if (buffer_len < 1)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_START_SESSION_INPUT_TLV_SESSION_TYPE;
        else {
            guint8 tmp;

            tmp = (guint8)input->arg_session_type;
            /* Write the guint8 variable to the buffer */
            qmi_utils_write_guint8_to_buffer (
                &buffer_aux,
                &buffer_len,
                &tmp);
        }

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_START_SESSION_INPUT_TLV_SESSION_TYPE:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_START_SESSION_INPUT_TLV_SESSION_TYPE;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_OMA_START_SESSION_INPUT_TLV_SESSION_TYPE,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_START_SESSION_INPUT_TLV_SESSION_TYPE:
            g_prefix_error (error, "Couldn't set the Session Type TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    }

    return self;
}

/* --- Output -- */

struct _QmiMessageOmaStartSessionOutput {
    volatile gint ref_count;

    /* Result */
    gboolean arg_result_set;
    QmiMessageResult arg_result;
};

#define QMI_MESSAGE_OMA_START_SESSION_OUTPUT_TLV_RESULT 0x02

/**
 * qmi_message_oma_start_session_output_get_result:
 * @self: a QmiMessageOmaStartSessionOutput.
 * @error: Return location for error or %NULL.
 *
 * Get the result of the QMI operation.
 *
 * Returns: %TRUE if the QMI operation succeeded, %FALSE if @error is set.
 */
gboolean
qmi_message_oma_start_session_output_get_result (
    QmiMessageOmaStartSessionOutput *self,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    /* We should always have a result set in the response message */
    if (!self->arg_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_MESSAGE,
                     "No 'Result' field given in the message");
        return FALSE;
    }

    if (self->arg_result.error_status == QMI_STATUS_SUCCESS) {
        /* Operation succeeded */
        return TRUE;
    }

    /* Report a QMI protocol error */
    g_set_error (error,
                 QMI_PROTOCOL_ERROR,
                 (QmiProtocolError) self->arg_result.error_code,
                 "QMI protocol error (%u): '%s'",
                 self->arg_result.error_code,
                 qmi_protocol_error_get_string ((QmiProtocolError) self->arg_result.error_code));
    return FALSE;
}

GType
qmi_message_oma_start_session_output_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageOmaStartSessionOutput"),
                                          (GBoxedCopyFunc) qmi_message_oma_start_session_output_ref,
                                          (GBoxedFreeFunc) qmi_message_oma_start_session_output_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_oma_start_session_output_ref:
 * @self: a #QmiMessageOmaStartSessionOutput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageOmaStartSessionOutput *
qmi_message_oma_start_session_output_ref (QmiMessageOmaStartSessionOutput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_oma_start_session_output_unref:
 * @self: a #QmiMessageOmaStartSessionOutput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_oma_start_session_output_unref (QmiMessageOmaStartSessionOutput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessageOmaStartSessionOutput, self);
    }
}

static gboolean
qmi_message_oma_start_session_input_session_type_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Session Type' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Session Type' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_oma_start_session_input_session_type_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_OMA_START_SESSION_INPUT_TLV_SESSION_TYPE,
                                      &buffer_len);
    if (buffer && qmi_message_oma_start_session_input_session_type_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_OMA_SESSION_TYPE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_oma_session_type_get_string ((QmiOmaSessionType)tmp));
#elif defined  __QMI_OMA_SESSION_TYPE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_oma_session_type_build_string_from_mask ((QmiOmaSessionType)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiOmaSessionType
#endif
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Session Type' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

struct message_start_session_context {
    QmiMessage *self;
    const gchar *line_prefix;
    GString *printable;
};

static void
message_start_session_get_tlv_printable (
    guint8 type,
    const guint8 *value,
    gsize length,
    struct message_start_session_context *ctx)
{
    const gchar *tlv_type_str = NULL;
    gchar *translated_value;

    if (!qmi_message_is_response (ctx->self)) {
        switch (type) {
        case QMI_MESSAGE_OMA_START_SESSION_INPUT_TLV_SESSION_TYPE:
            tlv_type_str = "Session Type";
            translated_value = qmi_message_oma_start_session_input_session_type_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    } else {
        switch (type) {
        case QMI_MESSAGE_OMA_START_SESSION_OUTPUT_TLV_RESULT:
            tlv_type_str = "Result";
            translated_value = qmi_message_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    }

    if (!tlv_type_str) {
        gchar *value_str = NULL;

        value_str = qmi_message_get_tlv_printable (ctx->self,
                                                   ctx->line_prefix,
                                                   type,
                                                   value,
                                                   length);
        g_string_append (ctx->printable, value_str);
        g_free (value_str);
    } else {
        gchar *value_hex;

        value_hex = __qmi_utils_str_hex (value, length, ':');
        g_string_append_printf (ctx->printable,
                                "%sTLV:\n"
                                "%s  type       = \"%s\" (0x%02x)\n"
                                "%s  length     = %" G_GSIZE_FORMAT "\n"
                                "%s  value      = %s\n"
                                "%s  translated = %s\n",
                                ctx->line_prefix,
                                ctx->line_prefix, tlv_type_str, type,
                                ctx->line_prefix, length,
                                ctx->line_prefix, value_hex,
                                ctx->line_prefix, translated_value ? translated_value : "");
        g_free (value_hex);
        g_free (translated_value);
    }
}

static gchar *
message_start_session_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    GString *printable;

    printable = g_string_new ("");
    g_string_append_printf (printable,
                            "%s  message     = \"Start Session\" (0x0020)\n",
                            line_prefix);

    {
        struct message_start_session_context ctx;
        ctx.self = self;
        ctx.line_prefix = line_prefix;
        ctx.printable = printable;
        qmi_message_foreach_raw_tlv (self,
                                     (QmiMessageForeachRawTlvFn)message_start_session_get_tlv_printable,
                                     &ctx);
    }

    return g_string_free (printable, FALSE);
}

static QmiMessageOmaStartSessionOutput *
__qmi_message_oma_start_session_response_parse (
    QmiMessage *message,
    GError **error)
{
    QmiMessageOmaStartSessionOutput *self;

    g_return_val_if_fail (qmi_message_get_message_id (message) == QMI_MESSAGE_OMA_START_SESSION, NULL);

    self = g_slice_new0 (QmiMessageOmaStartSessionOutput);
    self->ref_count = 1;

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_OMA_START_SESSION_OUTPUT_TLV_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_result_validate (buffer, buffer_len)) {
                self->arg_result_set = TRUE;

                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_status));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_code));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Result' TLV", buffer_len);
                }
            } else {
                g_set_error (error,
                             QMI_CORE_ERROR,
                             QMI_CORE_ERROR_TLV_NOT_FOUND,
                             "Couldn't get the Result TLV: Not found");
                qmi_message_oma_start_session_output_unref (self);
                return NULL;
            }

        }
    } while (0);

    return self;
}

/*****************************************************************************/
/* REQUEST/RESPONSE: Qmi Message OMA Cancel Session */


/* --- Input -- */

/* Note: no fields in the Input container */

static QmiMessage *
__qmi_message_oma_cancel_session_request_create (
    guint8 transaction_id,
    guint8 cid,
    gpointer unused,
    GError **error)
{
    QmiMessage *self;

    self = qmi_message_new (QMI_SERVICE_OMA,
                            cid,
                            transaction_id,
                            QMI_MESSAGE_OMA_CANCEL_SESSION);

    return self;
}

/* --- Output -- */

struct _QmiMessageOmaCancelSessionOutput {
    volatile gint ref_count;

    /* Result */
    gboolean arg_result_set;
    QmiMessageResult arg_result;
};

#define QMI_MESSAGE_OMA_CANCEL_SESSION_OUTPUT_TLV_RESULT 0x02

/**
 * qmi_message_oma_cancel_session_output_get_result:
 * @self: a QmiMessageOmaCancelSessionOutput.
 * @error: Return location for error or %NULL.
 *
 * Get the result of the QMI operation.
 *
 * Returns: %TRUE if the QMI operation succeeded, %FALSE if @error is set.
 */
gboolean
qmi_message_oma_cancel_session_output_get_result (
    QmiMessageOmaCancelSessionOutput *self,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    /* We should always have a result set in the response message */
    if (!self->arg_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_MESSAGE,
                     "No 'Result' field given in the message");
        return FALSE;
    }

    if (self->arg_result.error_status == QMI_STATUS_SUCCESS) {
        /* Operation succeeded */
        return TRUE;
    }

    /* Report a QMI protocol error */
    g_set_error (error,
                 QMI_PROTOCOL_ERROR,
                 (QmiProtocolError) self->arg_result.error_code,
                 "QMI protocol error (%u): '%s'",
                 self->arg_result.error_code,
                 qmi_protocol_error_get_string ((QmiProtocolError) self->arg_result.error_code));
    return FALSE;
}

GType
qmi_message_oma_cancel_session_output_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageOmaCancelSessionOutput"),
                                          (GBoxedCopyFunc) qmi_message_oma_cancel_session_output_ref,
                                          (GBoxedFreeFunc) qmi_message_oma_cancel_session_output_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_oma_cancel_session_output_ref:
 * @self: a #QmiMessageOmaCancelSessionOutput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageOmaCancelSessionOutput *
qmi_message_oma_cancel_session_output_ref (QmiMessageOmaCancelSessionOutput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_oma_cancel_session_output_unref:
 * @self: a #QmiMessageOmaCancelSessionOutput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_oma_cancel_session_output_unref (QmiMessageOmaCancelSessionOutput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessageOmaCancelSessionOutput, self);
    }
}

struct message_cancel_session_context {
    QmiMessage *self;
    const gchar *line_prefix;
    GString *printable;
};

static void
message_cancel_session_get_tlv_printable (
    guint8 type,
    const guint8 *value,
    gsize length,
    struct message_cancel_session_context *ctx)
{
    const gchar *tlv_type_str = NULL;
    gchar *translated_value;

    if (!qmi_message_is_response (ctx->self)) {
        switch (type) {
        default:
            break;
        }
    } else {
        switch (type) {
        case QMI_MESSAGE_OMA_CANCEL_SESSION_OUTPUT_TLV_RESULT:
            tlv_type_str = "Result";
            translated_value = qmi_message_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    }

    if (!tlv_type_str) {
        gchar *value_str = NULL;

        value_str = qmi_message_get_tlv_printable (ctx->self,
                                                   ctx->line_prefix,
                                                   type,
                                                   value,
                                                   length);
        g_string_append (ctx->printable, value_str);
        g_free (value_str);
    } else {
        gchar *value_hex;

        value_hex = __qmi_utils_str_hex (value, length, ':');
        g_string_append_printf (ctx->printable,
                                "%sTLV:\n"
                                "%s  type       = \"%s\" (0x%02x)\n"
                                "%s  length     = %" G_GSIZE_FORMAT "\n"
                                "%s  value      = %s\n"
                                "%s  translated = %s\n",
                                ctx->line_prefix,
                                ctx->line_prefix, tlv_type_str, type,
                                ctx->line_prefix, length,
                                ctx->line_prefix, value_hex,
                                ctx->line_prefix, translated_value ? translated_value : "");
        g_free (value_hex);
        g_free (translated_value);
    }
}

static gchar *
message_cancel_session_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    GString *printable;

    printable = g_string_new ("");
    g_string_append_printf (printable,
                            "%s  message     = \"Cancel Session\" (0x0021)\n",
                            line_prefix);

    {
        struct message_cancel_session_context ctx;
        ctx.self = self;
        ctx.line_prefix = line_prefix;
        ctx.printable = printable;
        qmi_message_foreach_raw_tlv (self,
                                     (QmiMessageForeachRawTlvFn)message_cancel_session_get_tlv_printable,
                                     &ctx);
    }

    return g_string_free (printable, FALSE);
}

static QmiMessageOmaCancelSessionOutput *
__qmi_message_oma_cancel_session_response_parse (
    QmiMessage *message,
    GError **error)
{
    QmiMessageOmaCancelSessionOutput *self;

    g_return_val_if_fail (qmi_message_get_message_id (message) == QMI_MESSAGE_OMA_CANCEL_SESSION, NULL);

    self = g_slice_new0 (QmiMessageOmaCancelSessionOutput);
    self->ref_count = 1;

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_OMA_CANCEL_SESSION_OUTPUT_TLV_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_result_validate (buffer, buffer_len)) {
                self->arg_result_set = TRUE;

                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_status));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_code));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Result' TLV", buffer_len);
                }
            } else {
                g_set_error (error,
                             QMI_CORE_ERROR,
                             QMI_CORE_ERROR_TLV_NOT_FOUND,
                             "Couldn't get the Result TLV: Not found");
                qmi_message_oma_cancel_session_output_unref (self);
                return NULL;
            }

        }
    } while (0);

    return self;
}

/*****************************************************************************/
/* REQUEST/RESPONSE: Qmi Message OMA Get Session Info */


/* --- Input -- */

/* Note: no fields in the Input container */

static QmiMessage *
__qmi_message_oma_get_session_info_request_create (
    guint8 transaction_id,
    guint8 cid,
    gpointer unused,
    GError **error)
{
    QmiMessage *self;

    self = qmi_message_new (QMI_SERVICE_OMA,
                            cid,
                            transaction_id,
                            QMI_MESSAGE_OMA_GET_SESSION_INFO);

    return self;
}

/* --- Output -- */

struct _QmiMessageOmaGetSessionInfoOutput {
    volatile gint ref_count;

    /* Result */
    gboolean arg_result_set;
    QmiMessageResult arg_result;

    /* Session Info */
    gboolean arg_session_info_set;
    guint8 arg_session_info_session_state;
    guint8 arg_session_info_session_type;

    /* Session Failed Reason */
    gboolean arg_session_failed_reason_set;
    guint8 arg_session_failed_reason;

    /* Retry Info */
    gboolean arg_retry_info_set;
    guint8 arg_retry_info_retry_count;
    guint16 arg_retry_info_retry_pause_timer;
    guint16 arg_retry_info_retry_pause_timer_remaining;

    /* Network Initiated Alert */
    gboolean arg_network_initiated_alert_set;
    guint8 arg_network_initiated_alert_session_type;
    guint16 arg_network_initiated_alert_session_id;
};

#define QMI_MESSAGE_OMA_GET_SESSION_INFO_OUTPUT_TLV_RESULT 0x02
#define QMI_MESSAGE_OMA_GET_SESSION_INFO_OUTPUT_TLV_SESSION_INFO 0x10
#define QMI_MESSAGE_OMA_GET_SESSION_INFO_OUTPUT_TLV_SESSION_FAILED_REASON 0x11
#define QMI_MESSAGE_OMA_GET_SESSION_INFO_OUTPUT_TLV_RETRY_INFO 0x12
#define QMI_MESSAGE_OMA_GET_SESSION_INFO_OUTPUT_TLV_NETWORK_INITIATED_ALERT 0x13

/**
 * qmi_message_oma_get_session_info_output_get_result:
 * @self: a QmiMessageOmaGetSessionInfoOutput.
 * @error: Return location for error or %NULL.
 *
 * Get the result of the QMI operation.
 *
 * Returns: %TRUE if the QMI operation succeeded, %FALSE if @error is set.
 */
gboolean
qmi_message_oma_get_session_info_output_get_result (
    QmiMessageOmaGetSessionInfoOutput *self,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    /* We should always have a result set in the response message */
    if (!self->arg_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_MESSAGE,
                     "No 'Result' field given in the message");
        return FALSE;
    }

    if (self->arg_result.error_status == QMI_STATUS_SUCCESS) {
        /* Operation succeeded */
        return TRUE;
    }

    /* Report a QMI protocol error */
    g_set_error (error,
                 QMI_PROTOCOL_ERROR,
                 (QmiProtocolError) self->arg_result.error_code,
                 "QMI protocol error (%u): '%s'",
                 self->arg_result.error_code,
                 qmi_protocol_error_get_string ((QmiProtocolError) self->arg_result.error_code));
    return FALSE;
}

/**
 * qmi_message_oma_get_session_info_output_get_session_info:
 * @self: a #QmiMessageOmaGetSessionInfoOutput.
 * @session_info_session_state: a placeholder for the output #QmiOmaSessionState, or %NULL if not required.
 * @session_info_session_type: a placeholder for the output #QmiOmaSessionType, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Session Info' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_oma_get_session_info_output_get_session_info (
    QmiMessageOmaGetSessionInfoOutput *self,
    QmiOmaSessionState *session_info_session_state,
    QmiOmaSessionType *session_info_session_type,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_session_info_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Session Info' was not found in the message");
        return FALSE;
    }

    if (session_info_session_state)
        *session_info_session_state = (QmiOmaSessionState)(self->arg_session_info_session_state);
    if (session_info_session_type)
        *session_info_session_type = (QmiOmaSessionType)(self->arg_session_info_session_type);

    return TRUE;
}

/**
 * qmi_message_oma_get_session_info_output_get_session_failed_reason:
 * @self: a #QmiMessageOmaGetSessionInfoOutput.
 * @session_failed_reason: a placeholder for the output #QmiOmaSessionFailedReason, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Session Failed Reason' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_oma_get_session_info_output_get_session_failed_reason (
    QmiMessageOmaGetSessionInfoOutput *self,
    QmiOmaSessionFailedReason *session_failed_reason,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_session_failed_reason_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Session Failed Reason' was not found in the message");
        return FALSE;
    }

    if (session_failed_reason)
        *session_failed_reason = (QmiOmaSessionFailedReason)(self->arg_session_failed_reason);

    return TRUE;
}

/**
 * qmi_message_oma_get_session_info_output_get_retry_info:
 * @self: a #QmiMessageOmaGetSessionInfoOutput.
 * @retry_info_retry_count: a placeholder for the output #guint8, or %NULL if not required.
 * @retry_info_retry_pause_timer: a placeholder for the output #guint16, or %NULL if not required.
 * @retry_info_retry_pause_timer_remaining: a placeholder for the output #guint16, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Retry Info' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_oma_get_session_info_output_get_retry_info (
    QmiMessageOmaGetSessionInfoOutput *self,
    guint8 *retry_info_retry_count,
    guint16 *retry_info_retry_pause_timer,
    guint16 *retry_info_retry_pause_timer_remaining,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_retry_info_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Retry Info' was not found in the message");
        return FALSE;
    }

    if (retry_info_retry_count)
        *retry_info_retry_count = self->arg_retry_info_retry_count;
    if (retry_info_retry_pause_timer)
        *retry_info_retry_pause_timer = self->arg_retry_info_retry_pause_timer;
    if (retry_info_retry_pause_timer_remaining)
        *retry_info_retry_pause_timer_remaining = self->arg_retry_info_retry_pause_timer_remaining;

    return TRUE;
}

/**
 * qmi_message_oma_get_session_info_output_get_network_initiated_alert:
 * @self: a #QmiMessageOmaGetSessionInfoOutput.
 * @network_initiated_alert_session_type: a placeholder for the output #QmiOmaSessionType, or %NULL if not required.
 * @network_initiated_alert_session_id: a placeholder for the output #guint16, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Network Initiated Alert' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_oma_get_session_info_output_get_network_initiated_alert (
    QmiMessageOmaGetSessionInfoOutput *self,
    QmiOmaSessionType *network_initiated_alert_session_type,
    guint16 *network_initiated_alert_session_id,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_network_initiated_alert_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Network Initiated Alert' was not found in the message");
        return FALSE;
    }

    if (network_initiated_alert_session_type)
        *network_initiated_alert_session_type = (QmiOmaSessionType)(self->arg_network_initiated_alert_session_type);
    if (network_initiated_alert_session_id)
        *network_initiated_alert_session_id = self->arg_network_initiated_alert_session_id;

    return TRUE;
}

GType
qmi_message_oma_get_session_info_output_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageOmaGetSessionInfoOutput"),
                                          (GBoxedCopyFunc) qmi_message_oma_get_session_info_output_ref,
                                          (GBoxedFreeFunc) qmi_message_oma_get_session_info_output_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_oma_get_session_info_output_ref:
 * @self: a #QmiMessageOmaGetSessionInfoOutput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageOmaGetSessionInfoOutput *
qmi_message_oma_get_session_info_output_ref (QmiMessageOmaGetSessionInfoOutput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_oma_get_session_info_output_unref:
 * @self: a #QmiMessageOmaGetSessionInfoOutput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_oma_get_session_info_output_unref (QmiMessageOmaGetSessionInfoOutput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessageOmaGetSessionInfoOutput, self);
    }
}

static gboolean
qmi_message_oma_get_session_info_output_session_info_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;
    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Session Info' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Session Info' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_oma_get_session_info_output_session_info_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_OMA_GET_SESSION_INFO_OUTPUT_TLV_SESSION_INFO,
                                      &buffer_len);
    if (buffer && qmi_message_oma_get_session_info_output_session_info_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " session_state = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_OMA_SESSION_STATE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_oma_session_state_get_string ((QmiOmaSessionState)tmp));
#elif defined  __QMI_OMA_SESSION_STATE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_oma_session_state_build_string_from_mask ((QmiOmaSessionState)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiOmaSessionState
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " session_type = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_OMA_SESSION_TYPE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_oma_session_type_get_string ((QmiOmaSessionType)tmp));
#elif defined  __QMI_OMA_SESSION_TYPE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_oma_session_type_build_string_from_mask ((QmiOmaSessionType)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiOmaSessionType
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Session Info' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_oma_get_session_info_output_session_failed_reason_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Session Failed Reason' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Session Failed Reason' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_oma_get_session_info_output_session_failed_reason_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_OMA_GET_SESSION_INFO_OUTPUT_TLV_SESSION_FAILED_REASON,
                                      &buffer_len);
    if (buffer && qmi_message_oma_get_session_info_output_session_failed_reason_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_OMA_SESSION_FAILED_REASON_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_oma_session_failed_reason_get_string ((QmiOmaSessionFailedReason)tmp));
#elif defined  __QMI_OMA_SESSION_FAILED_REASON_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_oma_session_failed_reason_build_string_from_mask ((QmiOmaSessionFailedReason)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiOmaSessionFailedReason
#endif
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Session Failed Reason' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_oma_get_session_info_output_retry_info_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;
    expected_len += 2;
    expected_len += 2;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Retry Info' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Retry Info' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_oma_get_session_info_output_retry_info_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_OMA_GET_SESSION_INFO_OUTPUT_TLV_RETRY_INFO,
                                      &buffer_len);
    if (buffer && qmi_message_oma_get_session_info_output_retry_info_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " retry_count = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " retry_pause_timer = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " retry_pause_timer_remaining = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Retry Info' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_oma_get_session_info_output_network_initiated_alert_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;
    expected_len += 2;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Network Initiated Alert' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Network Initiated Alert' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_oma_get_session_info_output_network_initiated_alert_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_OMA_GET_SESSION_INFO_OUTPUT_TLV_NETWORK_INITIATED_ALERT,
                                      &buffer_len);
    if (buffer && qmi_message_oma_get_session_info_output_network_initiated_alert_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " session_type = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_OMA_SESSION_TYPE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_oma_session_type_get_string ((QmiOmaSessionType)tmp));
#elif defined  __QMI_OMA_SESSION_TYPE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_oma_session_type_build_string_from_mask ((QmiOmaSessionType)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiOmaSessionType
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " session_id = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Network Initiated Alert' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

struct message_get_session_info_context {
    QmiMessage *self;
    const gchar *line_prefix;
    GString *printable;
};

static void
message_get_session_info_get_tlv_printable (
    guint8 type,
    const guint8 *value,
    gsize length,
    struct message_get_session_info_context *ctx)
{
    const gchar *tlv_type_str = NULL;
    gchar *translated_value;

    if (!qmi_message_is_response (ctx->self)) {
        switch (type) {
        default:
            break;
        }
    } else {
        switch (type) {
        case QMI_MESSAGE_OMA_GET_SESSION_INFO_OUTPUT_TLV_RESULT:
            tlv_type_str = "Result";
            translated_value = qmi_message_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_OMA_GET_SESSION_INFO_OUTPUT_TLV_SESSION_INFO:
            tlv_type_str = "Session Info";
            translated_value = qmi_message_oma_get_session_info_output_session_info_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_OMA_GET_SESSION_INFO_OUTPUT_TLV_SESSION_FAILED_REASON:
            tlv_type_str = "Session Failed Reason";
            translated_value = qmi_message_oma_get_session_info_output_session_failed_reason_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_OMA_GET_SESSION_INFO_OUTPUT_TLV_RETRY_INFO:
            tlv_type_str = "Retry Info";
            translated_value = qmi_message_oma_get_session_info_output_retry_info_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_OMA_GET_SESSION_INFO_OUTPUT_TLV_NETWORK_INITIATED_ALERT:
            tlv_type_str = "Network Initiated Alert";
            translated_value = qmi_message_oma_get_session_info_output_network_initiated_alert_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    }

    if (!tlv_type_str) {
        gchar *value_str = NULL;

        value_str = qmi_message_get_tlv_printable (ctx->self,
                                                   ctx->line_prefix,
                                                   type,
                                                   value,
                                                   length);
        g_string_append (ctx->printable, value_str);
        g_free (value_str);
    } else {
        gchar *value_hex;

        value_hex = __qmi_utils_str_hex (value, length, ':');
        g_string_append_printf (ctx->printable,
                                "%sTLV:\n"
                                "%s  type       = \"%s\" (0x%02x)\n"
                                "%s  length     = %" G_GSIZE_FORMAT "\n"
                                "%s  value      = %s\n"
                                "%s  translated = %s\n",
                                ctx->line_prefix,
                                ctx->line_prefix, tlv_type_str, type,
                                ctx->line_prefix, length,
                                ctx->line_prefix, value_hex,
                                ctx->line_prefix, translated_value ? translated_value : "");
        g_free (value_hex);
        g_free (translated_value);
    }
}

static gchar *
message_get_session_info_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    GString *printable;

    printable = g_string_new ("");
    g_string_append_printf (printable,
                            "%s  message     = \"Get Session Info\" (0x0022)\n",
                            line_prefix);

    {
        struct message_get_session_info_context ctx;
        ctx.self = self;
        ctx.line_prefix = line_prefix;
        ctx.printable = printable;
        qmi_message_foreach_raw_tlv (self,
                                     (QmiMessageForeachRawTlvFn)message_get_session_info_get_tlv_printable,
                                     &ctx);
    }

    return g_string_free (printable, FALSE);
}

static QmiMessageOmaGetSessionInfoOutput *
__qmi_message_oma_get_session_info_response_parse (
    QmiMessage *message,
    GError **error)
{
    QmiMessageOmaGetSessionInfoOutput *self;

    g_return_val_if_fail (qmi_message_get_message_id (message) == QMI_MESSAGE_OMA_GET_SESSION_INFO, NULL);

    self = g_slice_new0 (QmiMessageOmaGetSessionInfoOutput);
    self->ref_count = 1;

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_OMA_GET_SESSION_INFO_OUTPUT_TLV_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_result_validate (buffer, buffer_len)) {
                self->arg_result_set = TRUE;

                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_status));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_code));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Result' TLV", buffer_len);
                }
            } else {
                g_set_error (error,
                             QMI_CORE_ERROR,
                             QMI_CORE_ERROR_TLV_NOT_FOUND,
                             "Couldn't get the Result TLV: Not found");
                qmi_message_oma_get_session_info_output_unref (self);
                return NULL;
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_OMA_GET_SESSION_INFO_OUTPUT_TLV_SESSION_INFO,
                                              &buffer_len);
            if (buffer && qmi_message_oma_get_session_info_output_session_info_validate (buffer, buffer_len)) {
                self->arg_session_info_set = TRUE;

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_session_info_session_state = (QmiOmaSessionState)tmp;
                }
                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_session_info_session_type = (QmiOmaSessionType)tmp;
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Session Info' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_session_info_session_state == QMI_OMA_SESSION_STATE_FAILED))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_OMA_GET_SESSION_INFO_OUTPUT_TLV_SESSION_FAILED_REASON,
                                              &buffer_len);
            if (buffer && qmi_message_oma_get_session_info_output_session_failed_reason_validate (buffer, buffer_len)) {
                self->arg_session_failed_reason_set = TRUE;

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_session_failed_reason = (QmiOmaSessionFailedReason)tmp;
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Session Failed Reason' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_OMA_GET_SESSION_INFO_OUTPUT_TLV_RETRY_INFO,
                                              &buffer_len);
            if (buffer && qmi_message_oma_get_session_info_output_retry_info_validate (buffer, buffer_len)) {
                self->arg_retry_info_set = TRUE;

                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_retry_info_retry_count));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_retry_info_retry_pause_timer));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_retry_info_retry_pause_timer_remaining));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Retry Info' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_OMA_GET_SESSION_INFO_OUTPUT_TLV_NETWORK_INITIATED_ALERT,
                                              &buffer_len);
            if (buffer && qmi_message_oma_get_session_info_output_network_initiated_alert_validate (buffer, buffer_len)) {
                self->arg_network_initiated_alert_set = TRUE;

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_network_initiated_alert_session_type = (QmiOmaSessionType)tmp;
                }
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_network_initiated_alert_session_id));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Network Initiated Alert' TLV", buffer_len);
                }
            }

        }
    } while (0);

    return self;
}

/*****************************************************************************/
/* REQUEST/RESPONSE: Qmi Message OMA Send Selection */


/* --- Input -- */

struct _QmiMessageOmaSendSelectionInput {
    volatile gint ref_count;

    /* Network Initiated Alert Selection */
    gboolean arg_network_initiated_alert_selection_set;
    guint8 arg_network_initiated_alert_selection_control_point_selection_accept;
    guint16 arg_network_initiated_alert_selection_session_id;
};

#define QMI_MESSAGE_OMA_SEND_SELECTION_INPUT_TLV_NETWORK_INITIATED_ALERT_SELECTION 0x10

/**
 * qmi_message_oma_send_selection_input_get_network_initiated_alert_selection:
 * @self: a #QmiMessageOmaSendSelectionInput.
 * @network_initiated_alert_selection_control_point_selection_accept: a placeholder for the output #gboolean, or %NULL if not required.
 * @network_initiated_alert_selection_session_id: a placeholder for the output #guint16, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Network Initiated Alert Selection' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_oma_send_selection_input_get_network_initiated_alert_selection (
    QmiMessageOmaSendSelectionInput *self,
    gboolean *network_initiated_alert_selection_control_point_selection_accept,
    guint16 *network_initiated_alert_selection_session_id,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_network_initiated_alert_selection_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Network Initiated Alert Selection' was not found in the message");
        return FALSE;
    }

    if (network_initiated_alert_selection_control_point_selection_accept)
        *network_initiated_alert_selection_control_point_selection_accept = (gboolean)(self->arg_network_initiated_alert_selection_control_point_selection_accept);
    if (network_initiated_alert_selection_session_id)
        *network_initiated_alert_selection_session_id = self->arg_network_initiated_alert_selection_session_id;

    return TRUE;
}

/**
 * qmi_message_oma_send_selection_input_set_network_initiated_alert_selection:
 * @self: a #QmiMessageOmaSendSelectionInput.
 * @network_initiated_alert_selection_control_point_selection_accept: a #gboolean.
 * @network_initiated_alert_selection_session_id: a #guint16.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Network Initiated Alert Selection' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_oma_send_selection_input_set_network_initiated_alert_selection (
    QmiMessageOmaSendSelectionInput *self,
    gboolean network_initiated_alert_selection_control_point_selection_accept,
    guint16 network_initiated_alert_selection_session_id,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_network_initiated_alert_selection_control_point_selection_accept = (guint8)(network_initiated_alert_selection_control_point_selection_accept);
    self->arg_network_initiated_alert_selection_session_id = network_initiated_alert_selection_session_id;
    self->arg_network_initiated_alert_selection_set = TRUE;

    return TRUE;
}

GType
qmi_message_oma_send_selection_input_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageOmaSendSelectionInput"),
                                          (GBoxedCopyFunc) qmi_message_oma_send_selection_input_ref,
                                          (GBoxedFreeFunc) qmi_message_oma_send_selection_input_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_oma_send_selection_input_ref:
 * @self: a #QmiMessageOmaSendSelectionInput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageOmaSendSelectionInput *
qmi_message_oma_send_selection_input_ref (QmiMessageOmaSendSelectionInput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_oma_send_selection_input_unref:
 * @self: a #QmiMessageOmaSendSelectionInput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_oma_send_selection_input_unref (QmiMessageOmaSendSelectionInput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessageOmaSendSelectionInput, self);
    }
}

/**
 * qmi_message_oma_send_selection_input_new:
 *
 * Allocates a new #QmiMessageOmaSendSelectionInput.
 *
 * Returns: the newly created #QmiMessageOmaSendSelectionInput. The returned value should be freed with qmi_message_oma_send_selection_input_unref().
 */
QmiMessageOmaSendSelectionInput *
qmi_message_oma_send_selection_input_new (void)
{
    QmiMessageOmaSendSelectionInput *self;

    self = g_slice_new0 (QmiMessageOmaSendSelectionInput);
    self->ref_count = 1;
    return self;
}

static QmiMessage *
__qmi_message_oma_send_selection_request_create (
    guint8 transaction_id,
    guint8 cid,
    QmiMessageOmaSendSelectionInput *input,
    GError **error)
{
    QmiMessage *self;

    self = qmi_message_new (QMI_SERVICE_OMA,
                            cid,
                            transaction_id,
                            QMI_MESSAGE_OMA_SEND_SELECTION);

    /* All TLVs are optional, we allow NULL input */
    if (!input)
        return self;

    /* Try to add the 'Network Initiated Alert Selection' TLV */
    if (input->arg_network_initiated_alert_selection_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        if (buffer_len < 1)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SEND_SELECTION_INPUT_TLV_NETWORK_INITIATED_ALERT_SELECTION;
        else {
            guint8 tmp;

            tmp = (guint8)input->arg_network_initiated_alert_selection_control_point_selection_accept;
            /* Write the guint8 variable to the buffer */
            qmi_utils_write_guint8_to_buffer (
                &buffer_aux,
                &buffer_len,
                &tmp);
        }
        /* Write the guint16 variable to the buffer */
        if (buffer_len < 2)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SEND_SELECTION_INPUT_TLV_NETWORK_INITIATED_ALERT_SELECTION;
        else
            qmi_utils_write_guint16_to_buffer (
                &buffer_aux,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &(input->arg_network_initiated_alert_selection_session_id));

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SEND_SELECTION_INPUT_TLV_NETWORK_INITIATED_ALERT_SELECTION:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SEND_SELECTION_INPUT_TLV_NETWORK_INITIATED_ALERT_SELECTION;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_OMA_SEND_SELECTION_INPUT_TLV_NETWORK_INITIATED_ALERT_SELECTION,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SEND_SELECTION_INPUT_TLV_NETWORK_INITIATED_ALERT_SELECTION:
            g_prefix_error (error, "Couldn't set the Network Initiated Alert Selection TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    }

    return self;
}

/* --- Output -- */

struct _QmiMessageOmaSendSelectionOutput {
    volatile gint ref_count;

    /* Result */
    gboolean arg_result_set;
    QmiMessageResult arg_result;
};

#define QMI_MESSAGE_OMA_SEND_SELECTION_OUTPUT_TLV_RESULT 0x02

/**
 * qmi_message_oma_send_selection_output_get_result:
 * @self: a QmiMessageOmaSendSelectionOutput.
 * @error: Return location for error or %NULL.
 *
 * Get the result of the QMI operation.
 *
 * Returns: %TRUE if the QMI operation succeeded, %FALSE if @error is set.
 */
gboolean
qmi_message_oma_send_selection_output_get_result (
    QmiMessageOmaSendSelectionOutput *self,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    /* We should always have a result set in the response message */
    if (!self->arg_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_MESSAGE,
                     "No 'Result' field given in the message");
        return FALSE;
    }

    if (self->arg_result.error_status == QMI_STATUS_SUCCESS) {
        /* Operation succeeded */
        return TRUE;
    }

    /* Report a QMI protocol error */
    g_set_error (error,
                 QMI_PROTOCOL_ERROR,
                 (QmiProtocolError) self->arg_result.error_code,
                 "QMI protocol error (%u): '%s'",
                 self->arg_result.error_code,
                 qmi_protocol_error_get_string ((QmiProtocolError) self->arg_result.error_code));
    return FALSE;
}

GType
qmi_message_oma_send_selection_output_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageOmaSendSelectionOutput"),
                                          (GBoxedCopyFunc) qmi_message_oma_send_selection_output_ref,
                                          (GBoxedFreeFunc) qmi_message_oma_send_selection_output_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_oma_send_selection_output_ref:
 * @self: a #QmiMessageOmaSendSelectionOutput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageOmaSendSelectionOutput *
qmi_message_oma_send_selection_output_ref (QmiMessageOmaSendSelectionOutput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_oma_send_selection_output_unref:
 * @self: a #QmiMessageOmaSendSelectionOutput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_oma_send_selection_output_unref (QmiMessageOmaSendSelectionOutput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessageOmaSendSelectionOutput, self);
    }
}

static gboolean
qmi_message_oma_send_selection_input_network_initiated_alert_selection_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;
    expected_len += 2;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Network Initiated Alert Selection' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Network Initiated Alert Selection' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_oma_send_selection_input_network_initiated_alert_selection_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_OMA_SEND_SELECTION_INPUT_TLV_NETWORK_INITIATED_ALERT_SELECTION,
                                      &buffer_len);
    if (buffer && qmi_message_oma_send_selection_input_network_initiated_alert_selection_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " control_point_selection_accept = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%s", tmp ? "yes" : "no");
        }
        g_string_append (printable, "'");
        g_string_append (printable, " session_id = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Network Initiated Alert Selection' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

struct message_send_selection_context {
    QmiMessage *self;
    const gchar *line_prefix;
    GString *printable;
};

static void
message_send_selection_get_tlv_printable (
    guint8 type,
    const guint8 *value,
    gsize length,
    struct message_send_selection_context *ctx)
{
    const gchar *tlv_type_str = NULL;
    gchar *translated_value;

    if (!qmi_message_is_response (ctx->self)) {
        switch (type) {
        case QMI_MESSAGE_OMA_SEND_SELECTION_INPUT_TLV_NETWORK_INITIATED_ALERT_SELECTION:
            tlv_type_str = "Network Initiated Alert Selection";
            translated_value = qmi_message_oma_send_selection_input_network_initiated_alert_selection_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    } else {
        switch (type) {
        case QMI_MESSAGE_OMA_SEND_SELECTION_OUTPUT_TLV_RESULT:
            tlv_type_str = "Result";
            translated_value = qmi_message_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    }

    if (!tlv_type_str) {
        gchar *value_str = NULL;

        value_str = qmi_message_get_tlv_printable (ctx->self,
                                                   ctx->line_prefix,
                                                   type,
                                                   value,
                                                   length);
        g_string_append (ctx->printable, value_str);
        g_free (value_str);
    } else {
        gchar *value_hex;

        value_hex = __qmi_utils_str_hex (value, length, ':');
        g_string_append_printf (ctx->printable,
                                "%sTLV:\n"
                                "%s  type       = \"%s\" (0x%02x)\n"
                                "%s  length     = %" G_GSIZE_FORMAT "\n"
                                "%s  value      = %s\n"
                                "%s  translated = %s\n",
                                ctx->line_prefix,
                                ctx->line_prefix, tlv_type_str, type,
                                ctx->line_prefix, length,
                                ctx->line_prefix, value_hex,
                                ctx->line_prefix, translated_value ? translated_value : "");
        g_free (value_hex);
        g_free (translated_value);
    }
}

static gchar *
message_send_selection_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    GString *printable;

    printable = g_string_new ("");
    g_string_append_printf (printable,
                            "%s  message     = \"Send Selection\" (0x0023)\n",
                            line_prefix);

    {
        struct message_send_selection_context ctx;
        ctx.self = self;
        ctx.line_prefix = line_prefix;
        ctx.printable = printable;
        qmi_message_foreach_raw_tlv (self,
                                     (QmiMessageForeachRawTlvFn)message_send_selection_get_tlv_printable,
                                     &ctx);
    }

    return g_string_free (printable, FALSE);
}

static QmiMessageOmaSendSelectionOutput *
__qmi_message_oma_send_selection_response_parse (
    QmiMessage *message,
    GError **error)
{
    QmiMessageOmaSendSelectionOutput *self;

    g_return_val_if_fail (qmi_message_get_message_id (message) == QMI_MESSAGE_OMA_SEND_SELECTION, NULL);

    self = g_slice_new0 (QmiMessageOmaSendSelectionOutput);
    self->ref_count = 1;

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_OMA_SEND_SELECTION_OUTPUT_TLV_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_result_validate (buffer, buffer_len)) {
                self->arg_result_set = TRUE;

                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_status));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_code));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Result' TLV", buffer_len);
                }
            } else {
                g_set_error (error,
                             QMI_CORE_ERROR,
                             QMI_CORE_ERROR_TLV_NOT_FOUND,
                             "Couldn't get the Result TLV: Not found");
                qmi_message_oma_send_selection_output_unref (self);
                return NULL;
            }

        }
    } while (0);

    return self;
}

/*****************************************************************************/
/* REQUEST/RESPONSE: Qmi Message OMA Get Feature Setting */


/* --- Input -- */

/* Note: no fields in the Input container */

static QmiMessage *
__qmi_message_oma_get_feature_setting_request_create (
    guint8 transaction_id,
    guint8 cid,
    gpointer unused,
    GError **error)
{
    QmiMessage *self;

    self = qmi_message_new (QMI_SERVICE_OMA,
                            cid,
                            transaction_id,
                            QMI_MESSAGE_OMA_GET_FEATURE_SETTING);

    return self;
}

/* --- Output -- */

struct _QmiMessageOmaGetFeatureSettingOutput {
    volatile gint ref_count;

    /* Result */
    gboolean arg_result_set;
    QmiMessageResult arg_result;

    /* Device Provisioning Service Update Config */
    gboolean arg_device_provisioning_service_update_config_set;
    guint8 arg_device_provisioning_service_update_config;

    /* PRL Update Service Config */
    gboolean arg_prl_update_service_config_set;
    guint8 arg_prl_update_service_config;

    /* HFA Feature Config */
    gboolean arg_hfa_feature_config_set;
    guint8 arg_hfa_feature_config;

    /* HFA Feature Done State */
    gboolean arg_hfa_feature_done_state_set;
    guint8 arg_hfa_feature_done_state;
};

#define QMI_MESSAGE_OMA_GET_FEATURE_SETTING_OUTPUT_TLV_RESULT 0x02
#define QMI_MESSAGE_OMA_GET_FEATURE_SETTING_OUTPUT_TLV_DEVICE_PROVISIONING_SERVICE_UPDATE_CONFIG 0x10
#define QMI_MESSAGE_OMA_GET_FEATURE_SETTING_OUTPUT_TLV_PRL_UPDATE_SERVICE_CONFIG 0x11
#define QMI_MESSAGE_OMA_GET_FEATURE_SETTING_OUTPUT_TLV_HFA_FEATURE_CONFIG 0x12
#define QMI_MESSAGE_OMA_GET_FEATURE_SETTING_OUTPUT_TLV_HFA_FEATURE_DONE_STATE 0x13

/**
 * qmi_message_oma_get_feature_setting_output_get_result:
 * @self: a QmiMessageOmaGetFeatureSettingOutput.
 * @error: Return location for error or %NULL.
 *
 * Get the result of the QMI operation.
 *
 * Returns: %TRUE if the QMI operation succeeded, %FALSE if @error is set.
 */
gboolean
qmi_message_oma_get_feature_setting_output_get_result (
    QmiMessageOmaGetFeatureSettingOutput *self,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    /* We should always have a result set in the response message */
    if (!self->arg_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_MESSAGE,
                     "No 'Result' field given in the message");
        return FALSE;
    }

    if (self->arg_result.error_status == QMI_STATUS_SUCCESS) {
        /* Operation succeeded */
        return TRUE;
    }

    /* Report a QMI protocol error */
    g_set_error (error,
                 QMI_PROTOCOL_ERROR,
                 (QmiProtocolError) self->arg_result.error_code,
                 "QMI protocol error (%u): '%s'",
                 self->arg_result.error_code,
                 qmi_protocol_error_get_string ((QmiProtocolError) self->arg_result.error_code));
    return FALSE;
}

/**
 * qmi_message_oma_get_feature_setting_output_get_device_provisioning_service_update_config:
 * @self: a #QmiMessageOmaGetFeatureSettingOutput.
 * @device_provisioning_service_update_config: a placeholder for the output #gboolean, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Device Provisioning Service Update Config' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_oma_get_feature_setting_output_get_device_provisioning_service_update_config (
    QmiMessageOmaGetFeatureSettingOutput *self,
    gboolean *device_provisioning_service_update_config,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_device_provisioning_service_update_config_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Device Provisioning Service Update Config' was not found in the message");
        return FALSE;
    }

    if (device_provisioning_service_update_config)
        *device_provisioning_service_update_config = (gboolean)(self->arg_device_provisioning_service_update_config);

    return TRUE;
}

/**
 * qmi_message_oma_get_feature_setting_output_get_prl_update_service_config:
 * @self: a #QmiMessageOmaGetFeatureSettingOutput.
 * @prl_update_service_config: a placeholder for the output #gboolean, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'PRL Update Service Config' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_oma_get_feature_setting_output_get_prl_update_service_config (
    QmiMessageOmaGetFeatureSettingOutput *self,
    gboolean *prl_update_service_config,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_prl_update_service_config_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'PRL Update Service Config' was not found in the message");
        return FALSE;
    }

    if (prl_update_service_config)
        *prl_update_service_config = (gboolean)(self->arg_prl_update_service_config);

    return TRUE;
}

/**
 * qmi_message_oma_get_feature_setting_output_get_hfa_feature_config:
 * @self: a #QmiMessageOmaGetFeatureSettingOutput.
 * @hfa_feature_config: a placeholder for the output #gboolean, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'HFA Feature Config' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_oma_get_feature_setting_output_get_hfa_feature_config (
    QmiMessageOmaGetFeatureSettingOutput *self,
    gboolean *hfa_feature_config,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_hfa_feature_config_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'HFA Feature Config' was not found in the message");
        return FALSE;
    }

    if (hfa_feature_config)
        *hfa_feature_config = (gboolean)(self->arg_hfa_feature_config);

    return TRUE;
}

/**
 * qmi_message_oma_get_feature_setting_output_get_hfa_feature_done_state:
 * @self: a #QmiMessageOmaGetFeatureSettingOutput.
 * @hfa_feature_done_state: a placeholder for the output #QmiOmaHfaFeatureDoneState, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'HFA Feature Done State' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_oma_get_feature_setting_output_get_hfa_feature_done_state (
    QmiMessageOmaGetFeatureSettingOutput *self,
    QmiOmaHfaFeatureDoneState *hfa_feature_done_state,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_hfa_feature_done_state_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'HFA Feature Done State' was not found in the message");
        return FALSE;
    }

    if (hfa_feature_done_state)
        *hfa_feature_done_state = (QmiOmaHfaFeatureDoneState)(self->arg_hfa_feature_done_state);

    return TRUE;
}

GType
qmi_message_oma_get_feature_setting_output_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageOmaGetFeatureSettingOutput"),
                                          (GBoxedCopyFunc) qmi_message_oma_get_feature_setting_output_ref,
                                          (GBoxedFreeFunc) qmi_message_oma_get_feature_setting_output_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_oma_get_feature_setting_output_ref:
 * @self: a #QmiMessageOmaGetFeatureSettingOutput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageOmaGetFeatureSettingOutput *
qmi_message_oma_get_feature_setting_output_ref (QmiMessageOmaGetFeatureSettingOutput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_oma_get_feature_setting_output_unref:
 * @self: a #QmiMessageOmaGetFeatureSettingOutput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_oma_get_feature_setting_output_unref (QmiMessageOmaGetFeatureSettingOutput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessageOmaGetFeatureSettingOutput, self);
    }
}

static gboolean
qmi_message_oma_get_feature_setting_output_device_provisioning_service_update_config_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Device Provisioning Service Update Config' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Device Provisioning Service Update Config' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_oma_get_feature_setting_output_device_provisioning_service_update_config_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_OMA_GET_FEATURE_SETTING_OUTPUT_TLV_DEVICE_PROVISIONING_SERVICE_UPDATE_CONFIG,
                                      &buffer_len);
    if (buffer && qmi_message_oma_get_feature_setting_output_device_provisioning_service_update_config_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%s", tmp ? "yes" : "no");
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Device Provisioning Service Update Config' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_oma_get_feature_setting_output_prl_update_service_config_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'PRL Update Service Config' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'PRL Update Service Config' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_oma_get_feature_setting_output_prl_update_service_config_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_OMA_GET_FEATURE_SETTING_OUTPUT_TLV_PRL_UPDATE_SERVICE_CONFIG,
                                      &buffer_len);
    if (buffer && qmi_message_oma_get_feature_setting_output_prl_update_service_config_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%s", tmp ? "yes" : "no");
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'PRL Update Service Config' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_oma_get_feature_setting_output_hfa_feature_config_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'HFA Feature Config' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'HFA Feature Config' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_oma_get_feature_setting_output_hfa_feature_config_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_OMA_GET_FEATURE_SETTING_OUTPUT_TLV_HFA_FEATURE_CONFIG,
                                      &buffer_len);
    if (buffer && qmi_message_oma_get_feature_setting_output_hfa_feature_config_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%s", tmp ? "yes" : "no");
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'HFA Feature Config' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_oma_get_feature_setting_output_hfa_feature_done_state_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'HFA Feature Done State' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'HFA Feature Done State' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_oma_get_feature_setting_output_hfa_feature_done_state_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_OMA_GET_FEATURE_SETTING_OUTPUT_TLV_HFA_FEATURE_DONE_STATE,
                                      &buffer_len);
    if (buffer && qmi_message_oma_get_feature_setting_output_hfa_feature_done_state_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_OMA_HFA_FEATURE_DONE_STATE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_oma_hfa_feature_done_state_get_string ((QmiOmaHfaFeatureDoneState)tmp));
#elif defined  __QMI_OMA_HFA_FEATURE_DONE_STATE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_oma_hfa_feature_done_state_build_string_from_mask ((QmiOmaHfaFeatureDoneState)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiOmaHfaFeatureDoneState
#endif
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'HFA Feature Done State' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

struct message_get_feature_setting_context {
    QmiMessage *self;
    const gchar *line_prefix;
    GString *printable;
};

static void
message_get_feature_setting_get_tlv_printable (
    guint8 type,
    const guint8 *value,
    gsize length,
    struct message_get_feature_setting_context *ctx)
{
    const gchar *tlv_type_str = NULL;
    gchar *translated_value;

    if (!qmi_message_is_response (ctx->self)) {
        switch (type) {
        default:
            break;
        }
    } else {
        switch (type) {
        case QMI_MESSAGE_OMA_GET_FEATURE_SETTING_OUTPUT_TLV_RESULT:
            tlv_type_str = "Result";
            translated_value = qmi_message_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_OMA_GET_FEATURE_SETTING_OUTPUT_TLV_DEVICE_PROVISIONING_SERVICE_UPDATE_CONFIG:
            tlv_type_str = "Device Provisioning Service Update Config";
            translated_value = qmi_message_oma_get_feature_setting_output_device_provisioning_service_update_config_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_OMA_GET_FEATURE_SETTING_OUTPUT_TLV_PRL_UPDATE_SERVICE_CONFIG:
            tlv_type_str = "PRL Update Service Config";
            translated_value = qmi_message_oma_get_feature_setting_output_prl_update_service_config_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_OMA_GET_FEATURE_SETTING_OUTPUT_TLV_HFA_FEATURE_CONFIG:
            tlv_type_str = "HFA Feature Config";
            translated_value = qmi_message_oma_get_feature_setting_output_hfa_feature_config_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_OMA_GET_FEATURE_SETTING_OUTPUT_TLV_HFA_FEATURE_DONE_STATE:
            tlv_type_str = "HFA Feature Done State";
            translated_value = qmi_message_oma_get_feature_setting_output_hfa_feature_done_state_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    }

    if (!tlv_type_str) {
        gchar *value_str = NULL;

        value_str = qmi_message_get_tlv_printable (ctx->self,
                                                   ctx->line_prefix,
                                                   type,
                                                   value,
                                                   length);
        g_string_append (ctx->printable, value_str);
        g_free (value_str);
    } else {
        gchar *value_hex;

        value_hex = __qmi_utils_str_hex (value, length, ':');
        g_string_append_printf (ctx->printable,
                                "%sTLV:\n"
                                "%s  type       = \"%s\" (0x%02x)\n"
                                "%s  length     = %" G_GSIZE_FORMAT "\n"
                                "%s  value      = %s\n"
                                "%s  translated = %s\n",
                                ctx->line_prefix,
                                ctx->line_prefix, tlv_type_str, type,
                                ctx->line_prefix, length,
                                ctx->line_prefix, value_hex,
                                ctx->line_prefix, translated_value ? translated_value : "");
        g_free (value_hex);
        g_free (translated_value);
    }
}

static gchar *
message_get_feature_setting_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    GString *printable;

    printable = g_string_new ("");
    g_string_append_printf (printable,
                            "%s  message     = \"Get Feature Setting\" (0x0024)\n",
                            line_prefix);

    {
        struct message_get_feature_setting_context ctx;
        ctx.self = self;
        ctx.line_prefix = line_prefix;
        ctx.printable = printable;
        qmi_message_foreach_raw_tlv (self,
                                     (QmiMessageForeachRawTlvFn)message_get_feature_setting_get_tlv_printable,
                                     &ctx);
    }

    return g_string_free (printable, FALSE);
}

static QmiMessageOmaGetFeatureSettingOutput *
__qmi_message_oma_get_feature_setting_response_parse (
    QmiMessage *message,
    GError **error)
{
    QmiMessageOmaGetFeatureSettingOutput *self;

    g_return_val_if_fail (qmi_message_get_message_id (message) == QMI_MESSAGE_OMA_GET_FEATURE_SETTING, NULL);

    self = g_slice_new0 (QmiMessageOmaGetFeatureSettingOutput);
    self->ref_count = 1;

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_OMA_GET_FEATURE_SETTING_OUTPUT_TLV_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_result_validate (buffer, buffer_len)) {
                self->arg_result_set = TRUE;

                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_status));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_code));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Result' TLV", buffer_len);
                }
            } else {
                g_set_error (error,
                             QMI_CORE_ERROR,
                             QMI_CORE_ERROR_TLV_NOT_FOUND,
                             "Couldn't get the Result TLV: Not found");
                qmi_message_oma_get_feature_setting_output_unref (self);
                return NULL;
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_OMA_GET_FEATURE_SETTING_OUTPUT_TLV_DEVICE_PROVISIONING_SERVICE_UPDATE_CONFIG,
                                              &buffer_len);
            if (buffer && qmi_message_oma_get_feature_setting_output_device_provisioning_service_update_config_validate (buffer, buffer_len)) {
                self->arg_device_provisioning_service_update_config_set = TRUE;

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_device_provisioning_service_update_config = (gboolean)tmp;
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Device Provisioning Service Update Config' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_OMA_GET_FEATURE_SETTING_OUTPUT_TLV_PRL_UPDATE_SERVICE_CONFIG,
                                              &buffer_len);
            if (buffer && qmi_message_oma_get_feature_setting_output_prl_update_service_config_validate (buffer, buffer_len)) {
                self->arg_prl_update_service_config_set = TRUE;

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_prl_update_service_config = (gboolean)tmp;
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'PRL Update Service Config' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_OMA_GET_FEATURE_SETTING_OUTPUT_TLV_HFA_FEATURE_CONFIG,
                                              &buffer_len);
            if (buffer && qmi_message_oma_get_feature_setting_output_hfa_feature_config_validate (buffer, buffer_len)) {
                self->arg_hfa_feature_config_set = TRUE;

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_hfa_feature_config = (gboolean)tmp;
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'HFA Feature Config' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_OMA_GET_FEATURE_SETTING_OUTPUT_TLV_HFA_FEATURE_DONE_STATE,
                                              &buffer_len);
            if (buffer && qmi_message_oma_get_feature_setting_output_hfa_feature_done_state_validate (buffer, buffer_len)) {
                self->arg_hfa_feature_done_state_set = TRUE;

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_hfa_feature_done_state = (QmiOmaHfaFeatureDoneState)tmp;
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'HFA Feature Done State' TLV", buffer_len);
                }
            }

        }
    } while (0);

    return self;
}

/*****************************************************************************/
/* REQUEST/RESPONSE: Qmi Message OMA Set Feature Setting */


/* --- Input -- */

struct _QmiMessageOmaSetFeatureSettingInput {
    volatile gint ref_count;

    /* HFA Feature Config */
    gboolean arg_hfa_feature_config_set;
    guint8 arg_hfa_feature_config;

    /* PRL Update Service Config */
    gboolean arg_prl_update_service_config_set;
    guint8 arg_prl_update_service_config;

    /* Device Provisioning Service Update Config */
    gboolean arg_device_provisioning_service_update_config_set;
    guint8 arg_device_provisioning_service_update_config;
};

#define QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_HFA_FEATURE_CONFIG 0x12
#define QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_PRL_UPDATE_SERVICE_CONFIG 0x11
#define QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_DEVICE_PROVISIONING_SERVICE_UPDATE_CONFIG 0x10

/**
 * qmi_message_oma_set_feature_setting_input_get_hfa_feature_config:
 * @self: a #QmiMessageOmaSetFeatureSettingInput.
 * @hfa_feature_config: a placeholder for the output #gboolean, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'HFA Feature Config' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_oma_set_feature_setting_input_get_hfa_feature_config (
    QmiMessageOmaSetFeatureSettingInput *self,
    gboolean *hfa_feature_config,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_hfa_feature_config_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'HFA Feature Config' was not found in the message");
        return FALSE;
    }

    if (hfa_feature_config)
        *hfa_feature_config = (gboolean)(self->arg_hfa_feature_config);

    return TRUE;
}

/**
 * qmi_message_oma_set_feature_setting_input_set_hfa_feature_config:
 * @self: a #QmiMessageOmaSetFeatureSettingInput.
 * @hfa_feature_config: a #gboolean.
 * @error: Return location for error or %NULL.
 *
 * Set the 'HFA Feature Config' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_oma_set_feature_setting_input_set_hfa_feature_config (
    QmiMessageOmaSetFeatureSettingInput *self,
    gboolean hfa_feature_config,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_hfa_feature_config = (guint8)(hfa_feature_config);
    self->arg_hfa_feature_config_set = TRUE;

    return TRUE;
}

/**
 * qmi_message_oma_set_feature_setting_input_get_prl_update_service_config:
 * @self: a #QmiMessageOmaSetFeatureSettingInput.
 * @prl_update_service_config: a placeholder for the output #gboolean, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'PRL Update Service Config' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_oma_set_feature_setting_input_get_prl_update_service_config (
    QmiMessageOmaSetFeatureSettingInput *self,
    gboolean *prl_update_service_config,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_prl_update_service_config_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'PRL Update Service Config' was not found in the message");
        return FALSE;
    }

    if (prl_update_service_config)
        *prl_update_service_config = (gboolean)(self->arg_prl_update_service_config);

    return TRUE;
}

/**
 * qmi_message_oma_set_feature_setting_input_set_prl_update_service_config:
 * @self: a #QmiMessageOmaSetFeatureSettingInput.
 * @prl_update_service_config: a #gboolean.
 * @error: Return location for error or %NULL.
 *
 * Set the 'PRL Update Service Config' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_oma_set_feature_setting_input_set_prl_update_service_config (
    QmiMessageOmaSetFeatureSettingInput *self,
    gboolean prl_update_service_config,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_prl_update_service_config = (guint8)(prl_update_service_config);
    self->arg_prl_update_service_config_set = TRUE;

    return TRUE;
}

/**
 * qmi_message_oma_set_feature_setting_input_get_device_provisioning_service_update_config:
 * @self: a #QmiMessageOmaSetFeatureSettingInput.
 * @device_provisioning_service_update_config: a placeholder for the output #gboolean, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Device Provisioning Service Update Config' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_oma_set_feature_setting_input_get_device_provisioning_service_update_config (
    QmiMessageOmaSetFeatureSettingInput *self,
    gboolean *device_provisioning_service_update_config,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_device_provisioning_service_update_config_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Device Provisioning Service Update Config' was not found in the message");
        return FALSE;
    }

    if (device_provisioning_service_update_config)
        *device_provisioning_service_update_config = (gboolean)(self->arg_device_provisioning_service_update_config);

    return TRUE;
}

/**
 * qmi_message_oma_set_feature_setting_input_set_device_provisioning_service_update_config:
 * @self: a #QmiMessageOmaSetFeatureSettingInput.
 * @device_provisioning_service_update_config: a #gboolean.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Device Provisioning Service Update Config' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_oma_set_feature_setting_input_set_device_provisioning_service_update_config (
    QmiMessageOmaSetFeatureSettingInput *self,
    gboolean device_provisioning_service_update_config,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_device_provisioning_service_update_config = (guint8)(device_provisioning_service_update_config);
    self->arg_device_provisioning_service_update_config_set = TRUE;

    return TRUE;
}

GType
qmi_message_oma_set_feature_setting_input_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageOmaSetFeatureSettingInput"),
                                          (GBoxedCopyFunc) qmi_message_oma_set_feature_setting_input_ref,
                                          (GBoxedFreeFunc) qmi_message_oma_set_feature_setting_input_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_oma_set_feature_setting_input_ref:
 * @self: a #QmiMessageOmaSetFeatureSettingInput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageOmaSetFeatureSettingInput *
qmi_message_oma_set_feature_setting_input_ref (QmiMessageOmaSetFeatureSettingInput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_oma_set_feature_setting_input_unref:
 * @self: a #QmiMessageOmaSetFeatureSettingInput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_oma_set_feature_setting_input_unref (QmiMessageOmaSetFeatureSettingInput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessageOmaSetFeatureSettingInput, self);
    }
}

/**
 * qmi_message_oma_set_feature_setting_input_new:
 *
 * Allocates a new #QmiMessageOmaSetFeatureSettingInput.
 *
 * Returns: the newly created #QmiMessageOmaSetFeatureSettingInput. The returned value should be freed with qmi_message_oma_set_feature_setting_input_unref().
 */
QmiMessageOmaSetFeatureSettingInput *
qmi_message_oma_set_feature_setting_input_new (void)
{
    QmiMessageOmaSetFeatureSettingInput *self;

    self = g_slice_new0 (QmiMessageOmaSetFeatureSettingInput);
    self->ref_count = 1;
    return self;
}

static QmiMessage *
__qmi_message_oma_set_feature_setting_request_create (
    guint8 transaction_id,
    guint8 cid,
    QmiMessageOmaSetFeatureSettingInput *input,
    GError **error)
{
    QmiMessage *self;

    self = qmi_message_new (QMI_SERVICE_OMA,
                            cid,
                            transaction_id,
                            QMI_MESSAGE_OMA_SET_FEATURE_SETTING);

    /* All TLVs are optional, we allow NULL input */
    if (!input)
        return self;

    /* Try to add the 'HFA Feature Config' TLV */
    if (input->arg_hfa_feature_config_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        if (buffer_len < 1)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_HFA_FEATURE_CONFIG;
        else {
            guint8 tmp;

            tmp = (guint8)input->arg_hfa_feature_config;
            /* Write the guint8 variable to the buffer */
            qmi_utils_write_guint8_to_buffer (
                &buffer_aux,
                &buffer_len,
                &tmp);
        }

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_HFA_FEATURE_CONFIG:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_HFA_FEATURE_CONFIG;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_HFA_FEATURE_CONFIG,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_HFA_FEATURE_CONFIG:
            g_prefix_error (error, "Couldn't set the HFA Feature Config TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    }

    /* Try to add the 'PRL Update Service Config' TLV */
    if (input->arg_prl_update_service_config_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        if (buffer_len < 1)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_PRL_UPDATE_SERVICE_CONFIG;
        else {
            guint8 tmp;

            tmp = (guint8)input->arg_prl_update_service_config;
            /* Write the guint8 variable to the buffer */
            qmi_utils_write_guint8_to_buffer (
                &buffer_aux,
                &buffer_len,
                &tmp);
        }

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_PRL_UPDATE_SERVICE_CONFIG:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_PRL_UPDATE_SERVICE_CONFIG;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_PRL_UPDATE_SERVICE_CONFIG,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_PRL_UPDATE_SERVICE_CONFIG:
            g_prefix_error (error, "Couldn't set the PRL Update Service Config TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    }

    /* Try to add the 'Device Provisioning Service Update Config' TLV */
    if (input->arg_device_provisioning_service_update_config_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        if (buffer_len < 1)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_DEVICE_PROVISIONING_SERVICE_UPDATE_CONFIG;
        else {
            guint8 tmp;

            tmp = (guint8)input->arg_device_provisioning_service_update_config;
            /* Write the guint8 variable to the buffer */
            qmi_utils_write_guint8_to_buffer (
                &buffer_aux,
                &buffer_len,
                &tmp);
        }

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_DEVICE_PROVISIONING_SERVICE_UPDATE_CONFIG:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_DEVICE_PROVISIONING_SERVICE_UPDATE_CONFIG;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_DEVICE_PROVISIONING_SERVICE_UPDATE_CONFIG,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_DEVICE_PROVISIONING_SERVICE_UPDATE_CONFIG:
            g_prefix_error (error, "Couldn't set the Device Provisioning Service Update Config TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    }

    return self;
}

/* --- Output -- */

struct _QmiMessageOmaSetFeatureSettingOutput {
    volatile gint ref_count;

    /* Result */
    gboolean arg_result_set;
    QmiMessageResult arg_result;
};

#define QMI_MESSAGE_OMA_SET_FEATURE_SETTING_OUTPUT_TLV_RESULT 0x02

/**
 * qmi_message_oma_set_feature_setting_output_get_result:
 * @self: a QmiMessageOmaSetFeatureSettingOutput.
 * @error: Return location for error or %NULL.
 *
 * Get the result of the QMI operation.
 *
 * Returns: %TRUE if the QMI operation succeeded, %FALSE if @error is set.
 */
gboolean
qmi_message_oma_set_feature_setting_output_get_result (
    QmiMessageOmaSetFeatureSettingOutput *self,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    /* We should always have a result set in the response message */
    if (!self->arg_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_MESSAGE,
                     "No 'Result' field given in the message");
        return FALSE;
    }

    if (self->arg_result.error_status == QMI_STATUS_SUCCESS) {
        /* Operation succeeded */
        return TRUE;
    }

    /* Report a QMI protocol error */
    g_set_error (error,
                 QMI_PROTOCOL_ERROR,
                 (QmiProtocolError) self->arg_result.error_code,
                 "QMI protocol error (%u): '%s'",
                 self->arg_result.error_code,
                 qmi_protocol_error_get_string ((QmiProtocolError) self->arg_result.error_code));
    return FALSE;
}

GType
qmi_message_oma_set_feature_setting_output_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageOmaSetFeatureSettingOutput"),
                                          (GBoxedCopyFunc) qmi_message_oma_set_feature_setting_output_ref,
                                          (GBoxedFreeFunc) qmi_message_oma_set_feature_setting_output_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_oma_set_feature_setting_output_ref:
 * @self: a #QmiMessageOmaSetFeatureSettingOutput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageOmaSetFeatureSettingOutput *
qmi_message_oma_set_feature_setting_output_ref (QmiMessageOmaSetFeatureSettingOutput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_oma_set_feature_setting_output_unref:
 * @self: a #QmiMessageOmaSetFeatureSettingOutput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_oma_set_feature_setting_output_unref (QmiMessageOmaSetFeatureSettingOutput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessageOmaSetFeatureSettingOutput, self);
    }
}

static gboolean
qmi_message_oma_set_feature_setting_input_hfa_feature_config_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'HFA Feature Config' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'HFA Feature Config' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_oma_set_feature_setting_input_hfa_feature_config_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_HFA_FEATURE_CONFIG,
                                      &buffer_len);
    if (buffer && qmi_message_oma_set_feature_setting_input_hfa_feature_config_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%s", tmp ? "yes" : "no");
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'HFA Feature Config' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_oma_set_feature_setting_input_prl_update_service_config_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'PRL Update Service Config' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'PRL Update Service Config' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_oma_set_feature_setting_input_prl_update_service_config_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_PRL_UPDATE_SERVICE_CONFIG,
                                      &buffer_len);
    if (buffer && qmi_message_oma_set_feature_setting_input_prl_update_service_config_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%s", tmp ? "yes" : "no");
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'PRL Update Service Config' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_oma_set_feature_setting_input_device_provisioning_service_update_config_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Device Provisioning Service Update Config' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Device Provisioning Service Update Config' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_oma_set_feature_setting_input_device_provisioning_service_update_config_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_DEVICE_PROVISIONING_SERVICE_UPDATE_CONFIG,
                                      &buffer_len);
    if (buffer && qmi_message_oma_set_feature_setting_input_device_provisioning_service_update_config_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%s", tmp ? "yes" : "no");
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Device Provisioning Service Update Config' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

struct message_set_feature_setting_context {
    QmiMessage *self;
    const gchar *line_prefix;
    GString *printable;
};

static void
message_set_feature_setting_get_tlv_printable (
    guint8 type,
    const guint8 *value,
    gsize length,
    struct message_set_feature_setting_context *ctx)
{
    const gchar *tlv_type_str = NULL;
    gchar *translated_value;

    if (!qmi_message_is_response (ctx->self)) {
        switch (type) {
        case QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_HFA_FEATURE_CONFIG:
            tlv_type_str = "HFA Feature Config";
            translated_value = qmi_message_oma_set_feature_setting_input_hfa_feature_config_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_PRL_UPDATE_SERVICE_CONFIG:
            tlv_type_str = "PRL Update Service Config";
            translated_value = qmi_message_oma_set_feature_setting_input_prl_update_service_config_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_OMA_SET_FEATURE_SETTING_INPUT_TLV_DEVICE_PROVISIONING_SERVICE_UPDATE_CONFIG:
            tlv_type_str = "Device Provisioning Service Update Config";
            translated_value = qmi_message_oma_set_feature_setting_input_device_provisioning_service_update_config_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    } else {
        switch (type) {
        case QMI_MESSAGE_OMA_SET_FEATURE_SETTING_OUTPUT_TLV_RESULT:
            tlv_type_str = "Result";
            translated_value = qmi_message_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    }

    if (!tlv_type_str) {
        gchar *value_str = NULL;

        value_str = qmi_message_get_tlv_printable (ctx->self,
                                                   ctx->line_prefix,
                                                   type,
                                                   value,
                                                   length);
        g_string_append (ctx->printable, value_str);
        g_free (value_str);
    } else {
        gchar *value_hex;

        value_hex = __qmi_utils_str_hex (value, length, ':');
        g_string_append_printf (ctx->printable,
                                "%sTLV:\n"
                                "%s  type       = \"%s\" (0x%02x)\n"
                                "%s  length     = %" G_GSIZE_FORMAT "\n"
                                "%s  value      = %s\n"
                                "%s  translated = %s\n",
                                ctx->line_prefix,
                                ctx->line_prefix, tlv_type_str, type,
                                ctx->line_prefix, length,
                                ctx->line_prefix, value_hex,
                                ctx->line_prefix, translated_value ? translated_value : "");
        g_free (value_hex);
        g_free (translated_value);
    }
}

static gchar *
message_set_feature_setting_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    GString *printable;

    printable = g_string_new ("");
    g_string_append_printf (printable,
                            "%s  message     = \"Set Feature Setting\" (0x0025)\n",
                            line_prefix);

    {
        struct message_set_feature_setting_context ctx;
        ctx.self = self;
        ctx.line_prefix = line_prefix;
        ctx.printable = printable;
        qmi_message_foreach_raw_tlv (self,
                                     (QmiMessageForeachRawTlvFn)message_set_feature_setting_get_tlv_printable,
                                     &ctx);
    }

    return g_string_free (printable, FALSE);
}

static QmiMessageOmaSetFeatureSettingOutput *
__qmi_message_oma_set_feature_setting_response_parse (
    QmiMessage *message,
    GError **error)
{
    QmiMessageOmaSetFeatureSettingOutput *self;

    g_return_val_if_fail (qmi_message_get_message_id (message) == QMI_MESSAGE_OMA_SET_FEATURE_SETTING, NULL);

    self = g_slice_new0 (QmiMessageOmaSetFeatureSettingOutput);
    self->ref_count = 1;

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_OMA_SET_FEATURE_SETTING_OUTPUT_TLV_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_result_validate (buffer, buffer_len)) {
                self->arg_result_set = TRUE;

                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_status));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_code));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Result' TLV", buffer_len);
                }
            } else {
                g_set_error (error,
                             QMI_CORE_ERROR,
                             QMI_CORE_ERROR_TLV_NOT_FOUND,
                             "Couldn't get the Result TLV: Not found");
                qmi_message_oma_set_feature_setting_output_unref (self);
                return NULL;
            }

        }
    } while (0);

    return self;
}

/*****************************************************************************/
/* Service-specific printable: OMA */


gchar *
__qmi_message_oma_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    if (qmi_message_is_indication (self)) {
        switch (qmi_message_get_message_id (self)) {
        case QMI_INDICATION_OMA_EVENT_REPORT:
            return indication_event_report_get_printable (self, line_prefix);
         default:
             return NULL;
        }
    } else {
        switch (qmi_message_get_message_id (self)) {
        case QMI_MESSAGE_OMA_RESET:
            return message_reset_get_printable (self, line_prefix);
        case QMI_MESSAGE_OMA_SET_EVENT_REPORT:
            return message_set_event_report_get_printable (self, line_prefix);
        case QMI_MESSAGE_OMA_START_SESSION:
            return message_start_session_get_printable (self, line_prefix);
        case QMI_MESSAGE_OMA_CANCEL_SESSION:
            return message_cancel_session_get_printable (self, line_prefix);
        case QMI_MESSAGE_OMA_GET_SESSION_INFO:
            return message_get_session_info_get_printable (self, line_prefix);
        case QMI_MESSAGE_OMA_SEND_SELECTION:
            return message_send_selection_get_printable (self, line_prefix);
        case QMI_MESSAGE_OMA_GET_FEATURE_SETTING:
            return message_get_feature_setting_get_printable (self, line_prefix);
        case QMI_MESSAGE_OMA_SET_FEATURE_SETTING:
            return message_set_feature_setting_get_printable (self, line_prefix);
         default:
             return NULL;
        }
    }
}

gboolean
__qmi_message_oma_get_version_introduced (
    QmiMessage *self,
    guint *major,
    guint *minor)
{
    switch (qmi_message_get_message_id (self)) {
    case QMI_MESSAGE_OMA_RESET:
        *major = 1;
        *minor = 0;
        return TRUE;
    case QMI_MESSAGE_OMA_SET_EVENT_REPORT:
        *major = 1;
        *minor = 0;
        return TRUE;
    case QMI_MESSAGE_OMA_START_SESSION:
        *major = 1;
        *minor = 0;
        return TRUE;
    case QMI_MESSAGE_OMA_CANCEL_SESSION:
        *major = 1;
        *minor = 0;
        return TRUE;
    default:
        return FALSE;
    }
}

/*****************************************************************************/
/* CLIENT: QMI Client OMA */


/**
 * SECTION: qmi-client-oma
 * @title: QmiClientOma
 * @short_description: #QmiClient for the OMA service.
 *
 * #QmiClient which handles operations in the OMA service.
 */

G_DEFINE_TYPE (QmiClientOma, qmi_client_oma, QMI_TYPE_CLIENT);

enum {
    SIGNAL_EVENT_REPORT,
    SIGNAL_LAST
};

static guint signals[SIGNAL_LAST] = { 0 };

static void
process_indication (QmiClient *self,
                    QmiMessage *message)
{
    switch (qmi_message_get_message_id (message)) {
        case QMI_INDICATION_OMA_EVENT_REPORT: {
            QmiIndicationOmaEventReportOutput *output;
            GError *error = NULL;

            /* Parse indication */
            output = __qmi_indication_oma_event_report_indication_parse (message, &error);
            if (!output) {
                g_warning ("Couldn't parse 'Event Report' indication: %s",
                           error ? error->message : "Unknown error");
                if (error)
                    g_error_free (error);
            } else {
                g_signal_emit (self, signals[SIGNAL_EVENT_REPORT], 0, output);
                qmi_indication_oma_event_report_output_unref (output);
            }
            break;
        }
        default:
            break;
    }
}

static void
qmi_client_oma_init (QmiClientOma *self)
{
}

static void
qmi_client_oma_class_init (QmiClientOmaClass *klass)
{
    QmiClientClass *client_class = QMI_CLIENT_CLASS (klass);

    client_class->process_indication = process_indication;

    /**
     * QmiClientOma::event-report:
     * @object: A #QmiClientOma.
     * @output: A #QmiIndicationOmaEventReportOutput.
     *
     * The ::event-report signal gets emitted when a '<link linkend="libqmi-glib-OMA-Event-Report.top_of_page">Event Report</link>' indication is received.
     */
    signals[SIGNAL_EVENT_REPORT] =
        g_signal_new ("event-report",
                      G_OBJECT_CLASS_TYPE (G_OBJECT_CLASS (klass)),
                      G_SIGNAL_RUN_LAST,
                      0,
                      NULL,
                      NULL,
                      NULL,
                      G_TYPE_NONE,
                      1,
                      QMI_TYPE_INDICATION_OMA_EVENT_REPORT_OUTPUT);
}


/**
 * qmi_client_oma_reset_finish:
 * @self: a #QmiClientOma.
 * @res: the #GAsyncResult obtained from the #GAsyncReadyCallback passed to qmi_client_oma_reset().
 * @error: Return location for error or %NULL.
 *
 * Finishes an async operation started with qmi_client_oma_reset().
 *
 * Returns: a #QmiMessageOmaResetOutput, or %NULL if @error is set. The returned value should be freed with qmi_message_oma_reset_output_unref().
 */
QmiMessageOmaResetOutput *
qmi_client_oma_reset_finish (
    QmiClientOma *self,
    GAsyncResult *res,
    GError **error)
{
   if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (res), error))
       return NULL;

   return qmi_message_oma_reset_output_ref (g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (res)));
}

static void
reset_ready (
    QmiDevice *device,
    GAsyncResult *res,
    GSimpleAsyncResult *simple)
{
    GError *error = NULL;
    QmiMessage *reply;
    QmiMessageOmaResetOutput *output;

    reply = qmi_device_command_finish (device, res, &error);
    if (!reply) {
        g_simple_async_result_take_error (simple, error);
        g_simple_async_result_complete (simple);
        g_object_unref (simple);
        return;
    }

    /* Parse reply */
    output = __qmi_message_oma_reset_response_parse (reply, &error);
    if (!output)
        g_simple_async_result_take_error (simple, error);
    else
        g_simple_async_result_set_op_res_gpointer (simple,
                                                   output,
                                                   (GDestroyNotify)qmi_message_oma_reset_output_unref);
    g_simple_async_result_complete (simple);
    g_object_unref (simple);
    qmi_message_unref (reply);
}

/**
 * qmi_client_oma_reset:
 * @self: a #QmiClientOma.
 * @unused: %NULL. This message doesn't have any input bundle.
 * @timeout: maximum time to wait for the method to complete, in seconds.
 * @cancellable: a #GCancellable or %NULL.
 * @callback: a #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: user data to pass to @callback.
 *
 * Asynchronously sends a Reset request to the device.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from.
 *
 * You can then call qmi_client_oma_reset_finish() to get the result of the operation.
 */
void
qmi_client_oma_reset (
    QmiClientOma *self,
    gpointer unused,
    guint timeout,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
    GSimpleAsyncResult *result;
    QmiMessage *request;
    GError *error = NULL;
    guint16 transaction_id;

    result = g_simple_async_result_new (G_OBJECT (self),
                                        callback,
                                        user_data,
                                        qmi_client_oma_reset);

    transaction_id = qmi_client_get_next_transaction_id (QMI_CLIENT (self));

    request = __qmi_message_oma_reset_request_create (
                  transaction_id,
                  qmi_client_get_cid (QMI_CLIENT (self)),
                  NULL,
                  &error);
    if (!request) {
        g_prefix_error (&error, "Couldn't create request message: ");
        g_simple_async_result_take_error (result, error);
        g_simple_async_result_complete_in_idle (result);
        g_object_unref (result);
        return;
    }

    qmi_device_command (QMI_DEVICE (qmi_client_peek_device (QMI_CLIENT (self))),
                        request,
                        timeout,
                        cancellable,
                        (GAsyncReadyCallback)reset_ready,
                        result);
    qmi_message_unref (request);
}


/**
 * qmi_client_oma_set_event_report_finish:
 * @self: a #QmiClientOma.
 * @res: the #GAsyncResult obtained from the #GAsyncReadyCallback passed to qmi_client_oma_set_event_report().
 * @error: Return location for error or %NULL.
 *
 * Finishes an async operation started with qmi_client_oma_set_event_report().
 *
 * Returns: a #QmiMessageOmaSetEventReportOutput, or %NULL if @error is set. The returned value should be freed with qmi_message_oma_set_event_report_output_unref().
 */
QmiMessageOmaSetEventReportOutput *
qmi_client_oma_set_event_report_finish (
    QmiClientOma *self,
    GAsyncResult *res,
    GError **error)
{
   if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (res), error))
       return NULL;

   return qmi_message_oma_set_event_report_output_ref (g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (res)));
}

static void
set_event_report_ready (
    QmiDevice *device,
    GAsyncResult *res,
    GSimpleAsyncResult *simple)
{
    GError *error = NULL;
    QmiMessage *reply;
    QmiMessageOmaSetEventReportOutput *output;

    reply = qmi_device_command_finish (device, res, &error);
    if (!reply) {
        g_simple_async_result_take_error (simple, error);
        g_simple_async_result_complete (simple);
        g_object_unref (simple);
        return;
    }

    /* Parse reply */
    output = __qmi_message_oma_set_event_report_response_parse (reply, &error);
    if (!output)
        g_simple_async_result_take_error (simple, error);
    else
        g_simple_async_result_set_op_res_gpointer (simple,
                                                   output,
                                                   (GDestroyNotify)qmi_message_oma_set_event_report_output_unref);
    g_simple_async_result_complete (simple);
    g_object_unref (simple);
    qmi_message_unref (reply);
}

/**
 * qmi_client_oma_set_event_report:
 * @self: a #QmiClientOma.
 * @input: a #QmiMessageOmaSetEventReportInput.
 * @timeout: maximum time to wait for the method to complete, in seconds.
 * @cancellable: a #GCancellable or %NULL.
 * @callback: a #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: user data to pass to @callback.
 *
 * Asynchronously sends a Set Event Report request to the device.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from.
 *
 * You can then call qmi_client_oma_set_event_report_finish() to get the result of the operation.
 */
void
qmi_client_oma_set_event_report (
    QmiClientOma *self,
    QmiMessageOmaSetEventReportInput *input,
    guint timeout,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
    GSimpleAsyncResult *result;
    QmiMessage *request;
    GError *error = NULL;
    guint16 transaction_id;

    result = g_simple_async_result_new (G_OBJECT (self),
                                        callback,
                                        user_data,
                                        qmi_client_oma_set_event_report);

    transaction_id = qmi_client_get_next_transaction_id (QMI_CLIENT (self));

    request = __qmi_message_oma_set_event_report_request_create (
                  transaction_id,
                  qmi_client_get_cid (QMI_CLIENT (self)),
                  input,
                  &error);
    if (!request) {
        g_prefix_error (&error, "Couldn't create request message: ");
        g_simple_async_result_take_error (result, error);
        g_simple_async_result_complete_in_idle (result);
        g_object_unref (result);
        return;
    }

    qmi_device_command (QMI_DEVICE (qmi_client_peek_device (QMI_CLIENT (self))),
                        request,
                        timeout,
                        cancellable,
                        (GAsyncReadyCallback)set_event_report_ready,
                        result);
    qmi_message_unref (request);
}


/**
 * qmi_client_oma_start_session_finish:
 * @self: a #QmiClientOma.
 * @res: the #GAsyncResult obtained from the #GAsyncReadyCallback passed to qmi_client_oma_start_session().
 * @error: Return location for error or %NULL.
 *
 * Finishes an async operation started with qmi_client_oma_start_session().
 *
 * Returns: a #QmiMessageOmaStartSessionOutput, or %NULL if @error is set. The returned value should be freed with qmi_message_oma_start_session_output_unref().
 */
QmiMessageOmaStartSessionOutput *
qmi_client_oma_start_session_finish (
    QmiClientOma *self,
    GAsyncResult *res,
    GError **error)
{
   if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (res), error))
       return NULL;

   return qmi_message_oma_start_session_output_ref (g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (res)));
}

static void
start_session_ready (
    QmiDevice *device,
    GAsyncResult *res,
    GSimpleAsyncResult *simple)
{
    GError *error = NULL;
    QmiMessage *reply;
    QmiMessageOmaStartSessionOutput *output;

    reply = qmi_device_command_finish (device, res, &error);
    if (!reply) {
        g_simple_async_result_take_error (simple, error);
        g_simple_async_result_complete (simple);
        g_object_unref (simple);
        return;
    }

    /* Parse reply */
    output = __qmi_message_oma_start_session_response_parse (reply, &error);
    if (!output)
        g_simple_async_result_take_error (simple, error);
    else
        g_simple_async_result_set_op_res_gpointer (simple,
                                                   output,
                                                   (GDestroyNotify)qmi_message_oma_start_session_output_unref);
    g_simple_async_result_complete (simple);
    g_object_unref (simple);
    qmi_message_unref (reply);
}

/**
 * qmi_client_oma_start_session:
 * @self: a #QmiClientOma.
 * @input: a #QmiMessageOmaStartSessionInput.
 * @timeout: maximum time to wait for the method to complete, in seconds.
 * @cancellable: a #GCancellable or %NULL.
 * @callback: a #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: user data to pass to @callback.
 *
 * Asynchronously sends a Start Session request to the device.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from.
 *
 * You can then call qmi_client_oma_start_session_finish() to get the result of the operation.
 */
void
qmi_client_oma_start_session (
    QmiClientOma *self,
    QmiMessageOmaStartSessionInput *input,
    guint timeout,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
    GSimpleAsyncResult *result;
    QmiMessage *request;
    GError *error = NULL;
    guint16 transaction_id;

    result = g_simple_async_result_new (G_OBJECT (self),
                                        callback,
                                        user_data,
                                        qmi_client_oma_start_session);

    transaction_id = qmi_client_get_next_transaction_id (QMI_CLIENT (self));

    request = __qmi_message_oma_start_session_request_create (
                  transaction_id,
                  qmi_client_get_cid (QMI_CLIENT (self)),
                  input,
                  &error);
    if (!request) {
        g_prefix_error (&error, "Couldn't create request message: ");
        g_simple_async_result_take_error (result, error);
        g_simple_async_result_complete_in_idle (result);
        g_object_unref (result);
        return;
    }

    qmi_device_command (QMI_DEVICE (qmi_client_peek_device (QMI_CLIENT (self))),
                        request,
                        timeout,
                        cancellable,
                        (GAsyncReadyCallback)start_session_ready,
                        result);
    qmi_message_unref (request);
}


/**
 * qmi_client_oma_cancel_session_finish:
 * @self: a #QmiClientOma.
 * @res: the #GAsyncResult obtained from the #GAsyncReadyCallback passed to qmi_client_oma_cancel_session().
 * @error: Return location for error or %NULL.
 *
 * Finishes an async operation started with qmi_client_oma_cancel_session().
 *
 * Returns: a #QmiMessageOmaCancelSessionOutput, or %NULL if @error is set. The returned value should be freed with qmi_message_oma_cancel_session_output_unref().
 */
QmiMessageOmaCancelSessionOutput *
qmi_client_oma_cancel_session_finish (
    QmiClientOma *self,
    GAsyncResult *res,
    GError **error)
{
   if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (res), error))
       return NULL;

   return qmi_message_oma_cancel_session_output_ref (g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (res)));
}

static void
cancel_session_ready (
    QmiDevice *device,
    GAsyncResult *res,
    GSimpleAsyncResult *simple)
{
    GError *error = NULL;
    QmiMessage *reply;
    QmiMessageOmaCancelSessionOutput *output;

    reply = qmi_device_command_finish (device, res, &error);
    if (!reply) {
        g_simple_async_result_take_error (simple, error);
        g_simple_async_result_complete (simple);
        g_object_unref (simple);
        return;
    }

    /* Parse reply */
    output = __qmi_message_oma_cancel_session_response_parse (reply, &error);
    if (!output)
        g_simple_async_result_take_error (simple, error);
    else
        g_simple_async_result_set_op_res_gpointer (simple,
                                                   output,
                                                   (GDestroyNotify)qmi_message_oma_cancel_session_output_unref);
    g_simple_async_result_complete (simple);
    g_object_unref (simple);
    qmi_message_unref (reply);
}

/**
 * qmi_client_oma_cancel_session:
 * @self: a #QmiClientOma.
 * @unused: %NULL. This message doesn't have any input bundle.
 * @timeout: maximum time to wait for the method to complete, in seconds.
 * @cancellable: a #GCancellable or %NULL.
 * @callback: a #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: user data to pass to @callback.
 *
 * Asynchronously sends a Cancel Session request to the device.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from.
 *
 * You can then call qmi_client_oma_cancel_session_finish() to get the result of the operation.
 */
void
qmi_client_oma_cancel_session (
    QmiClientOma *self,
    gpointer unused,
    guint timeout,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
    GSimpleAsyncResult *result;
    QmiMessage *request;
    GError *error = NULL;
    guint16 transaction_id;

    result = g_simple_async_result_new (G_OBJECT (self),
                                        callback,
                                        user_data,
                                        qmi_client_oma_cancel_session);

    transaction_id = qmi_client_get_next_transaction_id (QMI_CLIENT (self));

    request = __qmi_message_oma_cancel_session_request_create (
                  transaction_id,
                  qmi_client_get_cid (QMI_CLIENT (self)),
                  NULL,
                  &error);
    if (!request) {
        g_prefix_error (&error, "Couldn't create request message: ");
        g_simple_async_result_take_error (result, error);
        g_simple_async_result_complete_in_idle (result);
        g_object_unref (result);
        return;
    }

    qmi_device_command (QMI_DEVICE (qmi_client_peek_device (QMI_CLIENT (self))),
                        request,
                        timeout,
                        cancellable,
                        (GAsyncReadyCallback)cancel_session_ready,
                        result);
    qmi_message_unref (request);
}


/**
 * qmi_client_oma_get_session_info_finish:
 * @self: a #QmiClientOma.
 * @res: the #GAsyncResult obtained from the #GAsyncReadyCallback passed to qmi_client_oma_get_session_info().
 * @error: Return location for error or %NULL.
 *
 * Finishes an async operation started with qmi_client_oma_get_session_info().
 *
 * Returns: a #QmiMessageOmaGetSessionInfoOutput, or %NULL if @error is set. The returned value should be freed with qmi_message_oma_get_session_info_output_unref().
 */
QmiMessageOmaGetSessionInfoOutput *
qmi_client_oma_get_session_info_finish (
    QmiClientOma *self,
    GAsyncResult *res,
    GError **error)
{
   if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (res), error))
       return NULL;

   return qmi_message_oma_get_session_info_output_ref (g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (res)));
}

static void
get_session_info_ready (
    QmiDevice *device,
    GAsyncResult *res,
    GSimpleAsyncResult *simple)
{
    GError *error = NULL;
    QmiMessage *reply;
    QmiMessageOmaGetSessionInfoOutput *output;

    reply = qmi_device_command_finish (device, res, &error);
    if (!reply) {
        g_simple_async_result_take_error (simple, error);
        g_simple_async_result_complete (simple);
        g_object_unref (simple);
        return;
    }

    /* Parse reply */
    output = __qmi_message_oma_get_session_info_response_parse (reply, &error);
    if (!output)
        g_simple_async_result_take_error (simple, error);
    else
        g_simple_async_result_set_op_res_gpointer (simple,
                                                   output,
                                                   (GDestroyNotify)qmi_message_oma_get_session_info_output_unref);
    g_simple_async_result_complete (simple);
    g_object_unref (simple);
    qmi_message_unref (reply);
}

/**
 * qmi_client_oma_get_session_info:
 * @self: a #QmiClientOma.
 * @unused: %NULL. This message doesn't have any input bundle.
 * @timeout: maximum time to wait for the method to complete, in seconds.
 * @cancellable: a #GCancellable or %NULL.
 * @callback: a #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: user data to pass to @callback.
 *
 * Asynchronously sends a Get Session Info request to the device.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from.
 *
 * You can then call qmi_client_oma_get_session_info_finish() to get the result of the operation.
 */
void
qmi_client_oma_get_session_info (
    QmiClientOma *self,
    gpointer unused,
    guint timeout,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
    GSimpleAsyncResult *result;
    QmiMessage *request;
    GError *error = NULL;
    guint16 transaction_id;

    result = g_simple_async_result_new (G_OBJECT (self),
                                        callback,
                                        user_data,
                                        qmi_client_oma_get_session_info);

    transaction_id = qmi_client_get_next_transaction_id (QMI_CLIENT (self));

    request = __qmi_message_oma_get_session_info_request_create (
                  transaction_id,
                  qmi_client_get_cid (QMI_CLIENT (self)),
                  NULL,
                  &error);
    if (!request) {
        g_prefix_error (&error, "Couldn't create request message: ");
        g_simple_async_result_take_error (result, error);
        g_simple_async_result_complete_in_idle (result);
        g_object_unref (result);
        return;
    }

    qmi_device_command (QMI_DEVICE (qmi_client_peek_device (QMI_CLIENT (self))),
                        request,
                        timeout,
                        cancellable,
                        (GAsyncReadyCallback)get_session_info_ready,
                        result);
    qmi_message_unref (request);
}


/**
 * qmi_client_oma_send_selection_finish:
 * @self: a #QmiClientOma.
 * @res: the #GAsyncResult obtained from the #GAsyncReadyCallback passed to qmi_client_oma_send_selection().
 * @error: Return location for error or %NULL.
 *
 * Finishes an async operation started with qmi_client_oma_send_selection().
 *
 * Returns: a #QmiMessageOmaSendSelectionOutput, or %NULL if @error is set. The returned value should be freed with qmi_message_oma_send_selection_output_unref().
 */
QmiMessageOmaSendSelectionOutput *
qmi_client_oma_send_selection_finish (
    QmiClientOma *self,
    GAsyncResult *res,
    GError **error)
{
   if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (res), error))
       return NULL;

   return qmi_message_oma_send_selection_output_ref (g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (res)));
}

static void
send_selection_ready (
    QmiDevice *device,
    GAsyncResult *res,
    GSimpleAsyncResult *simple)
{
    GError *error = NULL;
    QmiMessage *reply;
    QmiMessageOmaSendSelectionOutput *output;

    reply = qmi_device_command_finish (device, res, &error);
    if (!reply) {
        g_simple_async_result_take_error (simple, error);
        g_simple_async_result_complete (simple);
        g_object_unref (simple);
        return;
    }

    /* Parse reply */
    output = __qmi_message_oma_send_selection_response_parse (reply, &error);
    if (!output)
        g_simple_async_result_take_error (simple, error);
    else
        g_simple_async_result_set_op_res_gpointer (simple,
                                                   output,
                                                   (GDestroyNotify)qmi_message_oma_send_selection_output_unref);
    g_simple_async_result_complete (simple);
    g_object_unref (simple);
    qmi_message_unref (reply);
}

/**
 * qmi_client_oma_send_selection:
 * @self: a #QmiClientOma.
 * @input: a #QmiMessageOmaSendSelectionInput.
 * @timeout: maximum time to wait for the method to complete, in seconds.
 * @cancellable: a #GCancellable or %NULL.
 * @callback: a #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: user data to pass to @callback.
 *
 * Asynchronously sends a Send Selection request to the device.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from.
 *
 * You can then call qmi_client_oma_send_selection_finish() to get the result of the operation.
 */
void
qmi_client_oma_send_selection (
    QmiClientOma *self,
    QmiMessageOmaSendSelectionInput *input,
    guint timeout,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
    GSimpleAsyncResult *result;
    QmiMessage *request;
    GError *error = NULL;
    guint16 transaction_id;

    result = g_simple_async_result_new (G_OBJECT (self),
                                        callback,
                                        user_data,
                                        qmi_client_oma_send_selection);

    transaction_id = qmi_client_get_next_transaction_id (QMI_CLIENT (self));

    request = __qmi_message_oma_send_selection_request_create (
                  transaction_id,
                  qmi_client_get_cid (QMI_CLIENT (self)),
                  input,
                  &error);
    if (!request) {
        g_prefix_error (&error, "Couldn't create request message: ");
        g_simple_async_result_take_error (result, error);
        g_simple_async_result_complete_in_idle (result);
        g_object_unref (result);
        return;
    }

    qmi_device_command (QMI_DEVICE (qmi_client_peek_device (QMI_CLIENT (self))),
                        request,
                        timeout,
                        cancellable,
                        (GAsyncReadyCallback)send_selection_ready,
                        result);
    qmi_message_unref (request);
}


/**
 * qmi_client_oma_get_feature_setting_finish:
 * @self: a #QmiClientOma.
 * @res: the #GAsyncResult obtained from the #GAsyncReadyCallback passed to qmi_client_oma_get_feature_setting().
 * @error: Return location for error or %NULL.
 *
 * Finishes an async operation started with qmi_client_oma_get_feature_setting().
 *
 * Returns: a #QmiMessageOmaGetFeatureSettingOutput, or %NULL if @error is set. The returned value should be freed with qmi_message_oma_get_feature_setting_output_unref().
 */
QmiMessageOmaGetFeatureSettingOutput *
qmi_client_oma_get_feature_setting_finish (
    QmiClientOma *self,
    GAsyncResult *res,
    GError **error)
{
   if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (res), error))
       return NULL;

   return qmi_message_oma_get_feature_setting_output_ref (g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (res)));
}

static void
get_feature_setting_ready (
    QmiDevice *device,
    GAsyncResult *res,
    GSimpleAsyncResult *simple)
{
    GError *error = NULL;
    QmiMessage *reply;
    QmiMessageOmaGetFeatureSettingOutput *output;

    reply = qmi_device_command_finish (device, res, &error);
    if (!reply) {
        g_simple_async_result_take_error (simple, error);
        g_simple_async_result_complete (simple);
        g_object_unref (simple);
        return;
    }

    /* Parse reply */
    output = __qmi_message_oma_get_feature_setting_response_parse (reply, &error);
    if (!output)
        g_simple_async_result_take_error (simple, error);
    else
        g_simple_async_result_set_op_res_gpointer (simple,
                                                   output,
                                                   (GDestroyNotify)qmi_message_oma_get_feature_setting_output_unref);
    g_simple_async_result_complete (simple);
    g_object_unref (simple);
    qmi_message_unref (reply);
}

/**
 * qmi_client_oma_get_feature_setting:
 * @self: a #QmiClientOma.
 * @unused: %NULL. This message doesn't have any input bundle.
 * @timeout: maximum time to wait for the method to complete, in seconds.
 * @cancellable: a #GCancellable or %NULL.
 * @callback: a #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: user data to pass to @callback.
 *
 * Asynchronously sends a Get Feature Setting request to the device.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from.
 *
 * You can then call qmi_client_oma_get_feature_setting_finish() to get the result of the operation.
 */
void
qmi_client_oma_get_feature_setting (
    QmiClientOma *self,
    gpointer unused,
    guint timeout,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
    GSimpleAsyncResult *result;
    QmiMessage *request;
    GError *error = NULL;
    guint16 transaction_id;

    result = g_simple_async_result_new (G_OBJECT (self),
                                        callback,
                                        user_data,
                                        qmi_client_oma_get_feature_setting);

    transaction_id = qmi_client_get_next_transaction_id (QMI_CLIENT (self));

    request = __qmi_message_oma_get_feature_setting_request_create (
                  transaction_id,
                  qmi_client_get_cid (QMI_CLIENT (self)),
                  NULL,
                  &error);
    if (!request) {
        g_prefix_error (&error, "Couldn't create request message: ");
        g_simple_async_result_take_error (result, error);
        g_simple_async_result_complete_in_idle (result);
        g_object_unref (result);
        return;
    }

    qmi_device_command (QMI_DEVICE (qmi_client_peek_device (QMI_CLIENT (self))),
                        request,
                        timeout,
                        cancellable,
                        (GAsyncReadyCallback)get_feature_setting_ready,
                        result);
    qmi_message_unref (request);
}


/**
 * qmi_client_oma_set_feature_setting_finish:
 * @self: a #QmiClientOma.
 * @res: the #GAsyncResult obtained from the #GAsyncReadyCallback passed to qmi_client_oma_set_feature_setting().
 * @error: Return location for error or %NULL.
 *
 * Finishes an async operation started with qmi_client_oma_set_feature_setting().
 *
 * Returns: a #QmiMessageOmaSetFeatureSettingOutput, or %NULL if @error is set. The returned value should be freed with qmi_message_oma_set_feature_setting_output_unref().
 */
QmiMessageOmaSetFeatureSettingOutput *
qmi_client_oma_set_feature_setting_finish (
    QmiClientOma *self,
    GAsyncResult *res,
    GError **error)
{
   if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (res), error))
       return NULL;

   return qmi_message_oma_set_feature_setting_output_ref (g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (res)));
}

static void
set_feature_setting_ready (
    QmiDevice *device,
    GAsyncResult *res,
    GSimpleAsyncResult *simple)
{
    GError *error = NULL;
    QmiMessage *reply;
    QmiMessageOmaSetFeatureSettingOutput *output;

    reply = qmi_device_command_finish (device, res, &error);
    if (!reply) {
        g_simple_async_result_take_error (simple, error);
        g_simple_async_result_complete (simple);
        g_object_unref (simple);
        return;
    }

    /* Parse reply */
    output = __qmi_message_oma_set_feature_setting_response_parse (reply, &error);
    if (!output)
        g_simple_async_result_take_error (simple, error);
    else
        g_simple_async_result_set_op_res_gpointer (simple,
                                                   output,
                                                   (GDestroyNotify)qmi_message_oma_set_feature_setting_output_unref);
    g_simple_async_result_complete (simple);
    g_object_unref (simple);
    qmi_message_unref (reply);
}

/**
 * qmi_client_oma_set_feature_setting:
 * @self: a #QmiClientOma.
 * @input: a #QmiMessageOmaSetFeatureSettingInput.
 * @timeout: maximum time to wait for the method to complete, in seconds.
 * @cancellable: a #GCancellable or %NULL.
 * @callback: a #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: user data to pass to @callback.
 *
 * Asynchronously sends a Set Feature Setting request to the device.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from.
 *
 * You can then call qmi_client_oma_set_feature_setting_finish() to get the result of the operation.
 */
void
qmi_client_oma_set_feature_setting (
    QmiClientOma *self,
    QmiMessageOmaSetFeatureSettingInput *input,
    guint timeout,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
    GSimpleAsyncResult *result;
    QmiMessage *request;
    GError *error = NULL;
    guint16 transaction_id;

    result = g_simple_async_result_new (G_OBJECT (self),
                                        callback,
                                        user_data,
                                        qmi_client_oma_set_feature_setting);

    transaction_id = qmi_client_get_next_transaction_id (QMI_CLIENT (self));

    request = __qmi_message_oma_set_feature_setting_request_create (
                  transaction_id,
                  qmi_client_get_cid (QMI_CLIENT (self)),
                  input,
                  &error);
    if (!request) {
        g_prefix_error (&error, "Couldn't create request message: ");
        g_simple_async_result_take_error (result, error);
        g_simple_async_result_complete_in_idle (result);
        g_object_unref (result);
        return;
    }

    qmi_device_command (QMI_DEVICE (qmi_client_peek_device (QMI_CLIENT (self))),
                        request,
                        timeout,
                        cancellable,
                        (GAsyncReadyCallback)set_feature_setting_ready,
                        result);
    qmi_message_unref (request);
}

