
/* GENERATED CODE... DO NOT EDIT */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Copyright (C) 2012 Lanedo GmbH
 */


#include <string.h>

#include "qmi-pbm.h"
#include "qmi-enum-types.h"
#include "qmi-enum-types-private.h"
#include "qmi-flags64-types.h"
#include "qmi-error-types.h"
#include "qmi-device.h"
#include "qmi-utils.h"

#define QMI_STATUS_SUCCESS 0x0000
#define QMI_STATUS_FAILURE 0x0001


typedef enum {
    QMI_MESSAGE_PBM_INDICATION_REGISTER = 0x0001,
    QMI_MESSAGE_PBM_GET_CAPABILITIES = 0x0002,
    QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES = 0x0003,
} QmiMessagePbm;


/*****************************************************************************/
/* REQUEST/RESPONSE: Qmi Message PBM Indication Register */


/* --- Input -- */

struct _QmiMessagePbmIndicationRegisterInput {
    volatile gint ref_count;

    /* Event Registration Mask */
    gboolean arg_event_registration_mask_set;
    guint32 arg_event_registration_mask;
};

#define QMI_MESSAGE_PBM_INDICATION_REGISTER_INPUT_TLV_EVENT_REGISTRATION_MASK 0x01

/**
 * qmi_message_pbm_indication_register_input_get_event_registration_mask:
 * @self: a #QmiMessagePbmIndicationRegisterInput.
 * @event_registration_mask: a placeholder for the output #QmiPbmEventRegistrationFlag, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Event Registration Mask' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_indication_register_input_get_event_registration_mask (
    QmiMessagePbmIndicationRegisterInput *self,
    QmiPbmEventRegistrationFlag *event_registration_mask,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_event_registration_mask_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Event Registration Mask' was not found in the message");
        return FALSE;
    }

    if (event_registration_mask)
        *event_registration_mask = (QmiPbmEventRegistrationFlag)(self->arg_event_registration_mask);

    return TRUE;
}

/**
 * qmi_message_pbm_indication_register_input_set_event_registration_mask:
 * @self: a #QmiMessagePbmIndicationRegisterInput.
 * @event_registration_mask: a #QmiPbmEventRegistrationFlag.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Event Registration Mask' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_indication_register_input_set_event_registration_mask (
    QmiMessagePbmIndicationRegisterInput *self,
    QmiPbmEventRegistrationFlag event_registration_mask,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_event_registration_mask = (guint32)(event_registration_mask);
    self->arg_event_registration_mask_set = TRUE;

    return TRUE;
}

GType
qmi_message_pbm_indication_register_input_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessagePbmIndicationRegisterInput"),
                                          (GBoxedCopyFunc) qmi_message_pbm_indication_register_input_ref,
                                          (GBoxedFreeFunc) qmi_message_pbm_indication_register_input_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_pbm_indication_register_input_ref:
 * @self: a #QmiMessagePbmIndicationRegisterInput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessagePbmIndicationRegisterInput *
qmi_message_pbm_indication_register_input_ref (QmiMessagePbmIndicationRegisterInput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_pbm_indication_register_input_unref:
 * @self: a #QmiMessagePbmIndicationRegisterInput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_pbm_indication_register_input_unref (QmiMessagePbmIndicationRegisterInput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessagePbmIndicationRegisterInput, self);
    }
}

/**
 * qmi_message_pbm_indication_register_input_new:
 *
 * Allocates a new #QmiMessagePbmIndicationRegisterInput.
 *
 * Returns: the newly created #QmiMessagePbmIndicationRegisterInput. The returned value should be freed with qmi_message_pbm_indication_register_input_unref().
 */
QmiMessagePbmIndicationRegisterInput *
qmi_message_pbm_indication_register_input_new (void)
{
    QmiMessagePbmIndicationRegisterInput *self;

    self = g_slice_new0 (QmiMessagePbmIndicationRegisterInput);
    self->ref_count = 1;
    return self;
}

static QmiMessage *
__qmi_message_pbm_indication_register_request_create (
    guint8 transaction_id,
    guint8 cid,
    QmiMessagePbmIndicationRegisterInput *input,
    GError **error)
{
    QmiMessage *self;

    self = qmi_message_new (QMI_SERVICE_PBM,
                            cid,
                            transaction_id,
                            QMI_MESSAGE_PBM_INDICATION_REGISTER);

    /* There is at least one mandatory TLV, don't allow NULL input */
    if (!input) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_ARGS,
                     "Message 'Indication Register' has mandatory TLVs");
        qmi_message_unref (self);
        return NULL;
    }

    /* Try to add the 'Event Registration Mask' TLV */
    if (input->arg_event_registration_mask_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        if (buffer_len < 4)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_PBM_INDICATION_REGISTER_INPUT_TLV_EVENT_REGISTRATION_MASK;
        else {
            guint32 tmp;

            tmp = (guint32)input->arg_event_registration_mask;
            /* Write the guint32 variable to the buffer */
            qmi_utils_write_guint32_to_buffer (
                &buffer_aux,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);
        }

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_PBM_INDICATION_REGISTER_INPUT_TLV_EVENT_REGISTRATION_MASK:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_PBM_INDICATION_REGISTER_INPUT_TLV_EVENT_REGISTRATION_MASK;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_PBM_INDICATION_REGISTER_INPUT_TLV_EVENT_REGISTRATION_MASK,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_PBM_INDICATION_REGISTER_INPUT_TLV_EVENT_REGISTRATION_MASK:
            g_prefix_error (error, "Couldn't set the Event Registration Mask TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    } else {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_ARGS,
                     "Missing mandatory TLV 'Event Registration Mask' in message 'Indication Register'");
        qmi_message_unref (self);
        return NULL;
    }

    return self;
}

/* --- Output -- */

/**
 * QmiMessageResult:
 * @error_status: a #guint16.
 * @error_code: a #guint16.
 *
 * A QmiMessageResult struct.
 */
typedef struct _QmiMessageResult {
    guint16 error_status;
    guint16 error_code;
} QmiMessageResult;

struct _QmiMessagePbmIndicationRegisterOutput {
    volatile gint ref_count;

    /* Result */
    gboolean arg_result_set;
    QmiMessageResult arg_result;

    /* Event Registration Mask */
    gboolean arg_event_registration_mask_set;
    guint32 arg_event_registration_mask;
};

#define QMI_MESSAGE_PBM_INDICATION_REGISTER_OUTPUT_TLV_RESULT 0x02
#define QMI_MESSAGE_PBM_INDICATION_REGISTER_OUTPUT_TLV_EVENT_REGISTRATION_MASK 0x10

/**
 * qmi_message_pbm_indication_register_output_get_result:
 * @self: a QmiMessagePbmIndicationRegisterOutput.
 * @error: Return location for error or %NULL.
 *
 * Get the result of the QMI operation.
 *
 * Returns: %TRUE if the QMI operation succeeded, %FALSE if @error is set.
 */
gboolean
qmi_message_pbm_indication_register_output_get_result (
    QmiMessagePbmIndicationRegisterOutput *self,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    /* We should always have a result set in the response message */
    if (!self->arg_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_MESSAGE,
                     "No 'Result' field given in the message");
        return FALSE;
    }

    if (self->arg_result.error_status == QMI_STATUS_SUCCESS) {
        /* Operation succeeded */
        return TRUE;
    }

    /* Report a QMI protocol error */
    g_set_error (error,
                 QMI_PROTOCOL_ERROR,
                 (QmiProtocolError) self->arg_result.error_code,
                 "QMI protocol error (%u): '%s'",
                 self->arg_result.error_code,
                 qmi_protocol_error_get_string ((QmiProtocolError) self->arg_result.error_code));
    return FALSE;
}

/**
 * qmi_message_pbm_indication_register_output_get_event_registration_mask:
 * @self: a #QmiMessagePbmIndicationRegisterOutput.
 * @event_registration_mask: a placeholder for the output #QmiPbmEventRegistrationFlag, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Event Registration Mask' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_indication_register_output_get_event_registration_mask (
    QmiMessagePbmIndicationRegisterOutput *self,
    QmiPbmEventRegistrationFlag *event_registration_mask,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_event_registration_mask_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Event Registration Mask' was not found in the message");
        return FALSE;
    }

    if (event_registration_mask)
        *event_registration_mask = (QmiPbmEventRegistrationFlag)(self->arg_event_registration_mask);

    return TRUE;
}

GType
qmi_message_pbm_indication_register_output_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessagePbmIndicationRegisterOutput"),
                                          (GBoxedCopyFunc) qmi_message_pbm_indication_register_output_ref,
                                          (GBoxedFreeFunc) qmi_message_pbm_indication_register_output_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_pbm_indication_register_output_ref:
 * @self: a #QmiMessagePbmIndicationRegisterOutput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessagePbmIndicationRegisterOutput *
qmi_message_pbm_indication_register_output_ref (QmiMessagePbmIndicationRegisterOutput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_pbm_indication_register_output_unref:
 * @self: a #QmiMessagePbmIndicationRegisterOutput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_pbm_indication_register_output_unref (QmiMessagePbmIndicationRegisterOutput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessagePbmIndicationRegisterOutput, self);
    }
}

static gboolean
qmi_message_pbm_indication_register_input_event_registration_mask_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Event Registration Mask' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Event Registration Mask' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_pbm_indication_register_input_event_registration_mask_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_PBM_INDICATION_REGISTER_INPUT_TLV_EVENT_REGISTRATION_MASK,
                                      &buffer_len);
    if (buffer && qmi_message_pbm_indication_register_input_event_registration_mask_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

#if defined  __QMI_PBM_EVENT_REGISTRATION_FLAG_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_pbm_event_registration_flag_get_string ((QmiPbmEventRegistrationFlag)tmp));
#elif defined  __QMI_PBM_EVENT_REGISTRATION_FLAG_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_pbm_event_registration_flag_build_string_from_mask ((QmiPbmEventRegistrationFlag)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiPbmEventRegistrationFlag
#endif
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Event Registration Mask' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_result_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    static const guint expected_len = 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Result' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    return TRUE;
}

static gchar *
qmi_message_result_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (self,
                                      QMI_MESSAGE_PBM_INDICATION_REGISTER_OUTPUT_TLV_RESULT,
                                      &buffer_len);
    if (buffer) {
        GString *printable;
        guint16 error_status;
        guint16 error_code;

        printable = g_string_new ("");
        qmi_utils_read_guint16_from_buffer (
            &buffer,
            &buffer_len,
            QMI_ENDIAN_LITTLE,
            &error_status);
        qmi_utils_read_guint16_from_buffer (
            &buffer,
            &buffer_len,
            QMI_ENDIAN_LITTLE,
            &error_code);

        g_warn_if_fail (buffer_len == 0);

        if (error_status == QMI_STATUS_SUCCESS)
            g_string_append (printable, "SUCCESS");
        else
            g_string_append_printf (printable,
                                    "FAILURE: %s",
                                    qmi_protocol_error_get_string ((QmiProtocolError) error_code));

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_pbm_indication_register_output_event_registration_mask_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Event Registration Mask' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Event Registration Mask' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_pbm_indication_register_output_event_registration_mask_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_PBM_INDICATION_REGISTER_OUTPUT_TLV_EVENT_REGISTRATION_MASK,
                                      &buffer_len);
    if (buffer && qmi_message_pbm_indication_register_output_event_registration_mask_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

#if defined  __QMI_PBM_EVENT_REGISTRATION_FLAG_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_pbm_event_registration_flag_get_string ((QmiPbmEventRegistrationFlag)tmp));
#elif defined  __QMI_PBM_EVENT_REGISTRATION_FLAG_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_pbm_event_registration_flag_build_string_from_mask ((QmiPbmEventRegistrationFlag)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiPbmEventRegistrationFlag
#endif
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Event Registration Mask' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

struct message_indication_register_context {
    QmiMessage *self;
    const gchar *line_prefix;
    GString *printable;
};

static void
message_indication_register_get_tlv_printable (
    guint8 type,
    const guint8 *value,
    gsize length,
    struct message_indication_register_context *ctx)
{
    const gchar *tlv_type_str = NULL;
    gchar *translated_value;

    if (!qmi_message_is_response (ctx->self)) {
        switch (type) {
        case QMI_MESSAGE_PBM_INDICATION_REGISTER_INPUT_TLV_EVENT_REGISTRATION_MASK:
            tlv_type_str = "Event Registration Mask";
            translated_value = qmi_message_pbm_indication_register_input_event_registration_mask_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    } else {
        switch (type) {
        case QMI_MESSAGE_PBM_INDICATION_REGISTER_OUTPUT_TLV_RESULT:
            tlv_type_str = "Result";
            translated_value = qmi_message_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_PBM_INDICATION_REGISTER_OUTPUT_TLV_EVENT_REGISTRATION_MASK:
            tlv_type_str = "Event Registration Mask";
            translated_value = qmi_message_pbm_indication_register_output_event_registration_mask_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    }

    if (!tlv_type_str) {
        gchar *value_str = NULL;

        value_str = qmi_message_get_tlv_printable (ctx->self,
                                                   ctx->line_prefix,
                                                   type,
                                                   value,
                                                   length);
        g_string_append (ctx->printable, value_str);
        g_free (value_str);
    } else {
        gchar *value_hex;

        value_hex = __qmi_utils_str_hex (value, length, ':');
        g_string_append_printf (ctx->printable,
                                "%sTLV:\n"
                                "%s  type       = \"%s\" (0x%02x)\n"
                                "%s  length     = %" G_GSIZE_FORMAT "\n"
                                "%s  value      = %s\n"
                                "%s  translated = %s\n",
                                ctx->line_prefix,
                                ctx->line_prefix, tlv_type_str, type,
                                ctx->line_prefix, length,
                                ctx->line_prefix, value_hex,
                                ctx->line_prefix, translated_value ? translated_value : "");
        g_free (value_hex);
        g_free (translated_value);
    }
}

static gchar *
message_indication_register_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    GString *printable;

    printable = g_string_new ("");
    g_string_append_printf (printable,
                            "%s  message     = \"Indication Register\" (0x0001)\n",
                            line_prefix);

    {
        struct message_indication_register_context ctx;
        ctx.self = self;
        ctx.line_prefix = line_prefix;
        ctx.printable = printable;
        qmi_message_foreach_raw_tlv (self,
                                     (QmiMessageForeachRawTlvFn)message_indication_register_get_tlv_printable,
                                     &ctx);
    }

    return g_string_free (printable, FALSE);
}

static QmiMessagePbmIndicationRegisterOutput *
__qmi_message_pbm_indication_register_response_parse (
    QmiMessage *message,
    GError **error)
{
    QmiMessagePbmIndicationRegisterOutput *self;

    g_return_val_if_fail (qmi_message_get_message_id (message) == QMI_MESSAGE_PBM_INDICATION_REGISTER, NULL);

    self = g_slice_new0 (QmiMessagePbmIndicationRegisterOutput);
    self->ref_count = 1;

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_INDICATION_REGISTER_OUTPUT_TLV_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_result_validate (buffer, buffer_len)) {
                self->arg_result_set = TRUE;

                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_status));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_code));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Result' TLV", buffer_len);
                }
            } else {
                g_set_error (error,
                             QMI_CORE_ERROR,
                             QMI_CORE_ERROR_TLV_NOT_FOUND,
                             "Couldn't get the Result TLV: Not found");
                qmi_message_pbm_indication_register_output_unref (self);
                return NULL;
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_INDICATION_REGISTER_OUTPUT_TLV_EVENT_REGISTRATION_MASK,
                                              &buffer_len);
            if (buffer && qmi_message_pbm_indication_register_output_event_registration_mask_validate (buffer, buffer_len)) {
                self->arg_event_registration_mask_set = TRUE;

                {
                    guint32 tmp;

                    /* Read the guint32 variable from the buffer */
                    qmi_utils_read_guint32_from_buffer (
                        &buffer,
                        &buffer_len,
                        QMI_ENDIAN_LITTLE,
                        &tmp);
                    self->arg_event_registration_mask = (QmiPbmEventRegistrationFlag)tmp;
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Event Registration Mask' TLV", buffer_len);
                }
            }

        }
    } while (0);

    return self;
}

/*****************************************************************************/
/* REQUEST/RESPONSE: Qmi Message PBM Get Capabilities */


/* --- Input -- */

struct _QmiMessagePbmGetCapabilitiesInput {
    volatile gint ref_count;

    /* Phonebook Information */
    gboolean arg_phonebook_information_set;
    guint8 arg_phonebook_information_session_type;
    guint16 arg_phonebook_information_phonebook_type;
};

#define QMI_MESSAGE_PBM_GET_CAPABILITIES_INPUT_TLV_PHONEBOOK_INFORMATION 0x01

/**
 * qmi_message_pbm_get_capabilities_input_get_phonebook_information:
 * @self: a #QmiMessagePbmGetCapabilitiesInput.
 * @phonebook_information_session_type: a placeholder for the output #QmiPbmSessionType, or %NULL if not required.
 * @phonebook_information_phonebook_type: a placeholder for the output #QmiPbmPhonebookType, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Phonebook Information' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_get_capabilities_input_get_phonebook_information (
    QmiMessagePbmGetCapabilitiesInput *self,
    QmiPbmSessionType *phonebook_information_session_type,
    QmiPbmPhonebookType *phonebook_information_phonebook_type,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_phonebook_information_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Phonebook Information' was not found in the message");
        return FALSE;
    }

    if (phonebook_information_session_type)
        *phonebook_information_session_type = (QmiPbmSessionType)(self->arg_phonebook_information_session_type);
    if (phonebook_information_phonebook_type)
        *phonebook_information_phonebook_type = (QmiPbmPhonebookType)(self->arg_phonebook_information_phonebook_type);

    return TRUE;
}

/**
 * qmi_message_pbm_get_capabilities_input_set_phonebook_information:
 * @self: a #QmiMessagePbmGetCapabilitiesInput.
 * @phonebook_information_session_type: a #QmiPbmSessionType.
 * @phonebook_information_phonebook_type: a #QmiPbmPhonebookType.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Phonebook Information' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_get_capabilities_input_set_phonebook_information (
    QmiMessagePbmGetCapabilitiesInput *self,
    QmiPbmSessionType phonebook_information_session_type,
    QmiPbmPhonebookType phonebook_information_phonebook_type,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_phonebook_information_session_type = (guint8)(phonebook_information_session_type);
    self->arg_phonebook_information_phonebook_type = (guint16)(phonebook_information_phonebook_type);
    self->arg_phonebook_information_set = TRUE;

    return TRUE;
}

GType
qmi_message_pbm_get_capabilities_input_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessagePbmGetCapabilitiesInput"),
                                          (GBoxedCopyFunc) qmi_message_pbm_get_capabilities_input_ref,
                                          (GBoxedFreeFunc) qmi_message_pbm_get_capabilities_input_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_pbm_get_capabilities_input_ref:
 * @self: a #QmiMessagePbmGetCapabilitiesInput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessagePbmGetCapabilitiesInput *
qmi_message_pbm_get_capabilities_input_ref (QmiMessagePbmGetCapabilitiesInput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_pbm_get_capabilities_input_unref:
 * @self: a #QmiMessagePbmGetCapabilitiesInput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_pbm_get_capabilities_input_unref (QmiMessagePbmGetCapabilitiesInput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessagePbmGetCapabilitiesInput, self);
    }
}

/**
 * qmi_message_pbm_get_capabilities_input_new:
 *
 * Allocates a new #QmiMessagePbmGetCapabilitiesInput.
 *
 * Returns: the newly created #QmiMessagePbmGetCapabilitiesInput. The returned value should be freed with qmi_message_pbm_get_capabilities_input_unref().
 */
QmiMessagePbmGetCapabilitiesInput *
qmi_message_pbm_get_capabilities_input_new (void)
{
    QmiMessagePbmGetCapabilitiesInput *self;

    self = g_slice_new0 (QmiMessagePbmGetCapabilitiesInput);
    self->ref_count = 1;
    return self;
}

static QmiMessage *
__qmi_message_pbm_get_capabilities_request_create (
    guint8 transaction_id,
    guint8 cid,
    QmiMessagePbmGetCapabilitiesInput *input,
    GError **error)
{
    QmiMessage *self;

    self = qmi_message_new (QMI_SERVICE_PBM,
                            cid,
                            transaction_id,
                            QMI_MESSAGE_PBM_GET_CAPABILITIES);

    /* There is at least one mandatory TLV, don't allow NULL input */
    if (!input) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_ARGS,
                     "Message 'Get Capabilities' has mandatory TLVs");
        qmi_message_unref (self);
        return NULL;
    }

    /* Try to add the 'Phonebook Information' TLV */
    if (input->arg_phonebook_information_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        if (buffer_len < 1)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_PBM_GET_CAPABILITIES_INPUT_TLV_PHONEBOOK_INFORMATION;
        else {
            guint8 tmp;

            tmp = (guint8)input->arg_phonebook_information_session_type;
            /* Write the guint8 variable to the buffer */
            qmi_utils_write_guint8_to_buffer (
                &buffer_aux,
                &buffer_len,
                &tmp);
        }
        if (buffer_len < 2)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_PBM_GET_CAPABILITIES_INPUT_TLV_PHONEBOOK_INFORMATION;
        else {
            guint16 tmp;

            tmp = (guint16)input->arg_phonebook_information_phonebook_type;
            /* Write the guint16 variable to the buffer */
            qmi_utils_write_guint16_to_buffer (
                &buffer_aux,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);
        }

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_PBM_GET_CAPABILITIES_INPUT_TLV_PHONEBOOK_INFORMATION:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_PBM_GET_CAPABILITIES_INPUT_TLV_PHONEBOOK_INFORMATION;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_PBM_GET_CAPABILITIES_INPUT_TLV_PHONEBOOK_INFORMATION,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_PBM_GET_CAPABILITIES_INPUT_TLV_PHONEBOOK_INFORMATION:
            g_prefix_error (error, "Couldn't set the Phonebook Information TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    } else {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_ARGS,
                     "Missing mandatory TLV 'Phonebook Information' in message 'Get Capabilities'");
        qmi_message_unref (self);
        return NULL;
    }

    return self;
}

/* --- Output -- */

struct _QmiMessagePbmGetCapabilitiesOutput {
    volatile gint ref_count;

    /* Result */
    gboolean arg_result_set;
    QmiMessageResult arg_result;

    /* Capability Basic Information */
    gboolean arg_capability_basic_information_set;
    guint8 arg_capability_basic_information_session_type;
    guint16 arg_capability_basic_information_phonebook_type;
    guint16 arg_capability_basic_information_used_records;
    guint16 arg_capability_basic_information_maximum_records;
    guint8 arg_capability_basic_information_maximum_number_length;
    guint8 arg_capability_basic_information_maximum_name_length;

    /* Group Capability */
    gboolean arg_group_capability_set;
    guint8 arg_group_capability_maximum_groups;
    guint8 arg_group_capability_maximum_group_tag_length;

    /* Additional Number Capability */
    gboolean arg_additional_number_capability_set;
    guint8 arg_additional_number_capability_maximum_additional_numbers;
    guint8 arg_additional_number_capability_maximum_additional_number_length;
    guint8 arg_additional_number_capability_maximum_additional_number_tag_length;

    /* Email Capability */
    gboolean arg_email_capability_set;
    guint8 arg_email_capability_maximum_emails;
    guint8 arg_email_capability_maximum_email_address_length;

    /* Second Name Capability */
    gboolean arg_second_name_capability_set;
    guint8 arg_second_name_capability_maximum_second_name_length;

    /* Hidden Records Capability */
    gboolean arg_hidden_records_capability_set;
    guint8 arg_hidden_records_capability_supported;

    /* Grouping Information Alpha String Capability */
    gboolean arg_grouping_information_alpha_string_capability_set;
    guint8 arg_grouping_information_alpha_string_capability_maximum_records;
    guint8 arg_grouping_information_alpha_string_capability_used_records;
    guint8 arg_grouping_information_alpha_string_capability_maximum_string_length;

    /* Additional Number Alpha String Capability */
    gboolean arg_additional_number_alpha_string_capability_set;
    guint8 arg_additional_number_alpha_string_capability_maximum_records;
    guint8 arg_additional_number_alpha_string_capability_used_records;
    guint8 arg_additional_number_alpha_string_capability_maximum_string_length;
};

#define QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_RESULT 0x02
#define QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_CAPABILITY_BASIC_INFORMATION 0x10
#define QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_GROUP_CAPABILITY 0x11
#define QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_ADDITIONAL_NUMBER_CAPABILITY 0x12
#define QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_EMAIL_CAPABILITY 0x13
#define QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_SECOND_NAME_CAPABILITY 0x14
#define QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_HIDDEN_RECORDS_CAPABILITY 0x15
#define QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_GROUPING_INFORMATION_ALPHA_STRING_CAPABILITY 0x16
#define QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_ADDITIONAL_NUMBER_ALPHA_STRING_CAPABILITY 0x17

/**
 * qmi_message_pbm_get_capabilities_output_get_result:
 * @self: a QmiMessagePbmGetCapabilitiesOutput.
 * @error: Return location for error or %NULL.
 *
 * Get the result of the QMI operation.
 *
 * Returns: %TRUE if the QMI operation succeeded, %FALSE if @error is set.
 */
gboolean
qmi_message_pbm_get_capabilities_output_get_result (
    QmiMessagePbmGetCapabilitiesOutput *self,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    /* We should always have a result set in the response message */
    if (!self->arg_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_MESSAGE,
                     "No 'Result' field given in the message");
        return FALSE;
    }

    if (self->arg_result.error_status == QMI_STATUS_SUCCESS) {
        /* Operation succeeded */
        return TRUE;
    }

    /* Report a QMI protocol error */
    g_set_error (error,
                 QMI_PROTOCOL_ERROR,
                 (QmiProtocolError) self->arg_result.error_code,
                 "QMI protocol error (%u): '%s'",
                 self->arg_result.error_code,
                 qmi_protocol_error_get_string ((QmiProtocolError) self->arg_result.error_code));
    return FALSE;
}

/**
 * qmi_message_pbm_get_capabilities_output_get_capability_basic_information:
 * @self: a #QmiMessagePbmGetCapabilitiesOutput.
 * @capability_basic_information_session_type: a placeholder for the output #QmiPbmSessionType, or %NULL if not required.
 * @capability_basic_information_phonebook_type: a placeholder for the output #QmiPbmPhonebookType, or %NULL if not required.
 * @capability_basic_information_used_records: a placeholder for the output #guint16, or %NULL if not required.
 * @capability_basic_information_maximum_records: a placeholder for the output #guint16, or %NULL if not required.
 * @capability_basic_information_maximum_number_length: a placeholder for the output #guint8, or %NULL if not required.
 * @capability_basic_information_maximum_name_length: a placeholder for the output #guint8, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Capability Basic Information' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_get_capabilities_output_get_capability_basic_information (
    QmiMessagePbmGetCapabilitiesOutput *self,
    QmiPbmSessionType *capability_basic_information_session_type,
    QmiPbmPhonebookType *capability_basic_information_phonebook_type,
    guint16 *capability_basic_information_used_records,
    guint16 *capability_basic_information_maximum_records,
    guint8 *capability_basic_information_maximum_number_length,
    guint8 *capability_basic_information_maximum_name_length,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_capability_basic_information_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Capability Basic Information' was not found in the message");
        return FALSE;
    }

    if (capability_basic_information_session_type)
        *capability_basic_information_session_type = (QmiPbmSessionType)(self->arg_capability_basic_information_session_type);
    if (capability_basic_information_phonebook_type)
        *capability_basic_information_phonebook_type = (QmiPbmPhonebookType)(self->arg_capability_basic_information_phonebook_type);
    if (capability_basic_information_used_records)
        *capability_basic_information_used_records = self->arg_capability_basic_information_used_records;
    if (capability_basic_information_maximum_records)
        *capability_basic_information_maximum_records = self->arg_capability_basic_information_maximum_records;
    if (capability_basic_information_maximum_number_length)
        *capability_basic_information_maximum_number_length = self->arg_capability_basic_information_maximum_number_length;
    if (capability_basic_information_maximum_name_length)
        *capability_basic_information_maximum_name_length = self->arg_capability_basic_information_maximum_name_length;

    return TRUE;
}

/**
 * qmi_message_pbm_get_capabilities_output_get_group_capability:
 * @self: a #QmiMessagePbmGetCapabilitiesOutput.
 * @group_capability_maximum_groups: a placeholder for the output #guint8, or %NULL if not required.
 * @group_capability_maximum_group_tag_length: a placeholder for the output #guint8, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Group Capability' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_get_capabilities_output_get_group_capability (
    QmiMessagePbmGetCapabilitiesOutput *self,
    guint8 *group_capability_maximum_groups,
    guint8 *group_capability_maximum_group_tag_length,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_group_capability_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Group Capability' was not found in the message");
        return FALSE;
    }

    if (group_capability_maximum_groups)
        *group_capability_maximum_groups = self->arg_group_capability_maximum_groups;
    if (group_capability_maximum_group_tag_length)
        *group_capability_maximum_group_tag_length = self->arg_group_capability_maximum_group_tag_length;

    return TRUE;
}

/**
 * qmi_message_pbm_get_capabilities_output_get_additional_number_capability:
 * @self: a #QmiMessagePbmGetCapabilitiesOutput.
 * @additional_number_capability_maximum_additional_numbers: a placeholder for the output #guint8, or %NULL if not required.
 * @additional_number_capability_maximum_additional_number_length: a placeholder for the output #guint8, or %NULL if not required.
 * @additional_number_capability_maximum_additional_number_tag_length: a placeholder for the output #guint8, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Additional Number Capability' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_get_capabilities_output_get_additional_number_capability (
    QmiMessagePbmGetCapabilitiesOutput *self,
    guint8 *additional_number_capability_maximum_additional_numbers,
    guint8 *additional_number_capability_maximum_additional_number_length,
    guint8 *additional_number_capability_maximum_additional_number_tag_length,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_additional_number_capability_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Additional Number Capability' was not found in the message");
        return FALSE;
    }

    if (additional_number_capability_maximum_additional_numbers)
        *additional_number_capability_maximum_additional_numbers = self->arg_additional_number_capability_maximum_additional_numbers;
    if (additional_number_capability_maximum_additional_number_length)
        *additional_number_capability_maximum_additional_number_length = self->arg_additional_number_capability_maximum_additional_number_length;
    if (additional_number_capability_maximum_additional_number_tag_length)
        *additional_number_capability_maximum_additional_number_tag_length = self->arg_additional_number_capability_maximum_additional_number_tag_length;

    return TRUE;
}

/**
 * qmi_message_pbm_get_capabilities_output_get_email_capability:
 * @self: a #QmiMessagePbmGetCapabilitiesOutput.
 * @email_capability_maximum_emails: a placeholder for the output #guint8, or %NULL if not required.
 * @email_capability_maximum_email_address_length: a placeholder for the output #guint8, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Email Capability' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_get_capabilities_output_get_email_capability (
    QmiMessagePbmGetCapabilitiesOutput *self,
    guint8 *email_capability_maximum_emails,
    guint8 *email_capability_maximum_email_address_length,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_email_capability_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Email Capability' was not found in the message");
        return FALSE;
    }

    if (email_capability_maximum_emails)
        *email_capability_maximum_emails = self->arg_email_capability_maximum_emails;
    if (email_capability_maximum_email_address_length)
        *email_capability_maximum_email_address_length = self->arg_email_capability_maximum_email_address_length;

    return TRUE;
}

/**
 * qmi_message_pbm_get_capabilities_output_get_second_name_capability:
 * @self: a #QmiMessagePbmGetCapabilitiesOutput.
 * @second_name_capability_maximum_second_name_length: a placeholder for the output #guint8, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Second Name Capability' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_get_capabilities_output_get_second_name_capability (
    QmiMessagePbmGetCapabilitiesOutput *self,
    guint8 *second_name_capability_maximum_second_name_length,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_second_name_capability_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Second Name Capability' was not found in the message");
        return FALSE;
    }

    if (second_name_capability_maximum_second_name_length)
        *second_name_capability_maximum_second_name_length = self->arg_second_name_capability_maximum_second_name_length;

    return TRUE;
}

/**
 * qmi_message_pbm_get_capabilities_output_get_hidden_records_capability:
 * @self: a #QmiMessagePbmGetCapabilitiesOutput.
 * @hidden_records_capability_supported: a placeholder for the output #gboolean, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Hidden Records Capability' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_get_capabilities_output_get_hidden_records_capability (
    QmiMessagePbmGetCapabilitiesOutput *self,
    gboolean *hidden_records_capability_supported,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_hidden_records_capability_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Hidden Records Capability' was not found in the message");
        return FALSE;
    }

    if (hidden_records_capability_supported)
        *hidden_records_capability_supported = (gboolean)(self->arg_hidden_records_capability_supported);

    return TRUE;
}

/**
 * qmi_message_pbm_get_capabilities_output_get_grouping_information_alpha_string_capability:
 * @self: a #QmiMessagePbmGetCapabilitiesOutput.
 * @grouping_information_alpha_string_capability_maximum_records: a placeholder for the output #guint8, or %NULL if not required.
 * @grouping_information_alpha_string_capability_used_records: a placeholder for the output #guint8, or %NULL if not required.
 * @grouping_information_alpha_string_capability_maximum_string_length: a placeholder for the output #guint8, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Grouping Information Alpha String Capability' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_get_capabilities_output_get_grouping_information_alpha_string_capability (
    QmiMessagePbmGetCapabilitiesOutput *self,
    guint8 *grouping_information_alpha_string_capability_maximum_records,
    guint8 *grouping_information_alpha_string_capability_used_records,
    guint8 *grouping_information_alpha_string_capability_maximum_string_length,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_grouping_information_alpha_string_capability_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Grouping Information Alpha String Capability' was not found in the message");
        return FALSE;
    }

    if (grouping_information_alpha_string_capability_maximum_records)
        *grouping_information_alpha_string_capability_maximum_records = self->arg_grouping_information_alpha_string_capability_maximum_records;
    if (grouping_information_alpha_string_capability_used_records)
        *grouping_information_alpha_string_capability_used_records = self->arg_grouping_information_alpha_string_capability_used_records;
    if (grouping_information_alpha_string_capability_maximum_string_length)
        *grouping_information_alpha_string_capability_maximum_string_length = self->arg_grouping_information_alpha_string_capability_maximum_string_length;

    return TRUE;
}

/**
 * qmi_message_pbm_get_capabilities_output_get_additional_number_alpha_string_capability:
 * @self: a #QmiMessagePbmGetCapabilitiesOutput.
 * @additional_number_alpha_string_capability_maximum_records: a placeholder for the output #guint8, or %NULL if not required.
 * @additional_number_alpha_string_capability_used_records: a placeholder for the output #guint8, or %NULL if not required.
 * @additional_number_alpha_string_capability_maximum_string_length: a placeholder for the output #guint8, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Additional Number Alpha String Capability' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_get_capabilities_output_get_additional_number_alpha_string_capability (
    QmiMessagePbmGetCapabilitiesOutput *self,
    guint8 *additional_number_alpha_string_capability_maximum_records,
    guint8 *additional_number_alpha_string_capability_used_records,
    guint8 *additional_number_alpha_string_capability_maximum_string_length,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_additional_number_alpha_string_capability_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Additional Number Alpha String Capability' was not found in the message");
        return FALSE;
    }

    if (additional_number_alpha_string_capability_maximum_records)
        *additional_number_alpha_string_capability_maximum_records = self->arg_additional_number_alpha_string_capability_maximum_records;
    if (additional_number_alpha_string_capability_used_records)
        *additional_number_alpha_string_capability_used_records = self->arg_additional_number_alpha_string_capability_used_records;
    if (additional_number_alpha_string_capability_maximum_string_length)
        *additional_number_alpha_string_capability_maximum_string_length = self->arg_additional_number_alpha_string_capability_maximum_string_length;

    return TRUE;
}

GType
qmi_message_pbm_get_capabilities_output_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessagePbmGetCapabilitiesOutput"),
                                          (GBoxedCopyFunc) qmi_message_pbm_get_capabilities_output_ref,
                                          (GBoxedFreeFunc) qmi_message_pbm_get_capabilities_output_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_pbm_get_capabilities_output_ref:
 * @self: a #QmiMessagePbmGetCapabilitiesOutput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessagePbmGetCapabilitiesOutput *
qmi_message_pbm_get_capabilities_output_ref (QmiMessagePbmGetCapabilitiesOutput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_pbm_get_capabilities_output_unref:
 * @self: a #QmiMessagePbmGetCapabilitiesOutput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_pbm_get_capabilities_output_unref (QmiMessagePbmGetCapabilitiesOutput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessagePbmGetCapabilitiesOutput, self);
    }
}

static gboolean
qmi_message_pbm_get_capabilities_input_phonebook_information_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;
    expected_len += 2;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Phonebook Information' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Phonebook Information' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_pbm_get_capabilities_input_phonebook_information_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_PBM_GET_CAPABILITIES_INPUT_TLV_PHONEBOOK_INFORMATION,
                                      &buffer_len);
    if (buffer && qmi_message_pbm_get_capabilities_input_phonebook_information_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " session_type = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_PBM_SESSION_TYPE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_pbm_session_type_get_string ((QmiPbmSessionType)tmp));
#elif defined  __QMI_PBM_SESSION_TYPE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_pbm_session_type_build_string_from_mask ((QmiPbmSessionType)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiPbmSessionType
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " phonebook_type = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

#if defined  __QMI_PBM_PHONEBOOK_TYPE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_pbm_phonebook_type_get_string ((QmiPbmPhonebookType)tmp));
#elif defined  __QMI_PBM_PHONEBOOK_TYPE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_pbm_phonebook_type_build_string_from_mask ((QmiPbmPhonebookType)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiPbmPhonebookType
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Phonebook Information' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_pbm_get_capabilities_output_capability_basic_information_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;
    expected_len += 2;
    expected_len += 2;
    expected_len += 2;
    expected_len += 1;
    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Capability Basic Information' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Capability Basic Information' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_pbm_get_capabilities_output_capability_basic_information_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_CAPABILITY_BASIC_INFORMATION,
                                      &buffer_len);
    if (buffer && qmi_message_pbm_get_capabilities_output_capability_basic_information_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " session_type = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_PBM_SESSION_TYPE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_pbm_session_type_get_string ((QmiPbmSessionType)tmp));
#elif defined  __QMI_PBM_SESSION_TYPE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_pbm_session_type_build_string_from_mask ((QmiPbmSessionType)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiPbmSessionType
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " phonebook_type = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

#if defined  __QMI_PBM_PHONEBOOK_TYPE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_pbm_phonebook_type_get_string ((QmiPbmPhonebookType)tmp));
#elif defined  __QMI_PBM_PHONEBOOK_TYPE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_pbm_phonebook_type_build_string_from_mask ((QmiPbmPhonebookType)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiPbmPhonebookType
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " used_records = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " maximum_records = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " maximum_number_length = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " maximum_name_length = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Capability Basic Information' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_pbm_get_capabilities_output_group_capability_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;
    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Group Capability' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Group Capability' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_pbm_get_capabilities_output_group_capability_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_GROUP_CAPABILITY,
                                      &buffer_len);
    if (buffer && qmi_message_pbm_get_capabilities_output_group_capability_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " maximum_groups = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " maximum_group_tag_length = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Group Capability' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_pbm_get_capabilities_output_additional_number_capability_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;
    expected_len += 1;
    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Additional Number Capability' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Additional Number Capability' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_pbm_get_capabilities_output_additional_number_capability_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_ADDITIONAL_NUMBER_CAPABILITY,
                                      &buffer_len);
    if (buffer && qmi_message_pbm_get_capabilities_output_additional_number_capability_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " maximum_additional_numbers = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " maximum_additional_number_length = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " maximum_additional_number_tag_length = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Additional Number Capability' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_pbm_get_capabilities_output_email_capability_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;
    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Email Capability' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Email Capability' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_pbm_get_capabilities_output_email_capability_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_EMAIL_CAPABILITY,
                                      &buffer_len);
    if (buffer && qmi_message_pbm_get_capabilities_output_email_capability_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " maximum_emails = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " maximum_email_address_length = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Email Capability' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_pbm_get_capabilities_output_second_name_capability_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Second Name Capability' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Second Name Capability' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_pbm_get_capabilities_output_second_name_capability_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_SECOND_NAME_CAPABILITY,
                                      &buffer_len);
    if (buffer && qmi_message_pbm_get_capabilities_output_second_name_capability_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " maximum_second_name_length = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Second Name Capability' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_pbm_get_capabilities_output_hidden_records_capability_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Hidden Records Capability' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Hidden Records Capability' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_pbm_get_capabilities_output_hidden_records_capability_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_HIDDEN_RECORDS_CAPABILITY,
                                      &buffer_len);
    if (buffer && qmi_message_pbm_get_capabilities_output_hidden_records_capability_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " supported = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%s", tmp ? "yes" : "no");
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Hidden Records Capability' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_pbm_get_capabilities_output_grouping_information_alpha_string_capability_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;
    expected_len += 1;
    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Grouping Information Alpha String Capability' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Grouping Information Alpha String Capability' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_pbm_get_capabilities_output_grouping_information_alpha_string_capability_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_GROUPING_INFORMATION_ALPHA_STRING_CAPABILITY,
                                      &buffer_len);
    if (buffer && qmi_message_pbm_get_capabilities_output_grouping_information_alpha_string_capability_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " maximum_records = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " used_records = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " maximum_string_length = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Grouping Information Alpha String Capability' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_pbm_get_capabilities_output_additional_number_alpha_string_capability_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;
    expected_len += 1;
    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Additional Number Alpha String Capability' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Additional Number Alpha String Capability' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_pbm_get_capabilities_output_additional_number_alpha_string_capability_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_ADDITIONAL_NUMBER_ALPHA_STRING_CAPABILITY,
                                      &buffer_len);
    if (buffer && qmi_message_pbm_get_capabilities_output_additional_number_alpha_string_capability_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " maximum_records = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " used_records = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " maximum_string_length = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Additional Number Alpha String Capability' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

struct message_get_capabilities_context {
    QmiMessage *self;
    const gchar *line_prefix;
    GString *printable;
};

static void
message_get_capabilities_get_tlv_printable (
    guint8 type,
    const guint8 *value,
    gsize length,
    struct message_get_capabilities_context *ctx)
{
    const gchar *tlv_type_str = NULL;
    gchar *translated_value;

    if (!qmi_message_is_response (ctx->self)) {
        switch (type) {
        case QMI_MESSAGE_PBM_GET_CAPABILITIES_INPUT_TLV_PHONEBOOK_INFORMATION:
            tlv_type_str = "Phonebook Information";
            translated_value = qmi_message_pbm_get_capabilities_input_phonebook_information_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    } else {
        switch (type) {
        case QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_RESULT:
            tlv_type_str = "Result";
            translated_value = qmi_message_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_CAPABILITY_BASIC_INFORMATION:
            tlv_type_str = "Capability Basic Information";
            translated_value = qmi_message_pbm_get_capabilities_output_capability_basic_information_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_GROUP_CAPABILITY:
            tlv_type_str = "Group Capability";
            translated_value = qmi_message_pbm_get_capabilities_output_group_capability_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_ADDITIONAL_NUMBER_CAPABILITY:
            tlv_type_str = "Additional Number Capability";
            translated_value = qmi_message_pbm_get_capabilities_output_additional_number_capability_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_EMAIL_CAPABILITY:
            tlv_type_str = "Email Capability";
            translated_value = qmi_message_pbm_get_capabilities_output_email_capability_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_SECOND_NAME_CAPABILITY:
            tlv_type_str = "Second Name Capability";
            translated_value = qmi_message_pbm_get_capabilities_output_second_name_capability_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_HIDDEN_RECORDS_CAPABILITY:
            tlv_type_str = "Hidden Records Capability";
            translated_value = qmi_message_pbm_get_capabilities_output_hidden_records_capability_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_GROUPING_INFORMATION_ALPHA_STRING_CAPABILITY:
            tlv_type_str = "Grouping Information Alpha String Capability";
            translated_value = qmi_message_pbm_get_capabilities_output_grouping_information_alpha_string_capability_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_ADDITIONAL_NUMBER_ALPHA_STRING_CAPABILITY:
            tlv_type_str = "Additional Number Alpha String Capability";
            translated_value = qmi_message_pbm_get_capabilities_output_additional_number_alpha_string_capability_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    }

    if (!tlv_type_str) {
        gchar *value_str = NULL;

        value_str = qmi_message_get_tlv_printable (ctx->self,
                                                   ctx->line_prefix,
                                                   type,
                                                   value,
                                                   length);
        g_string_append (ctx->printable, value_str);
        g_free (value_str);
    } else {
        gchar *value_hex;

        value_hex = __qmi_utils_str_hex (value, length, ':');
        g_string_append_printf (ctx->printable,
                                "%sTLV:\n"
                                "%s  type       = \"%s\" (0x%02x)\n"
                                "%s  length     = %" G_GSIZE_FORMAT "\n"
                                "%s  value      = %s\n"
                                "%s  translated = %s\n",
                                ctx->line_prefix,
                                ctx->line_prefix, tlv_type_str, type,
                                ctx->line_prefix, length,
                                ctx->line_prefix, value_hex,
                                ctx->line_prefix, translated_value ? translated_value : "");
        g_free (value_hex);
        g_free (translated_value);
    }
}

static gchar *
message_get_capabilities_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    GString *printable;

    printable = g_string_new ("");
    g_string_append_printf (printable,
                            "%s  message     = \"Get Capabilities\" (0x0002)\n",
                            line_prefix);

    {
        struct message_get_capabilities_context ctx;
        ctx.self = self;
        ctx.line_prefix = line_prefix;
        ctx.printable = printable;
        qmi_message_foreach_raw_tlv (self,
                                     (QmiMessageForeachRawTlvFn)message_get_capabilities_get_tlv_printable,
                                     &ctx);
    }

    return g_string_free (printable, FALSE);
}

static QmiMessagePbmGetCapabilitiesOutput *
__qmi_message_pbm_get_capabilities_response_parse (
    QmiMessage *message,
    GError **error)
{
    QmiMessagePbmGetCapabilitiesOutput *self;

    g_return_val_if_fail (qmi_message_get_message_id (message) == QMI_MESSAGE_PBM_GET_CAPABILITIES, NULL);

    self = g_slice_new0 (QmiMessagePbmGetCapabilitiesOutput);
    self->ref_count = 1;

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_result_validate (buffer, buffer_len)) {
                self->arg_result_set = TRUE;

                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_status));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_code));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Result' TLV", buffer_len);
                }
            } else {
                g_set_error (error,
                             QMI_CORE_ERROR,
                             QMI_CORE_ERROR_TLV_NOT_FOUND,
                             "Couldn't get the Result TLV: Not found");
                qmi_message_pbm_get_capabilities_output_unref (self);
                return NULL;
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_CAPABILITY_BASIC_INFORMATION,
                                              &buffer_len);
            if (buffer && qmi_message_pbm_get_capabilities_output_capability_basic_information_validate (buffer, buffer_len)) {
                self->arg_capability_basic_information_set = TRUE;

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_capability_basic_information_session_type = (QmiPbmSessionType)tmp;
                }
                {
                    guint16 tmp;

                    /* Read the guint16 variable from the buffer */
                    qmi_utils_read_guint16_from_buffer (
                        &buffer,
                        &buffer_len,
                        QMI_ENDIAN_LITTLE,
                        &tmp);
                    self->arg_capability_basic_information_phonebook_type = (QmiPbmPhonebookType)tmp;
                }
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_capability_basic_information_used_records));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_capability_basic_information_maximum_records));
                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_capability_basic_information_maximum_number_length));
                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_capability_basic_information_maximum_name_length));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Capability Basic Information' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_GROUP_CAPABILITY,
                                              &buffer_len);
            if (buffer && qmi_message_pbm_get_capabilities_output_group_capability_validate (buffer, buffer_len)) {
                self->arg_group_capability_set = TRUE;

                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_group_capability_maximum_groups));
                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_group_capability_maximum_group_tag_length));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Group Capability' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_ADDITIONAL_NUMBER_CAPABILITY,
                                              &buffer_len);
            if (buffer && qmi_message_pbm_get_capabilities_output_additional_number_capability_validate (buffer, buffer_len)) {
                self->arg_additional_number_capability_set = TRUE;

                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_additional_number_capability_maximum_additional_numbers));
                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_additional_number_capability_maximum_additional_number_length));
                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_additional_number_capability_maximum_additional_number_tag_length));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Additional Number Capability' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_EMAIL_CAPABILITY,
                                              &buffer_len);
            if (buffer && qmi_message_pbm_get_capabilities_output_email_capability_validate (buffer, buffer_len)) {
                self->arg_email_capability_set = TRUE;

                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_email_capability_maximum_emails));
                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_email_capability_maximum_email_address_length));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Email Capability' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_SECOND_NAME_CAPABILITY,
                                              &buffer_len);
            if (buffer && qmi_message_pbm_get_capabilities_output_second_name_capability_validate (buffer, buffer_len)) {
                self->arg_second_name_capability_set = TRUE;

                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_second_name_capability_maximum_second_name_length));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Second Name Capability' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_HIDDEN_RECORDS_CAPABILITY,
                                              &buffer_len);
            if (buffer && qmi_message_pbm_get_capabilities_output_hidden_records_capability_validate (buffer, buffer_len)) {
                self->arg_hidden_records_capability_set = TRUE;

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_hidden_records_capability_supported = (gboolean)tmp;
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Hidden Records Capability' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_GROUPING_INFORMATION_ALPHA_STRING_CAPABILITY,
                                              &buffer_len);
            if (buffer && qmi_message_pbm_get_capabilities_output_grouping_information_alpha_string_capability_validate (buffer, buffer_len)) {
                self->arg_grouping_information_alpha_string_capability_set = TRUE;

                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_grouping_information_alpha_string_capability_maximum_records));
                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_grouping_information_alpha_string_capability_used_records));
                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_grouping_information_alpha_string_capability_maximum_string_length));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Grouping Information Alpha String Capability' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_GET_CAPABILITIES_OUTPUT_TLV_ADDITIONAL_NUMBER_ALPHA_STRING_CAPABILITY,
                                              &buffer_len);
            if (buffer && qmi_message_pbm_get_capabilities_output_additional_number_alpha_string_capability_validate (buffer, buffer_len)) {
                self->arg_additional_number_alpha_string_capability_set = TRUE;

                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_additional_number_alpha_string_capability_maximum_records));
                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_additional_number_alpha_string_capability_used_records));
                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_additional_number_alpha_string_capability_maximum_string_length));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Additional Number Alpha String Capability' TLV", buffer_len);
                }
            }

        }
    } while (0);

    return self;
}

/*****************************************************************************/
/* REQUEST/RESPONSE: Qmi Message PBM Get All Capabilities */


/* --- Input -- */

/* Note: no fields in the Input container */

static QmiMessage *
__qmi_message_pbm_get_all_capabilities_request_create (
    guint8 transaction_id,
    guint8 cid,
    gpointer unused,
    GError **error)
{
    QmiMessage *self;

    self = qmi_message_new (QMI_SERVICE_PBM,
                            cid,
                            transaction_id,
                            QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES);

    return self;
}

/* --- Output -- */

static void
capability_basic_information_qmimessagepbmgetallcapabilitiesoutputcapabilitybasicinformationelement_clear (QmiMessagePbmGetAllCapabilitiesOutputCapabilityBasicInformationElement *p)
{
    if ((*p).phonebooks)
        g_array_unref ((*p).phonebooks);
}

struct _QmiMessagePbmGetAllCapabilitiesOutput {
    volatile gint ref_count;

    /* Result */
    gboolean arg_result_set;
    QmiMessageResult arg_result;

    /* Capability Basic Information */
    gboolean arg_capability_basic_information_set;
    GArray *arg_capability_basic_information;

    /* Group Capability */
    gboolean arg_group_capability_set;
    GArray *arg_group_capability;

    /* Additional Number Capability */
    gboolean arg_additional_number_capability_set;
    GArray *arg_additional_number_capability;

    /* Email Capability */
    gboolean arg_email_capability_set;
    GArray *arg_email_capability;

    /* Second Name Capability */
    gboolean arg_second_name_capability_set;
    GArray *arg_second_name_capability;

    /* Hidden Records Capability */
    gboolean arg_hidden_records_capability_set;
    GArray *arg_hidden_records_capability;

    /* Grouping Information Alpha String Capability */
    gboolean arg_grouping_information_alpha_string_capability_set;
    GArray *arg_grouping_information_alpha_string_capability;

    /* Additional Number Alpha String Capability */
    gboolean arg_additional_number_alpha_string_capability_set;
    GArray *arg_additional_number_alpha_string_capability;
};

#define QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_RESULT 0x02
#define QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_CAPABILITY_BASIC_INFORMATION 0x10
#define QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_GROUP_CAPABILITY 0x11
#define QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_ADDITIONAL_NUMBER_CAPABILITY 0x12
#define QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_EMAIL_CAPABILITY 0x13
#define QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_SECOND_NAME_CAPABILITY 0x14
#define QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_HIDDEN_RECORDS_CAPABILITY 0x15
#define QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_GROUPING_INFORMATION_ALPHA_STRING_CAPABILITY 0x16
#define QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_ADDITIONAL_NUMBER_ALPHA_STRING_CAPABILITY 0x17

/**
 * qmi_message_pbm_get_all_capabilities_output_get_result:
 * @self: a QmiMessagePbmGetAllCapabilitiesOutput.
 * @error: Return location for error or %NULL.
 *
 * Get the result of the QMI operation.
 *
 * Returns: %TRUE if the QMI operation succeeded, %FALSE if @error is set.
 */
gboolean
qmi_message_pbm_get_all_capabilities_output_get_result (
    QmiMessagePbmGetAllCapabilitiesOutput *self,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    /* We should always have a result set in the response message */
    if (!self->arg_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_MESSAGE,
                     "No 'Result' field given in the message");
        return FALSE;
    }

    if (self->arg_result.error_status == QMI_STATUS_SUCCESS) {
        /* Operation succeeded */
        return TRUE;
    }

    /* Report a QMI protocol error */
    g_set_error (error,
                 QMI_PROTOCOL_ERROR,
                 (QmiProtocolError) self->arg_result.error_code,
                 "QMI protocol error (%u): '%s'",
                 self->arg_result.error_code,
                 qmi_protocol_error_get_string ((QmiProtocolError) self->arg_result.error_code));
    return FALSE;
}

/**
 * qmi_message_pbm_get_all_capabilities_output_get_capability_basic_information:
 * @self: a #QmiMessagePbmGetAllCapabilitiesOutput.
 * @capability_basic_information: a placeholder for the output #GArray of #QmiMessagePbmGetAllCapabilitiesOutputCapabilityBasicInformationElement elements, or %NULL if not required. Do not free it, it is owned by @self.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Capability Basic Information' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_get_all_capabilities_output_get_capability_basic_information (
    QmiMessagePbmGetAllCapabilitiesOutput *self,
    GArray **capability_basic_information,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_capability_basic_information_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Capability Basic Information' was not found in the message");
        return FALSE;
    }

    if (capability_basic_information)
        *capability_basic_information = self->arg_capability_basic_information;

    return TRUE;
}

/**
 * qmi_message_pbm_get_all_capabilities_output_get_group_capability:
 * @self: a #QmiMessagePbmGetAllCapabilitiesOutput.
 * @group_capability: a placeholder for the output #GArray of #QmiMessagePbmGetAllCapabilitiesOutputGroupCapabilityElement elements, or %NULL if not required. Do not free it, it is owned by @self.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Group Capability' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_get_all_capabilities_output_get_group_capability (
    QmiMessagePbmGetAllCapabilitiesOutput *self,
    GArray **group_capability,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_group_capability_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Group Capability' was not found in the message");
        return FALSE;
    }

    if (group_capability)
        *group_capability = self->arg_group_capability;

    return TRUE;
}

/**
 * qmi_message_pbm_get_all_capabilities_output_get_additional_number_capability:
 * @self: a #QmiMessagePbmGetAllCapabilitiesOutput.
 * @additional_number_capability: a placeholder for the output #GArray of #QmiMessagePbmGetAllCapabilitiesOutputAdditionalNumberCapabilityElement elements, or %NULL if not required. Do not free it, it is owned by @self.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Additional Number Capability' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_get_all_capabilities_output_get_additional_number_capability (
    QmiMessagePbmGetAllCapabilitiesOutput *self,
    GArray **additional_number_capability,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_additional_number_capability_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Additional Number Capability' was not found in the message");
        return FALSE;
    }

    if (additional_number_capability)
        *additional_number_capability = self->arg_additional_number_capability;

    return TRUE;
}

/**
 * qmi_message_pbm_get_all_capabilities_output_get_email_capability:
 * @self: a #QmiMessagePbmGetAllCapabilitiesOutput.
 * @email_capability: a placeholder for the output #GArray of #QmiMessagePbmGetAllCapabilitiesOutputEmailCapabilityElement elements, or %NULL if not required. Do not free it, it is owned by @self.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Email Capability' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_get_all_capabilities_output_get_email_capability (
    QmiMessagePbmGetAllCapabilitiesOutput *self,
    GArray **email_capability,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_email_capability_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Email Capability' was not found in the message");
        return FALSE;
    }

    if (email_capability)
        *email_capability = self->arg_email_capability;

    return TRUE;
}

/**
 * qmi_message_pbm_get_all_capabilities_output_get_second_name_capability:
 * @self: a #QmiMessagePbmGetAllCapabilitiesOutput.
 * @second_name_capability: a placeholder for the output #GArray of #QmiMessagePbmGetAllCapabilitiesOutputSecondNameCapabilityElement elements, or %NULL if not required. Do not free it, it is owned by @self.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Second Name Capability' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_get_all_capabilities_output_get_second_name_capability (
    QmiMessagePbmGetAllCapabilitiesOutput *self,
    GArray **second_name_capability,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_second_name_capability_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Second Name Capability' was not found in the message");
        return FALSE;
    }

    if (second_name_capability)
        *second_name_capability = self->arg_second_name_capability;

    return TRUE;
}

/**
 * qmi_message_pbm_get_all_capabilities_output_get_hidden_records_capability:
 * @self: a #QmiMessagePbmGetAllCapabilitiesOutput.
 * @hidden_records_capability: a placeholder for the output #GArray of #QmiMessagePbmGetAllCapabilitiesOutputHiddenRecordsCapabilityElement elements, or %NULL if not required. Do not free it, it is owned by @self.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Hidden Records Capability' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_get_all_capabilities_output_get_hidden_records_capability (
    QmiMessagePbmGetAllCapabilitiesOutput *self,
    GArray **hidden_records_capability,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_hidden_records_capability_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Hidden Records Capability' was not found in the message");
        return FALSE;
    }

    if (hidden_records_capability)
        *hidden_records_capability = self->arg_hidden_records_capability;

    return TRUE;
}

/**
 * qmi_message_pbm_get_all_capabilities_output_get_grouping_information_alpha_string_capability:
 * @self: a #QmiMessagePbmGetAllCapabilitiesOutput.
 * @grouping_information_alpha_string_capability: a placeholder for the output #GArray of #QmiMessagePbmGetAllCapabilitiesOutputGroupingInformationAlphaStringCapabilityElement elements, or %NULL if not required. Do not free it, it is owned by @self.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Grouping Information Alpha String Capability' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_get_all_capabilities_output_get_grouping_information_alpha_string_capability (
    QmiMessagePbmGetAllCapabilitiesOutput *self,
    GArray **grouping_information_alpha_string_capability,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_grouping_information_alpha_string_capability_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Grouping Information Alpha String Capability' was not found in the message");
        return FALSE;
    }

    if (grouping_information_alpha_string_capability)
        *grouping_information_alpha_string_capability = self->arg_grouping_information_alpha_string_capability;

    return TRUE;
}

/**
 * qmi_message_pbm_get_all_capabilities_output_get_additional_number_alpha_string_capability:
 * @self: a #QmiMessagePbmGetAllCapabilitiesOutput.
 * @additional_number_alpha_string_capability: a placeholder for the output #GArray of #QmiMessagePbmGetAllCapabilitiesOutputAdditionalNumberAlphaStringCapabilityElement elements, or %NULL if not required. Do not free it, it is owned by @self.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Additional Number Alpha String Capability' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_pbm_get_all_capabilities_output_get_additional_number_alpha_string_capability (
    QmiMessagePbmGetAllCapabilitiesOutput *self,
    GArray **additional_number_alpha_string_capability,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_additional_number_alpha_string_capability_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Additional Number Alpha String Capability' was not found in the message");
        return FALSE;
    }

    if (additional_number_alpha_string_capability)
        *additional_number_alpha_string_capability = self->arg_additional_number_alpha_string_capability;

    return TRUE;
}

GType
qmi_message_pbm_get_all_capabilities_output_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessagePbmGetAllCapabilitiesOutput"),
                                          (GBoxedCopyFunc) qmi_message_pbm_get_all_capabilities_output_ref,
                                          (GBoxedFreeFunc) qmi_message_pbm_get_all_capabilities_output_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_pbm_get_all_capabilities_output_ref:
 * @self: a #QmiMessagePbmGetAllCapabilitiesOutput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessagePbmGetAllCapabilitiesOutput *
qmi_message_pbm_get_all_capabilities_output_ref (QmiMessagePbmGetAllCapabilitiesOutput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_pbm_get_all_capabilities_output_unref:
 * @self: a #QmiMessagePbmGetAllCapabilitiesOutput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_pbm_get_all_capabilities_output_unref (QmiMessagePbmGetAllCapabilitiesOutput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        if (self->arg_capability_basic_information)
            g_array_unref (self->arg_capability_basic_information);
        if (self->arg_group_capability)
            g_array_unref (self->arg_group_capability);
        if (self->arg_additional_number_capability)
            g_array_unref (self->arg_additional_number_capability);
        if (self->arg_email_capability)
            g_array_unref (self->arg_email_capability);
        if (self->arg_second_name_capability)
            g_array_unref (self->arg_second_name_capability);
        if (self->arg_hidden_records_capability)
            g_array_unref (self->arg_hidden_records_capability);
        if (self->arg_grouping_information_alpha_string_capability)
            g_array_unref (self->arg_grouping_information_alpha_string_capability);
        if (self->arg_additional_number_alpha_string_capability)
            g_array_unref (self->arg_additional_number_alpha_string_capability);
        g_slice_free (QmiMessagePbmGetAllCapabilitiesOutput, self);
    }
}

static gboolean
qmi_message_pbm_get_all_capabilities_output_capability_basic_information_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    {
        guint capability_basic_information_i;

        guint8 capability_basic_information_n_items;
        const guint8 *capability_basic_information_aux_buffer = &buffer[expected_len];
        guint16 capability_basic_information_aux_buffer_len;

        capability_basic_information_aux_buffer_len = ((buffer_len >= expected_len) ? buffer_len - expected_len : 0);
        if (capability_basic_information_aux_buffer_len < 1) {
            g_warning ("Cannot read the array size: expected '%u' bytes, but only got '%u' bytes",
                       1, capability_basic_information_aux_buffer_len);
            return FALSE;
        }

        expected_len += 1;
        /* Read the guint8 variable from the buffer */
        qmi_utils_read_guint8_from_buffer (
            &capability_basic_information_aux_buffer,
            &capability_basic_information_aux_buffer_len,
            &(capability_basic_information_n_items));

        for (capability_basic_information_i = 0; capability_basic_information_i < capability_basic_information_n_items; capability_basic_information_i++) {

            expected_len += 1;
            {
                guint phonebooks_i;

                guint8 phonebooks_n_items;
                const guint8 *phonebooks_aux_buffer = &buffer[expected_len];
                guint16 phonebooks_aux_buffer_len;

                phonebooks_aux_buffer_len = ((buffer_len >= expected_len) ? buffer_len - expected_len : 0);
                if (phonebooks_aux_buffer_len < 1) {
                    g_warning ("Cannot read the array size: expected '%u' bytes, but only got '%u' bytes",
                               1, phonebooks_aux_buffer_len);
                    return FALSE;
                }

                expected_len += 1;
                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &phonebooks_aux_buffer,
                    &phonebooks_aux_buffer_len,
                    &(phonebooks_n_items));

                for (phonebooks_i = 0; phonebooks_i < phonebooks_n_items; phonebooks_i++) {

                    expected_len += 2;
                    expected_len += 2;
                    expected_len += 2;
                    expected_len += 1;
                    expected_len += 1;
                }
            }
        }
    }

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Capability Basic Information' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Capability Basic Information' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_pbm_get_all_capabilities_output_capability_basic_information_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_CAPABILITY_BASIC_INFORMATION,
                                      &buffer_len);
    if (buffer && qmi_message_pbm_get_all_capabilities_output_capability_basic_information_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        {
            guint capability_basic_information_i;
            guint8 capability_basic_information_n_items;

            /* Read number of items in the array */
            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &(capability_basic_information_n_items));

            g_string_append (printable, "{");

            for (capability_basic_information_i = 0; capability_basic_information_i < capability_basic_information_n_items; capability_basic_information_i++) {
                g_string_append_printf (printable, " [%u] = '", capability_basic_information_i);
                g_string_append (printable, "[");
                g_string_append (printable, " session_type = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

#if defined  __QMI_PBM_SESSION_TYPE_IS_ENUM__
                    g_string_append_printf (printable, "%s", qmi_pbm_session_type_get_string ((QmiPbmSessionType)tmp));
#elif defined  __QMI_PBM_SESSION_TYPE_IS_FLAGS__
                    {
                        gchar *flags_str;

                        flags_str = qmi_pbm_session_type_build_string_from_mask ((QmiPbmSessionType)tmp);
                        g_string_append_printf (printable, "%s", flags_str);
                        g_free (flags_str);
                    }
#else
# error unexpected public format: QmiPbmSessionType
#endif
                }
                g_string_append (printable, "'");
                g_string_append (printable, " phonebooks = '");
                {
                    guint phonebooks_i;
                    guint8 phonebooks_n_items;

                    /* Read number of items in the array */
                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &(phonebooks_n_items));

                    g_string_append (printable, "{");

                    for (phonebooks_i = 0; phonebooks_i < phonebooks_n_items; phonebooks_i++) {
                        g_string_append_printf (printable, " [%u] = '", phonebooks_i);
                        g_string_append (printable, "[");
                        g_string_append (printable, " phonebook_type = '");

                        {
                            guint16 tmp;

                            /* Read the guint16 variable from the buffer */
                            qmi_utils_read_guint16_from_buffer (
                                &buffer,
                                &buffer_len,
                                QMI_ENDIAN_LITTLE,
                                &tmp);

#if defined  __QMI_PBM_PHONEBOOK_TYPE_IS_ENUM__
                            g_string_append_printf (printable, "%s", qmi_pbm_phonebook_type_get_string ((QmiPbmPhonebookType)tmp));
#elif defined  __QMI_PBM_PHONEBOOK_TYPE_IS_FLAGS__
                            {
                                gchar *flags_str;

                                flags_str = qmi_pbm_phonebook_type_build_string_from_mask ((QmiPbmPhonebookType)tmp);
                                g_string_append_printf (printable, "%s", flags_str);
                                g_free (flags_str);
                            }
#else
# error unexpected public format: QmiPbmPhonebookType
#endif
                        }
                        g_string_append (printable, "'");
                        g_string_append (printable, " used_records = '");

                        {
                            guint16 tmp;

                            /* Read the guint16 variable from the buffer */
                            qmi_utils_read_guint16_from_buffer (
                                &buffer,
                                &buffer_len,
                                QMI_ENDIAN_LITTLE,
                                &tmp);

                            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
                        }
                        g_string_append (printable, "'");
                        g_string_append (printable, " maximum_records = '");

                        {
                            guint16 tmp;

                            /* Read the guint16 variable from the buffer */
                            qmi_utils_read_guint16_from_buffer (
                                &buffer,
                                &buffer_len,
                                QMI_ENDIAN_LITTLE,
                                &tmp);

                            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
                        }
                        g_string_append (printable, "'");
                        g_string_append (printable, " maximum_number_length = '");

                        {
                            guint8 tmp;

                            /* Read the guint8 variable from the buffer */
                            qmi_utils_read_guint8_from_buffer (
                                &buffer,
                                &buffer_len,
                                &tmp);

                            g_string_append_printf (printable, "%u", (guint)tmp);
                        }
                        g_string_append (printable, "'");
                        g_string_append (printable, " maximum_name_length = '");

                        {
                            guint8 tmp;

                            /* Read the guint8 variable from the buffer */
                            qmi_utils_read_guint8_from_buffer (
                                &buffer,
                                &buffer_len,
                                &tmp);

                            g_string_append_printf (printable, "%u", (guint)tmp);
                        }
                        g_string_append (printable, "'");
                        g_string_append (printable, " ]");
                        g_string_append (printable, " '");
                    }

                    g_string_append (printable, "}");
                }                g_string_append (printable, "'");
                g_string_append (printable, " ]");
                g_string_append (printable, " '");
            }

            g_string_append (printable, "}");
        }
        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Capability Basic Information' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_pbm_get_all_capabilities_output_group_capability_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    {
        guint group_capability_i;

        guint8 group_capability_n_items;
        const guint8 *group_capability_aux_buffer = &buffer[expected_len];
        guint16 group_capability_aux_buffer_len;

        group_capability_aux_buffer_len = ((buffer_len >= expected_len) ? buffer_len - expected_len : 0);
        if (group_capability_aux_buffer_len < 1) {
            g_warning ("Cannot read the array size: expected '%u' bytes, but only got '%u' bytes",
                       1, group_capability_aux_buffer_len);
            return FALSE;
        }

        expected_len += 1;
        /* Read the guint8 variable from the buffer */
        qmi_utils_read_guint8_from_buffer (
            &group_capability_aux_buffer,
            &group_capability_aux_buffer_len,
            &(group_capability_n_items));

        for (group_capability_i = 0; group_capability_i < group_capability_n_items; group_capability_i++) {

            expected_len += 1;
            expected_len += 1;
            expected_len += 1;
        }
    }

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Group Capability' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Group Capability' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_pbm_get_all_capabilities_output_group_capability_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_GROUP_CAPABILITY,
                                      &buffer_len);
    if (buffer && qmi_message_pbm_get_all_capabilities_output_group_capability_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        {
            guint group_capability_i;
            guint8 group_capability_n_items;

            /* Read number of items in the array */
            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &(group_capability_n_items));

            g_string_append (printable, "{");

            for (group_capability_i = 0; group_capability_i < group_capability_n_items; group_capability_i++) {
                g_string_append_printf (printable, " [%u] = '", group_capability_i);
                g_string_append (printable, "[");
                g_string_append (printable, " session_type = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

#if defined  __QMI_PBM_SESSION_TYPE_IS_ENUM__
                    g_string_append_printf (printable, "%s", qmi_pbm_session_type_get_string ((QmiPbmSessionType)tmp));
#elif defined  __QMI_PBM_SESSION_TYPE_IS_FLAGS__
                    {
                        gchar *flags_str;

                        flags_str = qmi_pbm_session_type_build_string_from_mask ((QmiPbmSessionType)tmp);
                        g_string_append_printf (printable, "%s", flags_str);
                        g_free (flags_str);
                    }
#else
# error unexpected public format: QmiPbmSessionType
#endif
                }
                g_string_append (printable, "'");
                g_string_append (printable, " maximum_groups = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, "'");
                g_string_append (printable, " maximum_group_tag_length = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, "'");
                g_string_append (printable, " ]");
                g_string_append (printable, " '");
            }

            g_string_append (printable, "}");
        }
        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Group Capability' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_pbm_get_all_capabilities_output_additional_number_capability_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    {
        guint additional_number_capability_i;

        guint8 additional_number_capability_n_items;
        const guint8 *additional_number_capability_aux_buffer = &buffer[expected_len];
        guint16 additional_number_capability_aux_buffer_len;

        additional_number_capability_aux_buffer_len = ((buffer_len >= expected_len) ? buffer_len - expected_len : 0);
        if (additional_number_capability_aux_buffer_len < 1) {
            g_warning ("Cannot read the array size: expected '%u' bytes, but only got '%u' bytes",
                       1, additional_number_capability_aux_buffer_len);
            return FALSE;
        }

        expected_len += 1;
        /* Read the guint8 variable from the buffer */
        qmi_utils_read_guint8_from_buffer (
            &additional_number_capability_aux_buffer,
            &additional_number_capability_aux_buffer_len,
            &(additional_number_capability_n_items));

        for (additional_number_capability_i = 0; additional_number_capability_i < additional_number_capability_n_items; additional_number_capability_i++) {

            expected_len += 1;
            expected_len += 1;
            expected_len += 1;
            expected_len += 1;
        }
    }

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Additional Number Capability' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Additional Number Capability' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_pbm_get_all_capabilities_output_additional_number_capability_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_ADDITIONAL_NUMBER_CAPABILITY,
                                      &buffer_len);
    if (buffer && qmi_message_pbm_get_all_capabilities_output_additional_number_capability_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        {
            guint additional_number_capability_i;
            guint8 additional_number_capability_n_items;

            /* Read number of items in the array */
            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &(additional_number_capability_n_items));

            g_string_append (printable, "{");

            for (additional_number_capability_i = 0; additional_number_capability_i < additional_number_capability_n_items; additional_number_capability_i++) {
                g_string_append_printf (printable, " [%u] = '", additional_number_capability_i);
                g_string_append (printable, "[");
                g_string_append (printable, " session_type = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

#if defined  __QMI_PBM_SESSION_TYPE_IS_ENUM__
                    g_string_append_printf (printable, "%s", qmi_pbm_session_type_get_string ((QmiPbmSessionType)tmp));
#elif defined  __QMI_PBM_SESSION_TYPE_IS_FLAGS__
                    {
                        gchar *flags_str;

                        flags_str = qmi_pbm_session_type_build_string_from_mask ((QmiPbmSessionType)tmp);
                        g_string_append_printf (printable, "%s", flags_str);
                        g_free (flags_str);
                    }
#else
# error unexpected public format: QmiPbmSessionType
#endif
                }
                g_string_append (printable, "'");
                g_string_append (printable, " maximum_additional_numbers = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, "'");
                g_string_append (printable, " maximum_additional_number_length = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, "'");
                g_string_append (printable, " maximum_additional_number_tag_length = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, "'");
                g_string_append (printable, " ]");
                g_string_append (printable, " '");
            }

            g_string_append (printable, "}");
        }
        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Additional Number Capability' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_pbm_get_all_capabilities_output_email_capability_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    {
        guint email_capability_i;

        guint8 email_capability_n_items;
        const guint8 *email_capability_aux_buffer = &buffer[expected_len];
        guint16 email_capability_aux_buffer_len;

        email_capability_aux_buffer_len = ((buffer_len >= expected_len) ? buffer_len - expected_len : 0);
        if (email_capability_aux_buffer_len < 1) {
            g_warning ("Cannot read the array size: expected '%u' bytes, but only got '%u' bytes",
                       1, email_capability_aux_buffer_len);
            return FALSE;
        }

        expected_len += 1;
        /* Read the guint8 variable from the buffer */
        qmi_utils_read_guint8_from_buffer (
            &email_capability_aux_buffer,
            &email_capability_aux_buffer_len,
            &(email_capability_n_items));

        for (email_capability_i = 0; email_capability_i < email_capability_n_items; email_capability_i++) {

            expected_len += 1;
            expected_len += 1;
            expected_len += 1;
        }
    }

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Email Capability' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Email Capability' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_pbm_get_all_capabilities_output_email_capability_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_EMAIL_CAPABILITY,
                                      &buffer_len);
    if (buffer && qmi_message_pbm_get_all_capabilities_output_email_capability_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        {
            guint email_capability_i;
            guint8 email_capability_n_items;

            /* Read number of items in the array */
            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &(email_capability_n_items));

            g_string_append (printable, "{");

            for (email_capability_i = 0; email_capability_i < email_capability_n_items; email_capability_i++) {
                g_string_append_printf (printable, " [%u] = '", email_capability_i);
                g_string_append (printable, "[");
                g_string_append (printable, " session_type = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

#if defined  __QMI_PBM_SESSION_TYPE_IS_ENUM__
                    g_string_append_printf (printable, "%s", qmi_pbm_session_type_get_string ((QmiPbmSessionType)tmp));
#elif defined  __QMI_PBM_SESSION_TYPE_IS_FLAGS__
                    {
                        gchar *flags_str;

                        flags_str = qmi_pbm_session_type_build_string_from_mask ((QmiPbmSessionType)tmp);
                        g_string_append_printf (printable, "%s", flags_str);
                        g_free (flags_str);
                    }
#else
# error unexpected public format: QmiPbmSessionType
#endif
                }
                g_string_append (printable, "'");
                g_string_append (printable, " maximum_emails = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, "'");
                g_string_append (printable, " maximum_email_address_length = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, "'");
                g_string_append (printable, " ]");
                g_string_append (printable, " '");
            }

            g_string_append (printable, "}");
        }
        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Email Capability' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_pbm_get_all_capabilities_output_second_name_capability_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    {
        guint second_name_capability_i;

        guint8 second_name_capability_n_items;
        const guint8 *second_name_capability_aux_buffer = &buffer[expected_len];
        guint16 second_name_capability_aux_buffer_len;

        second_name_capability_aux_buffer_len = ((buffer_len >= expected_len) ? buffer_len - expected_len : 0);
        if (second_name_capability_aux_buffer_len < 1) {
            g_warning ("Cannot read the array size: expected '%u' bytes, but only got '%u' bytes",
                       1, second_name_capability_aux_buffer_len);
            return FALSE;
        }

        expected_len += 1;
        /* Read the guint8 variable from the buffer */
        qmi_utils_read_guint8_from_buffer (
            &second_name_capability_aux_buffer,
            &second_name_capability_aux_buffer_len,
            &(second_name_capability_n_items));

        for (second_name_capability_i = 0; second_name_capability_i < second_name_capability_n_items; second_name_capability_i++) {

            expected_len += 1;
            expected_len += 1;
        }
    }

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Second Name Capability' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Second Name Capability' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_pbm_get_all_capabilities_output_second_name_capability_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_SECOND_NAME_CAPABILITY,
                                      &buffer_len);
    if (buffer && qmi_message_pbm_get_all_capabilities_output_second_name_capability_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        {
            guint second_name_capability_i;
            guint8 second_name_capability_n_items;

            /* Read number of items in the array */
            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &(second_name_capability_n_items));

            g_string_append (printable, "{");

            for (second_name_capability_i = 0; second_name_capability_i < second_name_capability_n_items; second_name_capability_i++) {
                g_string_append_printf (printable, " [%u] = '", second_name_capability_i);
                g_string_append (printable, "[");
                g_string_append (printable, " session_type = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

#if defined  __QMI_PBM_SESSION_TYPE_IS_ENUM__
                    g_string_append_printf (printable, "%s", qmi_pbm_session_type_get_string ((QmiPbmSessionType)tmp));
#elif defined  __QMI_PBM_SESSION_TYPE_IS_FLAGS__
                    {
                        gchar *flags_str;

                        flags_str = qmi_pbm_session_type_build_string_from_mask ((QmiPbmSessionType)tmp);
                        g_string_append_printf (printable, "%s", flags_str);
                        g_free (flags_str);
                    }
#else
# error unexpected public format: QmiPbmSessionType
#endif
                }
                g_string_append (printable, "'");
                g_string_append (printable, " maximum_second_name_length = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, "'");
                g_string_append (printable, " ]");
                g_string_append (printable, " '");
            }

            g_string_append (printable, "}");
        }
        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Second Name Capability' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_pbm_get_all_capabilities_output_hidden_records_capability_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    {
        guint hidden_records_capability_i;

        guint8 hidden_records_capability_n_items;
        const guint8 *hidden_records_capability_aux_buffer = &buffer[expected_len];
        guint16 hidden_records_capability_aux_buffer_len;

        hidden_records_capability_aux_buffer_len = ((buffer_len >= expected_len) ? buffer_len - expected_len : 0);
        if (hidden_records_capability_aux_buffer_len < 1) {
            g_warning ("Cannot read the array size: expected '%u' bytes, but only got '%u' bytes",
                       1, hidden_records_capability_aux_buffer_len);
            return FALSE;
        }

        expected_len += 1;
        /* Read the guint8 variable from the buffer */
        qmi_utils_read_guint8_from_buffer (
            &hidden_records_capability_aux_buffer,
            &hidden_records_capability_aux_buffer_len,
            &(hidden_records_capability_n_items));

        for (hidden_records_capability_i = 0; hidden_records_capability_i < hidden_records_capability_n_items; hidden_records_capability_i++) {

            expected_len += 1;
            expected_len += 1;
        }
    }

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Hidden Records Capability' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Hidden Records Capability' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_pbm_get_all_capabilities_output_hidden_records_capability_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_HIDDEN_RECORDS_CAPABILITY,
                                      &buffer_len);
    if (buffer && qmi_message_pbm_get_all_capabilities_output_hidden_records_capability_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        {
            guint hidden_records_capability_i;
            guint8 hidden_records_capability_n_items;

            /* Read number of items in the array */
            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &(hidden_records_capability_n_items));

            g_string_append (printable, "{");

            for (hidden_records_capability_i = 0; hidden_records_capability_i < hidden_records_capability_n_items; hidden_records_capability_i++) {
                g_string_append_printf (printable, " [%u] = '", hidden_records_capability_i);
                g_string_append (printable, "[");
                g_string_append (printable, " session_type = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

#if defined  __QMI_PBM_SESSION_TYPE_IS_ENUM__
                    g_string_append_printf (printable, "%s", qmi_pbm_session_type_get_string ((QmiPbmSessionType)tmp));
#elif defined  __QMI_PBM_SESSION_TYPE_IS_FLAGS__
                    {
                        gchar *flags_str;

                        flags_str = qmi_pbm_session_type_build_string_from_mask ((QmiPbmSessionType)tmp);
                        g_string_append_printf (printable, "%s", flags_str);
                        g_free (flags_str);
                    }
#else
# error unexpected public format: QmiPbmSessionType
#endif
                }
                g_string_append (printable, "'");
                g_string_append (printable, " supported = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%s", tmp ? "yes" : "no");
                }
                g_string_append (printable, "'");
                g_string_append (printable, " ]");
                g_string_append (printable, " '");
            }

            g_string_append (printable, "}");
        }
        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Hidden Records Capability' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_pbm_get_all_capabilities_output_grouping_information_alpha_string_capability_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    {
        guint grouping_information_alpha_string_capability_i;

        guint8 grouping_information_alpha_string_capability_n_items;
        const guint8 *grouping_information_alpha_string_capability_aux_buffer = &buffer[expected_len];
        guint16 grouping_information_alpha_string_capability_aux_buffer_len;

        grouping_information_alpha_string_capability_aux_buffer_len = ((buffer_len >= expected_len) ? buffer_len - expected_len : 0);
        if (grouping_information_alpha_string_capability_aux_buffer_len < 1) {
            g_warning ("Cannot read the array size: expected '%u' bytes, but only got '%u' bytes",
                       1, grouping_information_alpha_string_capability_aux_buffer_len);
            return FALSE;
        }

        expected_len += 1;
        /* Read the guint8 variable from the buffer */
        qmi_utils_read_guint8_from_buffer (
            &grouping_information_alpha_string_capability_aux_buffer,
            &grouping_information_alpha_string_capability_aux_buffer_len,
            &(grouping_information_alpha_string_capability_n_items));

        for (grouping_information_alpha_string_capability_i = 0; grouping_information_alpha_string_capability_i < grouping_information_alpha_string_capability_n_items; grouping_information_alpha_string_capability_i++) {

            expected_len += 1;
            expected_len += 1;
            expected_len += 1;
            expected_len += 1;
        }
    }

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Grouping Information Alpha String Capability' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Grouping Information Alpha String Capability' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_pbm_get_all_capabilities_output_grouping_information_alpha_string_capability_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_GROUPING_INFORMATION_ALPHA_STRING_CAPABILITY,
                                      &buffer_len);
    if (buffer && qmi_message_pbm_get_all_capabilities_output_grouping_information_alpha_string_capability_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        {
            guint grouping_information_alpha_string_capability_i;
            guint8 grouping_information_alpha_string_capability_n_items;

            /* Read number of items in the array */
            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &(grouping_information_alpha_string_capability_n_items));

            g_string_append (printable, "{");

            for (grouping_information_alpha_string_capability_i = 0; grouping_information_alpha_string_capability_i < grouping_information_alpha_string_capability_n_items; grouping_information_alpha_string_capability_i++) {
                g_string_append_printf (printable, " [%u] = '", grouping_information_alpha_string_capability_i);
                g_string_append (printable, "[");
                g_string_append (printable, " session_type = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

#if defined  __QMI_PBM_SESSION_TYPE_IS_ENUM__
                    g_string_append_printf (printable, "%s", qmi_pbm_session_type_get_string ((QmiPbmSessionType)tmp));
#elif defined  __QMI_PBM_SESSION_TYPE_IS_FLAGS__
                    {
                        gchar *flags_str;

                        flags_str = qmi_pbm_session_type_build_string_from_mask ((QmiPbmSessionType)tmp);
                        g_string_append_printf (printable, "%s", flags_str);
                        g_free (flags_str);
                    }
#else
# error unexpected public format: QmiPbmSessionType
#endif
                }
                g_string_append (printable, "'");
                g_string_append (printable, " maximum_records = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, "'");
                g_string_append (printable, " used_records = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, "'");
                g_string_append (printable, " maximum_string_length = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, "'");
                g_string_append (printable, " ]");
                g_string_append (printable, " '");
            }

            g_string_append (printable, "}");
        }
        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Grouping Information Alpha String Capability' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_pbm_get_all_capabilities_output_additional_number_alpha_string_capability_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    {
        guint additional_number_alpha_string_capability_i;

        guint8 additional_number_alpha_string_capability_n_items;
        const guint8 *additional_number_alpha_string_capability_aux_buffer = &buffer[expected_len];
        guint16 additional_number_alpha_string_capability_aux_buffer_len;

        additional_number_alpha_string_capability_aux_buffer_len = ((buffer_len >= expected_len) ? buffer_len - expected_len : 0);
        if (additional_number_alpha_string_capability_aux_buffer_len < 1) {
            g_warning ("Cannot read the array size: expected '%u' bytes, but only got '%u' bytes",
                       1, additional_number_alpha_string_capability_aux_buffer_len);
            return FALSE;
        }

        expected_len += 1;
        /* Read the guint8 variable from the buffer */
        qmi_utils_read_guint8_from_buffer (
            &additional_number_alpha_string_capability_aux_buffer,
            &additional_number_alpha_string_capability_aux_buffer_len,
            &(additional_number_alpha_string_capability_n_items));

        for (additional_number_alpha_string_capability_i = 0; additional_number_alpha_string_capability_i < additional_number_alpha_string_capability_n_items; additional_number_alpha_string_capability_i++) {

            expected_len += 1;
            expected_len += 1;
            expected_len += 1;
            expected_len += 1;
        }
    }

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Additional Number Alpha String Capability' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Additional Number Alpha String Capability' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_pbm_get_all_capabilities_output_additional_number_alpha_string_capability_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_ADDITIONAL_NUMBER_ALPHA_STRING_CAPABILITY,
                                      &buffer_len);
    if (buffer && qmi_message_pbm_get_all_capabilities_output_additional_number_alpha_string_capability_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        {
            guint additional_number_alpha_string_capability_i;
            guint8 additional_number_alpha_string_capability_n_items;

            /* Read number of items in the array */
            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &(additional_number_alpha_string_capability_n_items));

            g_string_append (printable, "{");

            for (additional_number_alpha_string_capability_i = 0; additional_number_alpha_string_capability_i < additional_number_alpha_string_capability_n_items; additional_number_alpha_string_capability_i++) {
                g_string_append_printf (printable, " [%u] = '", additional_number_alpha_string_capability_i);
                g_string_append (printable, "[");
                g_string_append (printable, " session_type = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

#if defined  __QMI_PBM_SESSION_TYPE_IS_ENUM__
                    g_string_append_printf (printable, "%s", qmi_pbm_session_type_get_string ((QmiPbmSessionType)tmp));
#elif defined  __QMI_PBM_SESSION_TYPE_IS_FLAGS__
                    {
                        gchar *flags_str;

                        flags_str = qmi_pbm_session_type_build_string_from_mask ((QmiPbmSessionType)tmp);
                        g_string_append_printf (printable, "%s", flags_str);
                        g_free (flags_str);
                    }
#else
# error unexpected public format: QmiPbmSessionType
#endif
                }
                g_string_append (printable, "'");
                g_string_append (printable, " maximum_records = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, "'");
                g_string_append (printable, " used_records = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, "'");
                g_string_append (printable, " maximum_string_length = '");

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, "'");
                g_string_append (printable, " ]");
                g_string_append (printable, " '");
            }

            g_string_append (printable, "}");
        }
        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Additional Number Alpha String Capability' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

struct message_get_all_capabilities_context {
    QmiMessage *self;
    const gchar *line_prefix;
    GString *printable;
};

static void
message_get_all_capabilities_get_tlv_printable (
    guint8 type,
    const guint8 *value,
    gsize length,
    struct message_get_all_capabilities_context *ctx)
{
    const gchar *tlv_type_str = NULL;
    gchar *translated_value;

    if (!qmi_message_is_response (ctx->self)) {
        switch (type) {
        default:
            break;
        }
    } else {
        switch (type) {
        case QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_RESULT:
            tlv_type_str = "Result";
            translated_value = qmi_message_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_CAPABILITY_BASIC_INFORMATION:
            tlv_type_str = "Capability Basic Information";
            translated_value = qmi_message_pbm_get_all_capabilities_output_capability_basic_information_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_GROUP_CAPABILITY:
            tlv_type_str = "Group Capability";
            translated_value = qmi_message_pbm_get_all_capabilities_output_group_capability_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_ADDITIONAL_NUMBER_CAPABILITY:
            tlv_type_str = "Additional Number Capability";
            translated_value = qmi_message_pbm_get_all_capabilities_output_additional_number_capability_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_EMAIL_CAPABILITY:
            tlv_type_str = "Email Capability";
            translated_value = qmi_message_pbm_get_all_capabilities_output_email_capability_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_SECOND_NAME_CAPABILITY:
            tlv_type_str = "Second Name Capability";
            translated_value = qmi_message_pbm_get_all_capabilities_output_second_name_capability_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_HIDDEN_RECORDS_CAPABILITY:
            tlv_type_str = "Hidden Records Capability";
            translated_value = qmi_message_pbm_get_all_capabilities_output_hidden_records_capability_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_GROUPING_INFORMATION_ALPHA_STRING_CAPABILITY:
            tlv_type_str = "Grouping Information Alpha String Capability";
            translated_value = qmi_message_pbm_get_all_capabilities_output_grouping_information_alpha_string_capability_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_ADDITIONAL_NUMBER_ALPHA_STRING_CAPABILITY:
            tlv_type_str = "Additional Number Alpha String Capability";
            translated_value = qmi_message_pbm_get_all_capabilities_output_additional_number_alpha_string_capability_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    }

    if (!tlv_type_str) {
        gchar *value_str = NULL;

        value_str = qmi_message_get_tlv_printable (ctx->self,
                                                   ctx->line_prefix,
                                                   type,
                                                   value,
                                                   length);
        g_string_append (ctx->printable, value_str);
        g_free (value_str);
    } else {
        gchar *value_hex;

        value_hex = __qmi_utils_str_hex (value, length, ':');
        g_string_append_printf (ctx->printable,
                                "%sTLV:\n"
                                "%s  type       = \"%s\" (0x%02x)\n"
                                "%s  length     = %" G_GSIZE_FORMAT "\n"
                                "%s  value      = %s\n"
                                "%s  translated = %s\n",
                                ctx->line_prefix,
                                ctx->line_prefix, tlv_type_str, type,
                                ctx->line_prefix, length,
                                ctx->line_prefix, value_hex,
                                ctx->line_prefix, translated_value ? translated_value : "");
        g_free (value_hex);
        g_free (translated_value);
    }
}

static gchar *
message_get_all_capabilities_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    GString *printable;

    printable = g_string_new ("");
    g_string_append_printf (printable,
                            "%s  message     = \"Get All Capabilities\" (0x0003)\n",
                            line_prefix);

    {
        struct message_get_all_capabilities_context ctx;
        ctx.self = self;
        ctx.line_prefix = line_prefix;
        ctx.printable = printable;
        qmi_message_foreach_raw_tlv (self,
                                     (QmiMessageForeachRawTlvFn)message_get_all_capabilities_get_tlv_printable,
                                     &ctx);
    }

    return g_string_free (printable, FALSE);
}

static QmiMessagePbmGetAllCapabilitiesOutput *
__qmi_message_pbm_get_all_capabilities_response_parse (
    QmiMessage *message,
    GError **error)
{
    QmiMessagePbmGetAllCapabilitiesOutput *self;

    g_return_val_if_fail (qmi_message_get_message_id (message) == QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES, NULL);

    self = g_slice_new0 (QmiMessagePbmGetAllCapabilitiesOutput);
    self->ref_count = 1;

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_result_validate (buffer, buffer_len)) {
                self->arg_result_set = TRUE;

                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_status));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_code));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Result' TLV", buffer_len);
                }
            } else {
                g_set_error (error,
                             QMI_CORE_ERROR,
                             QMI_CORE_ERROR_TLV_NOT_FOUND,
                             "Couldn't get the Result TLV: Not found");
                qmi_message_pbm_get_all_capabilities_output_unref (self);
                return NULL;
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_CAPABILITY_BASIC_INFORMATION,
                                              &buffer_len);
            if (buffer && qmi_message_pbm_get_all_capabilities_output_capability_basic_information_validate (buffer, buffer_len)) {
                self->arg_capability_basic_information_set = TRUE;

                {
                    guint capability_basic_information_i;
                    guint8 capability_basic_information_n_items;

                    /* Read number of items in the array */
                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &(capability_basic_information_n_items));

                    self->arg_capability_basic_information = g_array_sized_new (
                        FALSE,
                        FALSE,
                        sizeof (QmiMessagePbmGetAllCapabilitiesOutputCapabilityBasicInformationElement),
                        (guint)capability_basic_information_n_items);

                    g_array_set_clear_func (self->arg_capability_basic_information,
                                            (GDestroyNotify)capability_basic_information_qmimessagepbmgetallcapabilitiesoutputcapabilitybasicinformationelement_clear);

                    for (capability_basic_information_i = 0; capability_basic_information_i < capability_basic_information_n_items; capability_basic_information_i++) {
                        QmiMessagePbmGetAllCapabilitiesOutputCapabilityBasicInformationElement capability_basic_information_aux;

                        {
                            guint8 tmp;

                            /* Read the guint8 variable from the buffer */
                            qmi_utils_read_guint8_from_buffer (
                                &buffer,
                                &buffer_len,
                                &tmp);
                            capability_basic_information_aux.session_type = (QmiPbmSessionType)tmp;
                        }
                        {
                            guint phonebooks_i;
                            guint8 phonebooks_n_items;

                            /* Read number of items in the array */
                            /* Read the guint8 variable from the buffer */
                            qmi_utils_read_guint8_from_buffer (
                                &buffer,
                                &buffer_len,
                                &(phonebooks_n_items));

                            capability_basic_information_aux.phonebooks = g_array_sized_new (
                                FALSE,
                                FALSE,
                                sizeof (QmiMessagePbmGetAllCapabilitiesOutputCapabilityBasicInformationElementPhonebooksElement),
                                (guint)phonebooks_n_items);

                            for (phonebooks_i = 0; phonebooks_i < phonebooks_n_items; phonebooks_i++) {
                                QmiMessagePbmGetAllCapabilitiesOutputCapabilityBasicInformationElementPhonebooksElement phonebooks_aux;

                                {
                                    guint16 tmp;

                                    /* Read the guint16 variable from the buffer */
                                    qmi_utils_read_guint16_from_buffer (
                                        &buffer,
                                        &buffer_len,
                                        QMI_ENDIAN_LITTLE,
                                        &tmp);
                                    phonebooks_aux.phonebook_type = (QmiPbmPhonebookType)tmp;
                                }
                                /* Read the guint16 variable from the buffer */
                                qmi_utils_read_guint16_from_buffer (
                                    &buffer,
                                    &buffer_len,
                                    QMI_ENDIAN_LITTLE,
                                    &(phonebooks_aux.used_records));
                                /* Read the guint16 variable from the buffer */
                                qmi_utils_read_guint16_from_buffer (
                                    &buffer,
                                    &buffer_len,
                                    QMI_ENDIAN_LITTLE,
                                    &(phonebooks_aux.maximum_records));
                                /* Read the guint8 variable from the buffer */
                                qmi_utils_read_guint8_from_buffer (
                                    &buffer,
                                    &buffer_len,
                                    &(phonebooks_aux.maximum_number_length));
                                /* Read the guint8 variable from the buffer */
                                qmi_utils_read_guint8_from_buffer (
                                    &buffer,
                                    &buffer_len,
                                    &(phonebooks_aux.maximum_name_length));
                                g_array_insert_val (capability_basic_information_aux.phonebooks, phonebooks_i, phonebooks_aux);
                            }
                        }
                        g_array_insert_val (self->arg_capability_basic_information, capability_basic_information_i, capability_basic_information_aux);
                    }
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Capability Basic Information' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_GROUP_CAPABILITY,
                                              &buffer_len);
            if (buffer && qmi_message_pbm_get_all_capabilities_output_group_capability_validate (buffer, buffer_len)) {
                self->arg_group_capability_set = TRUE;

                {
                    guint group_capability_i;
                    guint8 group_capability_n_items;

                    /* Read number of items in the array */
                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &(group_capability_n_items));

                    self->arg_group_capability = g_array_sized_new (
                        FALSE,
                        FALSE,
                        sizeof (QmiMessagePbmGetAllCapabilitiesOutputGroupCapabilityElement),
                        (guint)group_capability_n_items);

                    for (group_capability_i = 0; group_capability_i < group_capability_n_items; group_capability_i++) {
                        QmiMessagePbmGetAllCapabilitiesOutputGroupCapabilityElement group_capability_aux;

                        {
                            guint8 tmp;

                            /* Read the guint8 variable from the buffer */
                            qmi_utils_read_guint8_from_buffer (
                                &buffer,
                                &buffer_len,
                                &tmp);
                            group_capability_aux.session_type = (QmiPbmSessionType)tmp;
                        }
                        /* Read the guint8 variable from the buffer */
                        qmi_utils_read_guint8_from_buffer (
                            &buffer,
                            &buffer_len,
                            &(group_capability_aux.maximum_groups));
                        /* Read the guint8 variable from the buffer */
                        qmi_utils_read_guint8_from_buffer (
                            &buffer,
                            &buffer_len,
                            &(group_capability_aux.maximum_group_tag_length));
                        g_array_insert_val (self->arg_group_capability, group_capability_i, group_capability_aux);
                    }
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Group Capability' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_ADDITIONAL_NUMBER_CAPABILITY,
                                              &buffer_len);
            if (buffer && qmi_message_pbm_get_all_capabilities_output_additional_number_capability_validate (buffer, buffer_len)) {
                self->arg_additional_number_capability_set = TRUE;

                {
                    guint additional_number_capability_i;
                    guint8 additional_number_capability_n_items;

                    /* Read number of items in the array */
                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &(additional_number_capability_n_items));

                    self->arg_additional_number_capability = g_array_sized_new (
                        FALSE,
                        FALSE,
                        sizeof (QmiMessagePbmGetAllCapabilitiesOutputAdditionalNumberCapabilityElement),
                        (guint)additional_number_capability_n_items);

                    for (additional_number_capability_i = 0; additional_number_capability_i < additional_number_capability_n_items; additional_number_capability_i++) {
                        QmiMessagePbmGetAllCapabilitiesOutputAdditionalNumberCapabilityElement additional_number_capability_aux;

                        {
                            guint8 tmp;

                            /* Read the guint8 variable from the buffer */
                            qmi_utils_read_guint8_from_buffer (
                                &buffer,
                                &buffer_len,
                                &tmp);
                            additional_number_capability_aux.session_type = (QmiPbmSessionType)tmp;
                        }
                        /* Read the guint8 variable from the buffer */
                        qmi_utils_read_guint8_from_buffer (
                            &buffer,
                            &buffer_len,
                            &(additional_number_capability_aux.maximum_additional_numbers));
                        /* Read the guint8 variable from the buffer */
                        qmi_utils_read_guint8_from_buffer (
                            &buffer,
                            &buffer_len,
                            &(additional_number_capability_aux.maximum_additional_number_length));
                        /* Read the guint8 variable from the buffer */
                        qmi_utils_read_guint8_from_buffer (
                            &buffer,
                            &buffer_len,
                            &(additional_number_capability_aux.maximum_additional_number_tag_length));
                        g_array_insert_val (self->arg_additional_number_capability, additional_number_capability_i, additional_number_capability_aux);
                    }
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Additional Number Capability' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_EMAIL_CAPABILITY,
                                              &buffer_len);
            if (buffer && qmi_message_pbm_get_all_capabilities_output_email_capability_validate (buffer, buffer_len)) {
                self->arg_email_capability_set = TRUE;

                {
                    guint email_capability_i;
                    guint8 email_capability_n_items;

                    /* Read number of items in the array */
                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &(email_capability_n_items));

                    self->arg_email_capability = g_array_sized_new (
                        FALSE,
                        FALSE,
                        sizeof (QmiMessagePbmGetAllCapabilitiesOutputEmailCapabilityElement),
                        (guint)email_capability_n_items);

                    for (email_capability_i = 0; email_capability_i < email_capability_n_items; email_capability_i++) {
                        QmiMessagePbmGetAllCapabilitiesOutputEmailCapabilityElement email_capability_aux;

                        {
                            guint8 tmp;

                            /* Read the guint8 variable from the buffer */
                            qmi_utils_read_guint8_from_buffer (
                                &buffer,
                                &buffer_len,
                                &tmp);
                            email_capability_aux.session_type = (QmiPbmSessionType)tmp;
                        }
                        /* Read the guint8 variable from the buffer */
                        qmi_utils_read_guint8_from_buffer (
                            &buffer,
                            &buffer_len,
                            &(email_capability_aux.maximum_emails));
                        /* Read the guint8 variable from the buffer */
                        qmi_utils_read_guint8_from_buffer (
                            &buffer,
                            &buffer_len,
                            &(email_capability_aux.maximum_email_address_length));
                        g_array_insert_val (self->arg_email_capability, email_capability_i, email_capability_aux);
                    }
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Email Capability' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_SECOND_NAME_CAPABILITY,
                                              &buffer_len);
            if (buffer && qmi_message_pbm_get_all_capabilities_output_second_name_capability_validate (buffer, buffer_len)) {
                self->arg_second_name_capability_set = TRUE;

                {
                    guint second_name_capability_i;
                    guint8 second_name_capability_n_items;

                    /* Read number of items in the array */
                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &(second_name_capability_n_items));

                    self->arg_second_name_capability = g_array_sized_new (
                        FALSE,
                        FALSE,
                        sizeof (QmiMessagePbmGetAllCapabilitiesOutputSecondNameCapabilityElement),
                        (guint)second_name_capability_n_items);

                    for (second_name_capability_i = 0; second_name_capability_i < second_name_capability_n_items; second_name_capability_i++) {
                        QmiMessagePbmGetAllCapabilitiesOutputSecondNameCapabilityElement second_name_capability_aux;

                        {
                            guint8 tmp;

                            /* Read the guint8 variable from the buffer */
                            qmi_utils_read_guint8_from_buffer (
                                &buffer,
                                &buffer_len,
                                &tmp);
                            second_name_capability_aux.session_type = (QmiPbmSessionType)tmp;
                        }
                        /* Read the guint8 variable from the buffer */
                        qmi_utils_read_guint8_from_buffer (
                            &buffer,
                            &buffer_len,
                            &(second_name_capability_aux.maximum_second_name_length));
                        g_array_insert_val (self->arg_second_name_capability, second_name_capability_i, second_name_capability_aux);
                    }
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Second Name Capability' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_HIDDEN_RECORDS_CAPABILITY,
                                              &buffer_len);
            if (buffer && qmi_message_pbm_get_all_capabilities_output_hidden_records_capability_validate (buffer, buffer_len)) {
                self->arg_hidden_records_capability_set = TRUE;

                {
                    guint hidden_records_capability_i;
                    guint8 hidden_records_capability_n_items;

                    /* Read number of items in the array */
                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &(hidden_records_capability_n_items));

                    self->arg_hidden_records_capability = g_array_sized_new (
                        FALSE,
                        FALSE,
                        sizeof (QmiMessagePbmGetAllCapabilitiesOutputHiddenRecordsCapabilityElement),
                        (guint)hidden_records_capability_n_items);

                    for (hidden_records_capability_i = 0; hidden_records_capability_i < hidden_records_capability_n_items; hidden_records_capability_i++) {
                        QmiMessagePbmGetAllCapabilitiesOutputHiddenRecordsCapabilityElement hidden_records_capability_aux;

                        {
                            guint8 tmp;

                            /* Read the guint8 variable from the buffer */
                            qmi_utils_read_guint8_from_buffer (
                                &buffer,
                                &buffer_len,
                                &tmp);
                            hidden_records_capability_aux.session_type = (QmiPbmSessionType)tmp;
                        }
                        {
                            guint8 tmp;

                            /* Read the guint8 variable from the buffer */
                            qmi_utils_read_guint8_from_buffer (
                                &buffer,
                                &buffer_len,
                                &tmp);
                            hidden_records_capability_aux.supported = (gboolean)tmp;
                        }
                        g_array_insert_val (self->arg_hidden_records_capability, hidden_records_capability_i, hidden_records_capability_aux);
                    }
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Hidden Records Capability' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_GROUPING_INFORMATION_ALPHA_STRING_CAPABILITY,
                                              &buffer_len);
            if (buffer && qmi_message_pbm_get_all_capabilities_output_grouping_information_alpha_string_capability_validate (buffer, buffer_len)) {
                self->arg_grouping_information_alpha_string_capability_set = TRUE;

                {
                    guint grouping_information_alpha_string_capability_i;
                    guint8 grouping_information_alpha_string_capability_n_items;

                    /* Read number of items in the array */
                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &(grouping_information_alpha_string_capability_n_items));

                    self->arg_grouping_information_alpha_string_capability = g_array_sized_new (
                        FALSE,
                        FALSE,
                        sizeof (QmiMessagePbmGetAllCapabilitiesOutputGroupingInformationAlphaStringCapabilityElement),
                        (guint)grouping_information_alpha_string_capability_n_items);

                    for (grouping_information_alpha_string_capability_i = 0; grouping_information_alpha_string_capability_i < grouping_information_alpha_string_capability_n_items; grouping_information_alpha_string_capability_i++) {
                        QmiMessagePbmGetAllCapabilitiesOutputGroupingInformationAlphaStringCapabilityElement grouping_information_alpha_string_capability_aux;

                        {
                            guint8 tmp;

                            /* Read the guint8 variable from the buffer */
                            qmi_utils_read_guint8_from_buffer (
                                &buffer,
                                &buffer_len,
                                &tmp);
                            grouping_information_alpha_string_capability_aux.session_type = (QmiPbmSessionType)tmp;
                        }
                        /* Read the guint8 variable from the buffer */
                        qmi_utils_read_guint8_from_buffer (
                            &buffer,
                            &buffer_len,
                            &(grouping_information_alpha_string_capability_aux.maximum_records));
                        /* Read the guint8 variable from the buffer */
                        qmi_utils_read_guint8_from_buffer (
                            &buffer,
                            &buffer_len,
                            &(grouping_information_alpha_string_capability_aux.used_records));
                        /* Read the guint8 variable from the buffer */
                        qmi_utils_read_guint8_from_buffer (
                            &buffer,
                            &buffer_len,
                            &(grouping_information_alpha_string_capability_aux.maximum_string_length));
                        g_array_insert_val (self->arg_grouping_information_alpha_string_capability, grouping_information_alpha_string_capability_i, grouping_information_alpha_string_capability_aux);
                    }
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Grouping Information Alpha String Capability' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES_OUTPUT_TLV_ADDITIONAL_NUMBER_ALPHA_STRING_CAPABILITY,
                                              &buffer_len);
            if (buffer && qmi_message_pbm_get_all_capabilities_output_additional_number_alpha_string_capability_validate (buffer, buffer_len)) {
                self->arg_additional_number_alpha_string_capability_set = TRUE;

                {
                    guint additional_number_alpha_string_capability_i;
                    guint8 additional_number_alpha_string_capability_n_items;

                    /* Read number of items in the array */
                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &(additional_number_alpha_string_capability_n_items));

                    self->arg_additional_number_alpha_string_capability = g_array_sized_new (
                        FALSE,
                        FALSE,
                        sizeof (QmiMessagePbmGetAllCapabilitiesOutputAdditionalNumberAlphaStringCapabilityElement),
                        (guint)additional_number_alpha_string_capability_n_items);

                    for (additional_number_alpha_string_capability_i = 0; additional_number_alpha_string_capability_i < additional_number_alpha_string_capability_n_items; additional_number_alpha_string_capability_i++) {
                        QmiMessagePbmGetAllCapabilitiesOutputAdditionalNumberAlphaStringCapabilityElement additional_number_alpha_string_capability_aux;

                        {
                            guint8 tmp;

                            /* Read the guint8 variable from the buffer */
                            qmi_utils_read_guint8_from_buffer (
                                &buffer,
                                &buffer_len,
                                &tmp);
                            additional_number_alpha_string_capability_aux.session_type = (QmiPbmSessionType)tmp;
                        }
                        /* Read the guint8 variable from the buffer */
                        qmi_utils_read_guint8_from_buffer (
                            &buffer,
                            &buffer_len,
                            &(additional_number_alpha_string_capability_aux.maximum_records));
                        /* Read the guint8 variable from the buffer */
                        qmi_utils_read_guint8_from_buffer (
                            &buffer,
                            &buffer_len,
                            &(additional_number_alpha_string_capability_aux.used_records));
                        /* Read the guint8 variable from the buffer */
                        qmi_utils_read_guint8_from_buffer (
                            &buffer,
                            &buffer_len,
                            &(additional_number_alpha_string_capability_aux.maximum_string_length));
                        g_array_insert_val (self->arg_additional_number_alpha_string_capability, additional_number_alpha_string_capability_i, additional_number_alpha_string_capability_aux);
                    }
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Additional Number Alpha String Capability' TLV", buffer_len);
                }
            }

        }
    } while (0);

    return self;
}

/*****************************************************************************/
/* Service-specific printable: PBM */


gchar *
__qmi_message_pbm_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    if (qmi_message_is_indication (self)) {
        switch (qmi_message_get_message_id (self)) {
         default:
             return NULL;
        }
    } else {
        switch (qmi_message_get_message_id (self)) {
        case QMI_MESSAGE_PBM_INDICATION_REGISTER:
            return message_indication_register_get_printable (self, line_prefix);
        case QMI_MESSAGE_PBM_GET_CAPABILITIES:
            return message_get_capabilities_get_printable (self, line_prefix);
        case QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES:
            return message_get_all_capabilities_get_printable (self, line_prefix);
         default:
             return NULL;
        }
    }
}

gboolean
__qmi_message_pbm_get_version_introduced (
    QmiMessage *self,
    guint *major,
    guint *minor)
{
    switch (qmi_message_get_message_id (self)) {
    case QMI_MESSAGE_PBM_INDICATION_REGISTER:
        *major = 1;
        *minor = 0;
        return TRUE;
    case QMI_MESSAGE_PBM_GET_CAPABILITIES:
        *major = 1;
        *minor = 0;
        return TRUE;
    case QMI_MESSAGE_PBM_GET_ALL_CAPABILITIES:
        *major = 1;
        *minor = 0;
        return TRUE;
    default:
        return FALSE;
    }
}

/*****************************************************************************/
/* CLIENT: QMI Client PBM */


/**
 * SECTION: qmi-client-pbm
 * @title: QmiClientPbm
 * @short_description: #QmiClient for the PBM service.
 *
 * #QmiClient which handles operations in the PBM service.
 */

G_DEFINE_TYPE (QmiClientPbm, qmi_client_pbm, QMI_TYPE_CLIENT);

static void
process_indication (QmiClient *self,
                    QmiMessage *message)
{
    switch (qmi_message_get_message_id (message)) {
        default:
            break;
    }
}

static void
qmi_client_pbm_init (QmiClientPbm *self)
{
}

static void
qmi_client_pbm_class_init (QmiClientPbmClass *klass)
{
    QmiClientClass *client_class = QMI_CLIENT_CLASS (klass);

    client_class->process_indication = process_indication;
}


/**
 * qmi_client_pbm_indication_register_finish:
 * @self: a #QmiClientPbm.
 * @res: the #GAsyncResult obtained from the #GAsyncReadyCallback passed to qmi_client_pbm_indication_register().
 * @error: Return location for error or %NULL.
 *
 * Finishes an async operation started with qmi_client_pbm_indication_register().
 *
 * Returns: a #QmiMessagePbmIndicationRegisterOutput, or %NULL if @error is set. The returned value should be freed with qmi_message_pbm_indication_register_output_unref().
 */
QmiMessagePbmIndicationRegisterOutput *
qmi_client_pbm_indication_register_finish (
    QmiClientPbm *self,
    GAsyncResult *res,
    GError **error)
{
   if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (res), error))
       return NULL;

   return qmi_message_pbm_indication_register_output_ref (g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (res)));
}

static void
indication_register_ready (
    QmiDevice *device,
    GAsyncResult *res,
    GSimpleAsyncResult *simple)
{
    GError *error = NULL;
    QmiMessage *reply;
    QmiMessagePbmIndicationRegisterOutput *output;

    reply = qmi_device_command_finish (device, res, &error);
    if (!reply) {
        g_simple_async_result_take_error (simple, error);
        g_simple_async_result_complete (simple);
        g_object_unref (simple);
        return;
    }

    /* Parse reply */
    output = __qmi_message_pbm_indication_register_response_parse (reply, &error);
    if (!output)
        g_simple_async_result_take_error (simple, error);
    else
        g_simple_async_result_set_op_res_gpointer (simple,
                                                   output,
                                                   (GDestroyNotify)qmi_message_pbm_indication_register_output_unref);
    g_simple_async_result_complete (simple);
    g_object_unref (simple);
    qmi_message_unref (reply);
}

/**
 * qmi_client_pbm_indication_register:
 * @self: a #QmiClientPbm.
 * @input: a #QmiMessagePbmIndicationRegisterInput.
 * @timeout: maximum time to wait for the method to complete, in seconds.
 * @cancellable: a #GCancellable or %NULL.
 * @callback: a #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: user data to pass to @callback.
 *
 * Asynchronously sends a Indication Register request to the device.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from.
 *
 * You can then call qmi_client_pbm_indication_register_finish() to get the result of the operation.
 */
void
qmi_client_pbm_indication_register (
    QmiClientPbm *self,
    QmiMessagePbmIndicationRegisterInput *input,
    guint timeout,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
    GSimpleAsyncResult *result;
    QmiMessage *request;
    GError *error = NULL;
    guint16 transaction_id;

    result = g_simple_async_result_new (G_OBJECT (self),
                                        callback,
                                        user_data,
                                        qmi_client_pbm_indication_register);

    transaction_id = qmi_client_get_next_transaction_id (QMI_CLIENT (self));

    request = __qmi_message_pbm_indication_register_request_create (
                  transaction_id,
                  qmi_client_get_cid (QMI_CLIENT (self)),
                  input,
                  &error);
    if (!request) {
        g_prefix_error (&error, "Couldn't create request message: ");
        g_simple_async_result_take_error (result, error);
        g_simple_async_result_complete_in_idle (result);
        g_object_unref (result);
        return;
    }

    qmi_device_command (QMI_DEVICE (qmi_client_peek_device (QMI_CLIENT (self))),
                        request,
                        timeout,
                        cancellable,
                        (GAsyncReadyCallback)indication_register_ready,
                        result);
    qmi_message_unref (request);
}


/**
 * qmi_client_pbm_get_capabilities_finish:
 * @self: a #QmiClientPbm.
 * @res: the #GAsyncResult obtained from the #GAsyncReadyCallback passed to qmi_client_pbm_get_capabilities().
 * @error: Return location for error or %NULL.
 *
 * Finishes an async operation started with qmi_client_pbm_get_capabilities().
 *
 * Returns: a #QmiMessagePbmGetCapabilitiesOutput, or %NULL if @error is set. The returned value should be freed with qmi_message_pbm_get_capabilities_output_unref().
 */
QmiMessagePbmGetCapabilitiesOutput *
qmi_client_pbm_get_capabilities_finish (
    QmiClientPbm *self,
    GAsyncResult *res,
    GError **error)
{
   if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (res), error))
       return NULL;

   return qmi_message_pbm_get_capabilities_output_ref (g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (res)));
}

static void
get_capabilities_ready (
    QmiDevice *device,
    GAsyncResult *res,
    GSimpleAsyncResult *simple)
{
    GError *error = NULL;
    QmiMessage *reply;
    QmiMessagePbmGetCapabilitiesOutput *output;

    reply = qmi_device_command_finish (device, res, &error);
    if (!reply) {
        g_simple_async_result_take_error (simple, error);
        g_simple_async_result_complete (simple);
        g_object_unref (simple);
        return;
    }

    /* Parse reply */
    output = __qmi_message_pbm_get_capabilities_response_parse (reply, &error);
    if (!output)
        g_simple_async_result_take_error (simple, error);
    else
        g_simple_async_result_set_op_res_gpointer (simple,
                                                   output,
                                                   (GDestroyNotify)qmi_message_pbm_get_capabilities_output_unref);
    g_simple_async_result_complete (simple);
    g_object_unref (simple);
    qmi_message_unref (reply);
}

/**
 * qmi_client_pbm_get_capabilities:
 * @self: a #QmiClientPbm.
 * @input: a #QmiMessagePbmGetCapabilitiesInput.
 * @timeout: maximum time to wait for the method to complete, in seconds.
 * @cancellable: a #GCancellable or %NULL.
 * @callback: a #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: user data to pass to @callback.
 *
 * Asynchronously sends a Get Capabilities request to the device.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from.
 *
 * You can then call qmi_client_pbm_get_capabilities_finish() to get the result of the operation.
 */
void
qmi_client_pbm_get_capabilities (
    QmiClientPbm *self,
    QmiMessagePbmGetCapabilitiesInput *input,
    guint timeout,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
    GSimpleAsyncResult *result;
    QmiMessage *request;
    GError *error = NULL;
    guint16 transaction_id;

    result = g_simple_async_result_new (G_OBJECT (self),
                                        callback,
                                        user_data,
                                        qmi_client_pbm_get_capabilities);

    transaction_id = qmi_client_get_next_transaction_id (QMI_CLIENT (self));

    request = __qmi_message_pbm_get_capabilities_request_create (
                  transaction_id,
                  qmi_client_get_cid (QMI_CLIENT (self)),
                  input,
                  &error);
    if (!request) {
        g_prefix_error (&error, "Couldn't create request message: ");
        g_simple_async_result_take_error (result, error);
        g_simple_async_result_complete_in_idle (result);
        g_object_unref (result);
        return;
    }

    qmi_device_command (QMI_DEVICE (qmi_client_peek_device (QMI_CLIENT (self))),
                        request,
                        timeout,
                        cancellable,
                        (GAsyncReadyCallback)get_capabilities_ready,
                        result);
    qmi_message_unref (request);
}


/**
 * qmi_client_pbm_get_all_capabilities_finish:
 * @self: a #QmiClientPbm.
 * @res: the #GAsyncResult obtained from the #GAsyncReadyCallback passed to qmi_client_pbm_get_all_capabilities().
 * @error: Return location for error or %NULL.
 *
 * Finishes an async operation started with qmi_client_pbm_get_all_capabilities().
 *
 * Returns: a #QmiMessagePbmGetAllCapabilitiesOutput, or %NULL if @error is set. The returned value should be freed with qmi_message_pbm_get_all_capabilities_output_unref().
 */
QmiMessagePbmGetAllCapabilitiesOutput *
qmi_client_pbm_get_all_capabilities_finish (
    QmiClientPbm *self,
    GAsyncResult *res,
    GError **error)
{
   if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (res), error))
       return NULL;

   return qmi_message_pbm_get_all_capabilities_output_ref (g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (res)));
}

static void
get_all_capabilities_ready (
    QmiDevice *device,
    GAsyncResult *res,
    GSimpleAsyncResult *simple)
{
    GError *error = NULL;
    QmiMessage *reply;
    QmiMessagePbmGetAllCapabilitiesOutput *output;

    reply = qmi_device_command_finish (device, res, &error);
    if (!reply) {
        g_simple_async_result_take_error (simple, error);
        g_simple_async_result_complete (simple);
        g_object_unref (simple);
        return;
    }

    /* Parse reply */
    output = __qmi_message_pbm_get_all_capabilities_response_parse (reply, &error);
    if (!output)
        g_simple_async_result_take_error (simple, error);
    else
        g_simple_async_result_set_op_res_gpointer (simple,
                                                   output,
                                                   (GDestroyNotify)qmi_message_pbm_get_all_capabilities_output_unref);
    g_simple_async_result_complete (simple);
    g_object_unref (simple);
    qmi_message_unref (reply);
}

/**
 * qmi_client_pbm_get_all_capabilities:
 * @self: a #QmiClientPbm.
 * @unused: %NULL. This message doesn't have any input bundle.
 * @timeout: maximum time to wait for the method to complete, in seconds.
 * @cancellable: a #GCancellable or %NULL.
 * @callback: a #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: user data to pass to @callback.
 *
 * Asynchronously sends a Get All Capabilities request to the device.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from.
 *
 * You can then call qmi_client_pbm_get_all_capabilities_finish() to get the result of the operation.
 */
void
qmi_client_pbm_get_all_capabilities (
    QmiClientPbm *self,
    gpointer unused,
    guint timeout,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
    GSimpleAsyncResult *result;
    QmiMessage *request;
    GError *error = NULL;
    guint16 transaction_id;

    result = g_simple_async_result_new (G_OBJECT (self),
                                        callback,
                                        user_data,
                                        qmi_client_pbm_get_all_capabilities);

    transaction_id = qmi_client_get_next_transaction_id (QMI_CLIENT (self));

    request = __qmi_message_pbm_get_all_capabilities_request_create (
                  transaction_id,
                  qmi_client_get_cid (QMI_CLIENT (self)),
                  NULL,
                  &error);
    if (!request) {
        g_prefix_error (&error, "Couldn't create request message: ");
        g_simple_async_result_take_error (result, error);
        g_simple_async_result_complete_in_idle (result);
        g_object_unref (result);
        return;
    }

    qmi_device_command (QMI_DEVICE (qmi_client_peek_device (QMI_CLIENT (self))),
                        request,
                        timeout,
                        cancellable,
                        (GAsyncReadyCallback)get_all_capabilities_ready,
                        result);
    qmi_message_unref (request);
}

