
/* GENERATED CODE... DO NOT EDIT */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Copyright (C) 2012 Lanedo GmbH
 */


#include <string.h>

#include "qmi-uim.h"
#include "qmi-enum-types.h"
#include "qmi-enum-types-private.h"
#include "qmi-flags64-types.h"
#include "qmi-error-types.h"
#include "qmi-device.h"
#include "qmi-utils.h"

#define QMI_STATUS_SUCCESS 0x0000
#define QMI_STATUS_FAILURE 0x0001


typedef enum {
    QMI_MESSAGE_UIM_RESET = 0x0000,
    QMI_MESSAGE_UIM_READ_TRANSPARENT = 0x0020,
    QMI_MESSAGE_UIM_READ_RECORD = 0x0021,
    QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES = 0x0024,
} QmiMessageUim;


/*****************************************************************************/
/* REQUEST/RESPONSE: Qmi Message UIM Reset */


/* --- Input -- */

/* Note: no fields in the Input container */

static QmiMessage *
__qmi_message_uim_reset_request_create (
    guint8 transaction_id,
    guint8 cid,
    gpointer unused,
    GError **error)
{
    QmiMessage *self;

    self = qmi_message_new (QMI_SERVICE_UIM,
                            cid,
                            transaction_id,
                            QMI_MESSAGE_UIM_RESET);

    return self;
}

/* --- Output -- */

/**
 * QmiMessageResult:
 * @error_status: a #guint16.
 * @error_code: a #guint16.
 *
 * A QmiMessageResult struct.
 */
typedef struct _QmiMessageResult {
    guint16 error_status;
    guint16 error_code;
} QmiMessageResult;

struct _QmiMessageUimResetOutput {
    volatile gint ref_count;

    /* Result */
    gboolean arg_result_set;
    QmiMessageResult arg_result;
};

#define QMI_MESSAGE_UIM_RESET_OUTPUT_TLV_RESULT 0x02

/**
 * qmi_message_uim_reset_output_get_result:
 * @self: a QmiMessageUimResetOutput.
 * @error: Return location for error or %NULL.
 *
 * Get the result of the QMI operation.
 *
 * Returns: %TRUE if the QMI operation succeeded, %FALSE if @error is set.
 */
gboolean
qmi_message_uim_reset_output_get_result (
    QmiMessageUimResetOutput *self,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    /* We should always have a result set in the response message */
    if (!self->arg_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_MESSAGE,
                     "No 'Result' field given in the message");
        return FALSE;
    }

    if (self->arg_result.error_status == QMI_STATUS_SUCCESS) {
        /* Operation succeeded */
        return TRUE;
    }

    /* Report a QMI protocol error */
    g_set_error (error,
                 QMI_PROTOCOL_ERROR,
                 (QmiProtocolError) self->arg_result.error_code,
                 "QMI protocol error (%u): '%s'",
                 self->arg_result.error_code,
                 qmi_protocol_error_get_string ((QmiProtocolError) self->arg_result.error_code));
    return FALSE;
}

GType
qmi_message_uim_reset_output_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageUimResetOutput"),
                                          (GBoxedCopyFunc) qmi_message_uim_reset_output_ref,
                                          (GBoxedFreeFunc) qmi_message_uim_reset_output_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_uim_reset_output_ref:
 * @self: a #QmiMessageUimResetOutput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageUimResetOutput *
qmi_message_uim_reset_output_ref (QmiMessageUimResetOutput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_uim_reset_output_unref:
 * @self: a #QmiMessageUimResetOutput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_uim_reset_output_unref (QmiMessageUimResetOutput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        g_slice_free (QmiMessageUimResetOutput, self);
    }
}

static gboolean
qmi_message_result_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    static const guint expected_len = 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Result' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    return TRUE;
}

static gchar *
qmi_message_result_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (self,
                                      QMI_MESSAGE_UIM_RESET_OUTPUT_TLV_RESULT,
                                      &buffer_len);
    if (buffer) {
        GString *printable;
        guint16 error_status;
        guint16 error_code;

        printable = g_string_new ("");
        qmi_utils_read_guint16_from_buffer (
            &buffer,
            &buffer_len,
            QMI_ENDIAN_LITTLE,
            &error_status);
        qmi_utils_read_guint16_from_buffer (
            &buffer,
            &buffer_len,
            QMI_ENDIAN_LITTLE,
            &error_code);

        g_warn_if_fail (buffer_len == 0);

        if (error_status == QMI_STATUS_SUCCESS)
            g_string_append (printable, "SUCCESS");
        else
            g_string_append_printf (printable,
                                    "FAILURE: %s",
                                    qmi_protocol_error_get_string ((QmiProtocolError) error_code));

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

struct message_reset_context {
    QmiMessage *self;
    const gchar *line_prefix;
    GString *printable;
};

static void
message_reset_get_tlv_printable (
    guint8 type,
    const guint8 *value,
    gsize length,
    struct message_reset_context *ctx)
{
    const gchar *tlv_type_str = NULL;
    gchar *translated_value;

    if (!qmi_message_is_response (ctx->self)) {
        switch (type) {
        default:
            break;
        }
    } else {
        switch (type) {
        case QMI_MESSAGE_UIM_RESET_OUTPUT_TLV_RESULT:
            tlv_type_str = "Result";
            translated_value = qmi_message_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    }

    if (!tlv_type_str) {
        gchar *value_str = NULL;

        value_str = qmi_message_get_tlv_printable (ctx->self,
                                                   ctx->line_prefix,
                                                   type,
                                                   value,
                                                   length);
        g_string_append (ctx->printable, value_str);
        g_free (value_str);
    } else {
        gchar *value_hex;

        value_hex = __qmi_utils_str_hex (value, length, ':');
        g_string_append_printf (ctx->printable,
                                "%sTLV:\n"
                                "%s  type       = \"%s\" (0x%02x)\n"
                                "%s  length     = %" G_GSIZE_FORMAT "\n"
                                "%s  value      = %s\n"
                                "%s  translated = %s\n",
                                ctx->line_prefix,
                                ctx->line_prefix, tlv_type_str, type,
                                ctx->line_prefix, length,
                                ctx->line_prefix, value_hex,
                                ctx->line_prefix, translated_value ? translated_value : "");
        g_free (value_hex);
        g_free (translated_value);
    }
}

static gchar *
message_reset_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    GString *printable;

    printable = g_string_new ("");
    g_string_append_printf (printable,
                            "%s  message     = \"Reset\" (0x0000)\n",
                            line_prefix);

    {
        struct message_reset_context ctx;
        ctx.self = self;
        ctx.line_prefix = line_prefix;
        ctx.printable = printable;
        qmi_message_foreach_raw_tlv (self,
                                     (QmiMessageForeachRawTlvFn)message_reset_get_tlv_printable,
                                     &ctx);
    }

    return g_string_free (printable, FALSE);
}

static QmiMessageUimResetOutput *
__qmi_message_uim_reset_response_parse (
    QmiMessage *message,
    GError **error)
{
    QmiMessageUimResetOutput *self;

    g_return_val_if_fail (qmi_message_get_message_id (message) == QMI_MESSAGE_UIM_RESET, NULL);

    self = g_slice_new0 (QmiMessageUimResetOutput);
    self->ref_count = 1;

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_UIM_RESET_OUTPUT_TLV_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_result_validate (buffer, buffer_len)) {
                self->arg_result_set = TRUE;

                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_status));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_code));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Result' TLV", buffer_len);
                }
            } else {
                g_set_error (error,
                             QMI_CORE_ERROR,
                             QMI_CORE_ERROR_TLV_NOT_FOUND,
                             "Couldn't get the Result TLV: Not found");
                qmi_message_uim_reset_output_unref (self);
                return NULL;
            }

        }
    } while (0);

    return self;
}

/*****************************************************************************/
/* REQUEST/RESPONSE: Qmi Message UIM Read Transparent */


/* --- Input -- */

struct _QmiMessageUimReadTransparentInput {
    volatile gint ref_count;

    /* Encrypt Data */
    gboolean arg_encrypt_data_set;
    guint8 arg_encrypt_data;

    /* Response In Indication Token */
    gboolean arg_response_in_indication_token_set;
    guint32 arg_response_in_indication_token;

    /* Read Information */
    gboolean arg_read_information_set;
    guint16 arg_read_information_offset;
    guint16 arg_read_information_length;

    /* File */
    gboolean arg_file_set;
    guint16 arg_file_file_id;
    GArray *arg_file_file_path;

    /* Session Information */
    gboolean arg_session_information_set;
    guint8 arg_session_information_session_type;
    gchar *arg_session_information_application_identifier;
};

#define QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_ENCRYPT_DATA 0x11
#define QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN 0x10
#define QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_READ_INFORMATION 0x03
#define QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_FILE 0x02
#define QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_SESSION_INFORMATION 0x01

/**
 * qmi_message_uim_read_transparent_input_get_encrypt_data:
 * @self: a #QmiMessageUimReadTransparentInput.
 * @encrypt_data: a placeholder for the output #gboolean, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Encrypt Data' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_transparent_input_get_encrypt_data (
    QmiMessageUimReadTransparentInput *self,
    gboolean *encrypt_data,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_encrypt_data_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Encrypt Data' was not found in the message");
        return FALSE;
    }

    if (encrypt_data)
        *encrypt_data = (gboolean)(self->arg_encrypt_data);

    return TRUE;
}

/**
 * qmi_message_uim_read_transparent_input_set_encrypt_data:
 * @self: a #QmiMessageUimReadTransparentInput.
 * @encrypt_data: a #gboolean.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Encrypt Data' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_transparent_input_set_encrypt_data (
    QmiMessageUimReadTransparentInput *self,
    gboolean encrypt_data,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_encrypt_data = (guint8)(encrypt_data);
    self->arg_encrypt_data_set = TRUE;

    return TRUE;
}

/**
 * qmi_message_uim_read_transparent_input_get_response_in_indication_token:
 * @self: a #QmiMessageUimReadTransparentInput.
 * @response_in_indication_token: a placeholder for the output #guint32, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Response In Indication Token' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_transparent_input_get_response_in_indication_token (
    QmiMessageUimReadTransparentInput *self,
    guint32 *response_in_indication_token,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_response_in_indication_token_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Response In Indication Token' was not found in the message");
        return FALSE;
    }

    if (response_in_indication_token)
        *response_in_indication_token = self->arg_response_in_indication_token;

    return TRUE;
}

/**
 * qmi_message_uim_read_transparent_input_set_response_in_indication_token:
 * @self: a #QmiMessageUimReadTransparentInput.
 * @response_in_indication_token: a #guint32.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Response In Indication Token' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_transparent_input_set_response_in_indication_token (
    QmiMessageUimReadTransparentInput *self,
    guint32 response_in_indication_token,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_response_in_indication_token = response_in_indication_token;
    self->arg_response_in_indication_token_set = TRUE;

    return TRUE;
}

/**
 * qmi_message_uim_read_transparent_input_get_read_information:
 * @self: a #QmiMessageUimReadTransparentInput.
 * @read_information_offset: a placeholder for the output #guint16, or %NULL if not required.
 * @read_information_length: a placeholder for the output #guint16, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Read Information' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_transparent_input_get_read_information (
    QmiMessageUimReadTransparentInput *self,
    guint16 *read_information_offset,
    guint16 *read_information_length,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_read_information_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Read Information' was not found in the message");
        return FALSE;
    }

    if (read_information_offset)
        *read_information_offset = self->arg_read_information_offset;
    if (read_information_length)
        *read_information_length = self->arg_read_information_length;

    return TRUE;
}

/**
 * qmi_message_uim_read_transparent_input_set_read_information:
 * @self: a #QmiMessageUimReadTransparentInput.
 * @read_information_offset: a #guint16.
 * @read_information_length: a #guint16.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Read Information' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_transparent_input_set_read_information (
    QmiMessageUimReadTransparentInput *self,
    guint16 read_information_offset,
    guint16 read_information_length,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_read_information_offset = read_information_offset;
    self->arg_read_information_length = read_information_length;
    self->arg_read_information_set = TRUE;

    return TRUE;
}

/**
 * qmi_message_uim_read_transparent_input_get_file:
 * @self: a #QmiMessageUimReadTransparentInput.
 * @file_file_id: a placeholder for the output #guint16, or %NULL if not required.
 * @file_file_path: a placeholder for the output #GArray of #guint8 elements, or %NULL if not required. Do not free it, it is owned by @self.
 * @error: Return location for error or %NULL.
 *
 * Get the 'File' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_transparent_input_get_file (
    QmiMessageUimReadTransparentInput *self,
    guint16 *file_file_id,
    GArray **file_file_path,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_file_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'File' was not found in the message");
        return FALSE;
    }

    if (file_file_id)
        *file_file_id = self->arg_file_file_id;
    if (file_file_path)
        *file_file_path = self->arg_file_file_path;

    return TRUE;
}

/**
 * qmi_message_uim_read_transparent_input_set_file:
 * @self: a #QmiMessageUimReadTransparentInput.
 * @file_file_id: a #guint16.
 * @file_file_path: a #GArray of #guint8 elements. A new reference to @file_file_path will be taken.
 * @error: Return location for error or %NULL.
 *
 * Set the 'File' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_transparent_input_set_file (
    QmiMessageUimReadTransparentInput *self,
    guint16 file_file_id,
    GArray *file_file_path,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_file_file_id = file_file_id;
    if (self->arg_file_file_path)
        g_array_unref (self->arg_file_file_path);
    self->arg_file_file_path = g_array_ref (file_file_path);
    self->arg_file_set = TRUE;

    return TRUE;
}

/**
 * qmi_message_uim_read_transparent_input_get_session_information:
 * @self: a #QmiMessageUimReadTransparentInput.
 * @session_information_session_type: a placeholder for the output #QmiUimSessionType, or %NULL if not required.
 * @session_information_application_identifier: a placeholder for the output constant string, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Session Information' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_transparent_input_get_session_information (
    QmiMessageUimReadTransparentInput *self,
    QmiUimSessionType *session_information_session_type,
    const gchar **session_information_application_identifier,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_session_information_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Session Information' was not found in the message");
        return FALSE;
    }

    if (session_information_session_type)
        *session_information_session_type = (QmiUimSessionType)(self->arg_session_information_session_type);
    if (session_information_application_identifier)
        *session_information_application_identifier = self->arg_session_information_application_identifier;

    return TRUE;
}

/**
 * qmi_message_uim_read_transparent_input_set_session_information:
 * @self: a #QmiMessageUimReadTransparentInput.
 * @session_information_session_type: a #QmiUimSessionType.
 * @session_information_application_identifier: a constant string.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Session Information' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_transparent_input_set_session_information (
    QmiMessageUimReadTransparentInput *self,
    QmiUimSessionType session_information_session_type,
    const gchar *session_information_application_identifier,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_session_information_session_type = (guint8)(session_information_session_type);
    g_free (self->arg_session_information_application_identifier);
    self->arg_session_information_application_identifier = g_strdup (session_information_application_identifier ? session_information_application_identifier : "");
    self->arg_session_information_set = TRUE;

    return TRUE;
}

GType
qmi_message_uim_read_transparent_input_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageUimReadTransparentInput"),
                                          (GBoxedCopyFunc) qmi_message_uim_read_transparent_input_ref,
                                          (GBoxedFreeFunc) qmi_message_uim_read_transparent_input_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_uim_read_transparent_input_ref:
 * @self: a #QmiMessageUimReadTransparentInput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageUimReadTransparentInput *
qmi_message_uim_read_transparent_input_ref (QmiMessageUimReadTransparentInput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_uim_read_transparent_input_unref:
 * @self: a #QmiMessageUimReadTransparentInput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_uim_read_transparent_input_unref (QmiMessageUimReadTransparentInput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        if (self->arg_file_file_path)
            g_array_unref (self->arg_file_file_path);
        g_free (self->arg_session_information_application_identifier);
        g_slice_free (QmiMessageUimReadTransparentInput, self);
    }
}

/**
 * qmi_message_uim_read_transparent_input_new:
 *
 * Allocates a new #QmiMessageUimReadTransparentInput.
 *
 * Returns: the newly created #QmiMessageUimReadTransparentInput. The returned value should be freed with qmi_message_uim_read_transparent_input_unref().
 */
QmiMessageUimReadTransparentInput *
qmi_message_uim_read_transparent_input_new (void)
{
    QmiMessageUimReadTransparentInput *self;

    self = g_slice_new0 (QmiMessageUimReadTransparentInput);
    self->ref_count = 1;
    return self;
}

static QmiMessage *
__qmi_message_uim_read_transparent_request_create (
    guint8 transaction_id,
    guint8 cid,
    QmiMessageUimReadTransparentInput *input,
    GError **error)
{
    QmiMessage *self;

    self = qmi_message_new (QMI_SERVICE_UIM,
                            cid,
                            transaction_id,
                            QMI_MESSAGE_UIM_READ_TRANSPARENT);

    /* There is at least one mandatory TLV, don't allow NULL input */
    if (!input) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_ARGS,
                     "Message 'Read Transparent' has mandatory TLVs");
        qmi_message_unref (self);
        return NULL;
    }

    /* Try to add the 'Encrypt Data' TLV */
    if (input->arg_encrypt_data_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        if (buffer_len < 1)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_ENCRYPT_DATA;
        else {
            guint8 tmp;

            tmp = (guint8)input->arg_encrypt_data;
            /* Write the guint8 variable to the buffer */
            qmi_utils_write_guint8_to_buffer (
                &buffer_aux,
                &buffer_len,
                &tmp);
        }

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_ENCRYPT_DATA:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_ENCRYPT_DATA;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_ENCRYPT_DATA,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_ENCRYPT_DATA:
            g_prefix_error (error, "Couldn't set the Encrypt Data TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    }

    /* Try to add the 'Response In Indication Token' TLV */
    if (input->arg_response_in_indication_token_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        /* Write the guint32 variable to the buffer */
        if (buffer_len < 4)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN;
        else
            qmi_utils_write_guint32_to_buffer (
                &buffer_aux,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &(input->arg_response_in_indication_token));

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN:
            g_prefix_error (error, "Couldn't set the Response In Indication Token TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    }

    /* Try to add the 'Read Information' TLV */
    if (input->arg_read_information_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        /* Write the guint16 variable to the buffer */
        if (buffer_len < 2)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_READ_INFORMATION;
        else
            qmi_utils_write_guint16_to_buffer (
                &buffer_aux,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &(input->arg_read_information_offset));
        /* Write the guint16 variable to the buffer */
        if (buffer_len < 2)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_READ_INFORMATION;
        else
            qmi_utils_write_guint16_to_buffer (
                &buffer_aux,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &(input->arg_read_information_length));

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_READ_INFORMATION:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_READ_INFORMATION;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_READ_INFORMATION,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_READ_INFORMATION:
            g_prefix_error (error, "Couldn't set the Read Information TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    } else {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_ARGS,
                     "Missing mandatory TLV 'Read Information' in message 'Read Transparent'");
        qmi_message_unref (self);
        return NULL;
    }

    /* Try to add the 'File' TLV */
    if (input->arg_file_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        /* Write the guint16 variable to the buffer */
        if (buffer_len < 2)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_FILE;
        else
            qmi_utils_write_guint16_to_buffer (
                &buffer_aux,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &(input->arg_file_file_id));
        {
            guint file_path_i;
            guint8 file_path_n_items;

            /* Write the number of items in the array first */
            file_path_n_items = (guint8) input->arg_file_file_path->len;
            /* Write the guint8 variable to the buffer */
            if (buffer_len < 1)
                goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_FILE;
            else
                qmi_utils_write_guint8_to_buffer (
                    &buffer_aux,
                    &buffer_len,
                    &(file_path_n_items));

            for (file_path_i = 0; file_path_i < input->arg_file_file_path->len; file_path_i++) {
                /* Write the guint8 variable to the buffer */
                if (buffer_len < 1)
                    goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_FILE;
                else
                    qmi_utils_write_guint8_to_buffer (
                        &buffer_aux,
                        &buffer_len,
                        &(g_array_index (input->arg_file_file_path, guint8,file_path_i)));
            }
        }

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_FILE:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_FILE;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_FILE,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_FILE:
            g_prefix_error (error, "Couldn't set the File TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    } else {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_ARGS,
                     "Missing mandatory TLV 'File' in message 'Read Transparent'");
        qmi_message_unref (self);
        return NULL;
    }

    /* Try to add the 'Session Information' TLV */
    if (input->arg_session_information_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        if (buffer_len < 1)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_SESSION_INFORMATION;
        else {
            guint8 tmp;

            tmp = (guint8)input->arg_session_information_session_type;
            /* Write the guint8 variable to the buffer */
            qmi_utils_write_guint8_to_buffer (
                &buffer_aux,
                &buffer_len,
                &tmp);
        }
        /* Write the string variable to the buffer */
        if (!input->arg_session_information_application_identifier || buffer_len < 8 + strlen (input->arg_session_information_application_identifier))
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_SESSION_INFORMATION;
        else
            qmi_utils_write_string_to_buffer (
               &buffer_aux,
               &buffer_len,
               8,
               input->arg_session_information_application_identifier);

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_SESSION_INFORMATION:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_SESSION_INFORMATION;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_SESSION_INFORMATION,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_SESSION_INFORMATION:
            g_prefix_error (error, "Couldn't set the Session Information TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    } else {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_ARGS,
                     "Missing mandatory TLV 'Session Information' in message 'Read Transparent'");
        qmi_message_unref (self);
        return NULL;
    }

    return self;
}

/* --- Output -- */

struct _QmiMessageUimReadTransparentOutput {
    volatile gint ref_count;

    /* Result */
    gboolean arg_result_set;
    QmiMessageResult arg_result;

    /* Card result */
    gboolean arg_card_result_set;
    guint8 arg_card_result_sw1;
    guint8 arg_card_result_sw2;

    /* Read result */
    gboolean arg_read_result_set;
    GArray *arg_read_result;

    /* Response In Indication Token */
    gboolean arg_response_in_indication_token_set;
    guint32 arg_response_in_indication_token;

    /* Encrypted Data */
    gboolean arg_encrypted_data_set;
    guint8 arg_encrypted_data;
};

#define QMI_MESSAGE_UIM_READ_TRANSPARENT_OUTPUT_TLV_RESULT 0x02
#define QMI_MESSAGE_UIM_READ_TRANSPARENT_OUTPUT_TLV_CARD_RESULT 0x10
#define QMI_MESSAGE_UIM_READ_TRANSPARENT_OUTPUT_TLV_READ_RESULT 0x11
#define QMI_MESSAGE_UIM_READ_TRANSPARENT_OUTPUT_TLV_RESPONSE_IN_INDICATION_TOKEN 0x12
#define QMI_MESSAGE_UIM_READ_TRANSPARENT_OUTPUT_TLV_ENCRYPTED_DATA 0x13

/**
 * qmi_message_uim_read_transparent_output_get_result:
 * @self: a QmiMessageUimReadTransparentOutput.
 * @error: Return location for error or %NULL.
 *
 * Get the result of the QMI operation.
 *
 * Returns: %TRUE if the QMI operation succeeded, %FALSE if @error is set.
 */
gboolean
qmi_message_uim_read_transparent_output_get_result (
    QmiMessageUimReadTransparentOutput *self,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    /* We should always have a result set in the response message */
    if (!self->arg_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_MESSAGE,
                     "No 'Result' field given in the message");
        return FALSE;
    }

    if (self->arg_result.error_status == QMI_STATUS_SUCCESS) {
        /* Operation succeeded */
        return TRUE;
    }

    /* Report a QMI protocol error */
    g_set_error (error,
                 QMI_PROTOCOL_ERROR,
                 (QmiProtocolError) self->arg_result.error_code,
                 "QMI protocol error (%u): '%s'",
                 self->arg_result.error_code,
                 qmi_protocol_error_get_string ((QmiProtocolError) self->arg_result.error_code));
    return FALSE;
}

/**
 * qmi_message_uim_read_transparent_output_get_card_result:
 * @self: a #QmiMessageUimReadTransparentOutput.
 * @card_result_sw1: a placeholder for the output #guint8, or %NULL if not required.
 * @card_result_sw2: a placeholder for the output #guint8, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Card result' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_transparent_output_get_card_result (
    QmiMessageUimReadTransparentOutput *self,
    guint8 *card_result_sw1,
    guint8 *card_result_sw2,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_card_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Card result' was not found in the message");
        return FALSE;
    }

    if (card_result_sw1)
        *card_result_sw1 = self->arg_card_result_sw1;
    if (card_result_sw2)
        *card_result_sw2 = self->arg_card_result_sw2;

    return TRUE;
}

/**
 * qmi_message_uim_read_transparent_output_get_read_result:
 * @self: a #QmiMessageUimReadTransparentOutput.
 * @read_result: a placeholder for the output #GArray of #guint8 elements, or %NULL if not required. Do not free it, it is owned by @self.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Read result' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_transparent_output_get_read_result (
    QmiMessageUimReadTransparentOutput *self,
    GArray **read_result,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_read_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Read result' was not found in the message");
        return FALSE;
    }

    if (read_result)
        *read_result = self->arg_read_result;

    return TRUE;
}

/**
 * qmi_message_uim_read_transparent_output_get_response_in_indication_token:
 * @self: a #QmiMessageUimReadTransparentOutput.
 * @response_in_indication_token: a placeholder for the output #guint32, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Response In Indication Token' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_transparent_output_get_response_in_indication_token (
    QmiMessageUimReadTransparentOutput *self,
    guint32 *response_in_indication_token,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_response_in_indication_token_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Response In Indication Token' was not found in the message");
        return FALSE;
    }

    if (response_in_indication_token)
        *response_in_indication_token = self->arg_response_in_indication_token;

    return TRUE;
}

/**
 * qmi_message_uim_read_transparent_output_get_encrypted_data:
 * @self: a #QmiMessageUimReadTransparentOutput.
 * @encrypted_data: a placeholder for the output #gboolean, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Encrypted Data' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_transparent_output_get_encrypted_data (
    QmiMessageUimReadTransparentOutput *self,
    gboolean *encrypted_data,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_encrypted_data_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Encrypted Data' was not found in the message");
        return FALSE;
    }

    if (encrypted_data)
        *encrypted_data = (gboolean)(self->arg_encrypted_data);

    return TRUE;
}

GType
qmi_message_uim_read_transparent_output_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageUimReadTransparentOutput"),
                                          (GBoxedCopyFunc) qmi_message_uim_read_transparent_output_ref,
                                          (GBoxedFreeFunc) qmi_message_uim_read_transparent_output_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_uim_read_transparent_output_ref:
 * @self: a #QmiMessageUimReadTransparentOutput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageUimReadTransparentOutput *
qmi_message_uim_read_transparent_output_ref (QmiMessageUimReadTransparentOutput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_uim_read_transparent_output_unref:
 * @self: a #QmiMessageUimReadTransparentOutput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_uim_read_transparent_output_unref (QmiMessageUimReadTransparentOutput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        if (self->arg_read_result)
            g_array_unref (self->arg_read_result);
        g_slice_free (QmiMessageUimReadTransparentOutput, self);
    }
}

static gboolean
qmi_message_uim_read_transparent_input_encrypt_data_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Encrypt Data' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Encrypt Data' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_read_transparent_input_encrypt_data_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_ENCRYPT_DATA,
                                      &buffer_len);
    if (buffer && qmi_message_uim_read_transparent_input_encrypt_data_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%s", tmp ? "yes" : "no");
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Encrypt Data' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_read_transparent_input_response_in_indication_token_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Response In Indication Token' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Response In Indication Token' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_read_transparent_input_response_in_indication_token_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN,
                                      &buffer_len);
    if (buffer && qmi_message_uim_read_transparent_input_response_in_indication_token_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT32_FORMAT "", tmp);
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Response In Indication Token' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_read_transparent_input_read_information_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 2;
    expected_len += 2;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Read Information' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Read Information' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_read_transparent_input_read_information_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_READ_INFORMATION,
                                      &buffer_len);
    if (buffer && qmi_message_uim_read_transparent_input_read_information_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " offset = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " length = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Read Information' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_read_transparent_input_file_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 2;
    {
        guint file_path_i;

        guint8 file_path_n_items;
        const guint8 *file_path_aux_buffer = &buffer[expected_len];
        guint16 file_path_aux_buffer_len;

        file_path_aux_buffer_len = ((buffer_len >= expected_len) ? buffer_len - expected_len : 0);
        if (file_path_aux_buffer_len < 1) {
            g_warning ("Cannot read the array size: expected '%u' bytes, but only got '%u' bytes",
                       1, file_path_aux_buffer_len);
            return FALSE;
        }

        expected_len += 1;
        /* Read the guint8 variable from the buffer */
        qmi_utils_read_guint8_from_buffer (
            &file_path_aux_buffer,
            &file_path_aux_buffer_len,
            &(file_path_n_items));

        for (file_path_i = 0; file_path_i < file_path_n_items; file_path_i++) {

            expected_len += 1;
        }
    }

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'File' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'File' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_read_transparent_input_file_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_FILE,
                                      &buffer_len);
    if (buffer && qmi_message_uim_read_transparent_input_file_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " file_id = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " file_path = '");
        {
            guint file_path_i;
            guint8 file_path_n_items;

            /* Read number of items in the array */
            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &(file_path_n_items));

            g_string_append (printable, "{");

            for (file_path_i = 0; file_path_i < file_path_n_items; file_path_i++) {
                g_string_append_printf (printable, " [%u] = '", file_path_i);

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, " '");
            }

            g_string_append (printable, "}");
        }        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'File' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_read_transparent_input_session_information_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;
    {
        guint8 size8;
        const guint8 *aux_buffer = &buffer[expected_len];
        guint16 aux_buffer_len;

        aux_buffer_len = ((buffer_len >= expected_len) ? buffer_len - expected_len : 0);
        if (aux_buffer_len < 1) {
            g_warning ("Cannot read the string size: expected '1' bytes, but only got '%u' bytes",
                       aux_buffer_len);
            return FALSE;
        }

        qmi_utils_read_guint8_from_buffer (&aux_buffer, &aux_buffer_len, &size8);
        expected_len += (1 + size8);
    }

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Session Information' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Session Information' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_read_transparent_input_session_information_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_SESSION_INFORMATION,
                                      &buffer_len);
    if (buffer && qmi_message_uim_read_transparent_input_session_information_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " session_type = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_UIM_SESSION_TYPE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_uim_session_type_get_string ((QmiUimSessionType)tmp));
#elif defined  __QMI_UIM_SESSION_TYPE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_uim_session_type_build_string_from_mask ((QmiUimSessionType)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiUimSessionType
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " application_identifier = '");

        {
            gchar *tmp;

            /* Read the string variable from the buffer */
            qmi_utils_read_string_from_buffer (
                &buffer,
                &buffer_len,
                8,
                0,
                &tmp);

            g_string_append_printf (printable, "%s", tmp);
            g_free (tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Session Information' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_read_transparent_output_card_result_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;
    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Card result' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Card result' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_read_transparent_output_card_result_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_READ_TRANSPARENT_OUTPUT_TLV_CARD_RESULT,
                                      &buffer_len);
    if (buffer && qmi_message_uim_read_transparent_output_card_result_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " sw1 = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " sw2 = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Card result' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_read_transparent_output_read_result_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    {
        guint read_result_i;

        guint16 read_result_n_items;
        const guint8 *read_result_aux_buffer = &buffer[expected_len];
        guint16 read_result_aux_buffer_len;

        read_result_aux_buffer_len = ((buffer_len >= expected_len) ? buffer_len - expected_len : 0);
        if (read_result_aux_buffer_len < 2) {
            g_warning ("Cannot read the array size: expected '%u' bytes, but only got '%u' bytes",
                       2, read_result_aux_buffer_len);
            return FALSE;
        }

        expected_len += 2;
        /* Read the guint16 variable from the buffer */
        qmi_utils_read_guint16_from_buffer (
            &read_result_aux_buffer,
            &read_result_aux_buffer_len,
            QMI_ENDIAN_LITTLE,
            &(read_result_n_items));

        for (read_result_i = 0; read_result_i < read_result_n_items; read_result_i++) {

            expected_len += 1;
        }
    }

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Read result' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Read result' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_read_transparent_output_read_result_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_READ_TRANSPARENT_OUTPUT_TLV_READ_RESULT,
                                      &buffer_len);
    if (buffer && qmi_message_uim_read_transparent_output_read_result_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        {
            guint read_result_i;
            guint16 read_result_n_items;

            /* Read number of items in the array */
            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &(read_result_n_items));

            g_string_append (printable, "{");

            for (read_result_i = 0; read_result_i < read_result_n_items; read_result_i++) {
                g_string_append_printf (printable, " [%u] = '", read_result_i);

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, " '");
            }

            g_string_append (printable, "}");
        }
        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Read result' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_read_transparent_output_response_in_indication_token_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Response In Indication Token' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Response In Indication Token' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_read_transparent_output_response_in_indication_token_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_READ_TRANSPARENT_OUTPUT_TLV_RESPONSE_IN_INDICATION_TOKEN,
                                      &buffer_len);
    if (buffer && qmi_message_uim_read_transparent_output_response_in_indication_token_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT32_FORMAT "", tmp);
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Response In Indication Token' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_read_transparent_output_encrypted_data_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Encrypted Data' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Encrypted Data' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_read_transparent_output_encrypted_data_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_READ_TRANSPARENT_OUTPUT_TLV_ENCRYPTED_DATA,
                                      &buffer_len);
    if (buffer && qmi_message_uim_read_transparent_output_encrypted_data_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%s", tmp ? "yes" : "no");
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Encrypted Data' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

struct message_read_transparent_context {
    QmiMessage *self;
    const gchar *line_prefix;
    GString *printable;
};

static void
message_read_transparent_get_tlv_printable (
    guint8 type,
    const guint8 *value,
    gsize length,
    struct message_read_transparent_context *ctx)
{
    const gchar *tlv_type_str = NULL;
    gchar *translated_value;

    if (!qmi_message_is_response (ctx->self)) {
        switch (type) {
        case QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_ENCRYPT_DATA:
            tlv_type_str = "Encrypt Data";
            translated_value = qmi_message_uim_read_transparent_input_encrypt_data_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN:
            tlv_type_str = "Response In Indication Token";
            translated_value = qmi_message_uim_read_transparent_input_response_in_indication_token_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_READ_INFORMATION:
            tlv_type_str = "Read Information";
            translated_value = qmi_message_uim_read_transparent_input_read_information_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_FILE:
            tlv_type_str = "File";
            translated_value = qmi_message_uim_read_transparent_input_file_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_READ_TRANSPARENT_INPUT_TLV_SESSION_INFORMATION:
            tlv_type_str = "Session Information";
            translated_value = qmi_message_uim_read_transparent_input_session_information_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    } else {
        switch (type) {
        case QMI_MESSAGE_UIM_READ_TRANSPARENT_OUTPUT_TLV_RESULT:
            tlv_type_str = "Result";
            translated_value = qmi_message_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_READ_TRANSPARENT_OUTPUT_TLV_CARD_RESULT:
            tlv_type_str = "Card result";
            translated_value = qmi_message_uim_read_transparent_output_card_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_READ_TRANSPARENT_OUTPUT_TLV_READ_RESULT:
            tlv_type_str = "Read result";
            translated_value = qmi_message_uim_read_transparent_output_read_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_READ_TRANSPARENT_OUTPUT_TLV_RESPONSE_IN_INDICATION_TOKEN:
            tlv_type_str = "Response In Indication Token";
            translated_value = qmi_message_uim_read_transparent_output_response_in_indication_token_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_READ_TRANSPARENT_OUTPUT_TLV_ENCRYPTED_DATA:
            tlv_type_str = "Encrypted Data";
            translated_value = qmi_message_uim_read_transparent_output_encrypted_data_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    }

    if (!tlv_type_str) {
        gchar *value_str = NULL;

        value_str = qmi_message_get_tlv_printable (ctx->self,
                                                   ctx->line_prefix,
                                                   type,
                                                   value,
                                                   length);
        g_string_append (ctx->printable, value_str);
        g_free (value_str);
    } else {
        gchar *value_hex;

        value_hex = __qmi_utils_str_hex (value, length, ':');
        g_string_append_printf (ctx->printable,
                                "%sTLV:\n"
                                "%s  type       = \"%s\" (0x%02x)\n"
                                "%s  length     = %" G_GSIZE_FORMAT "\n"
                                "%s  value      = %s\n"
                                "%s  translated = %s\n",
                                ctx->line_prefix,
                                ctx->line_prefix, tlv_type_str, type,
                                ctx->line_prefix, length,
                                ctx->line_prefix, value_hex,
                                ctx->line_prefix, translated_value ? translated_value : "");
        g_free (value_hex);
        g_free (translated_value);
    }
}

static gchar *
message_read_transparent_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    GString *printable;

    printable = g_string_new ("");
    g_string_append_printf (printable,
                            "%s  message     = \"Read Transparent\" (0x0020)\n",
                            line_prefix);

    {
        struct message_read_transparent_context ctx;
        ctx.self = self;
        ctx.line_prefix = line_prefix;
        ctx.printable = printable;
        qmi_message_foreach_raw_tlv (self,
                                     (QmiMessageForeachRawTlvFn)message_read_transparent_get_tlv_printable,
                                     &ctx);
    }

    return g_string_free (printable, FALSE);
}

static QmiMessageUimReadTransparentOutput *
__qmi_message_uim_read_transparent_response_parse (
    QmiMessage *message,
    GError **error)
{
    QmiMessageUimReadTransparentOutput *self;

    g_return_val_if_fail (qmi_message_get_message_id (message) == QMI_MESSAGE_UIM_READ_TRANSPARENT, NULL);

    self = g_slice_new0 (QmiMessageUimReadTransparentOutput);
    self->ref_count = 1;

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_UIM_READ_TRANSPARENT_OUTPUT_TLV_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_result_validate (buffer, buffer_len)) {
                self->arg_result_set = TRUE;

                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_status));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_code));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Result' TLV", buffer_len);
                }
            } else {
                g_set_error (error,
                             QMI_CORE_ERROR,
                             QMI_CORE_ERROR_TLV_NOT_FOUND,
                             "Couldn't get the Result TLV: Not found");
                qmi_message_uim_read_transparent_output_unref (self);
                return NULL;
            }

        }
    } while (0);

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_UIM_READ_TRANSPARENT_OUTPUT_TLV_CARD_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_uim_read_transparent_output_card_result_validate (buffer, buffer_len)) {
                self->arg_card_result_set = TRUE;

                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_card_result_sw1));
                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_card_result_sw2));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Card result' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_UIM_READ_TRANSPARENT_OUTPUT_TLV_READ_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_uim_read_transparent_output_read_result_validate (buffer, buffer_len)) {
                self->arg_read_result_set = TRUE;

                {
                    guint read_result_i;
                    guint16 read_result_n_items;

                    /* Read number of items in the array */
                    /* Read the guint16 variable from the buffer */
                    qmi_utils_read_guint16_from_buffer (
                        &buffer,
                        &buffer_len,
                        QMI_ENDIAN_LITTLE,
                        &(read_result_n_items));

                    self->arg_read_result = g_array_sized_new (
                        FALSE,
                        FALSE,
                        sizeof (guint8),
                        (guint)read_result_n_items);

                    for (read_result_i = 0; read_result_i < read_result_n_items; read_result_i++) {
                        guint8 read_result_aux;

                        /* Read the guint8 variable from the buffer */
                        qmi_utils_read_guint8_from_buffer (
                            &buffer,
                            &buffer_len,
                            &(read_result_aux));
                        g_array_insert_val (self->arg_read_result, read_result_i, read_result_aux);
                    }
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Read result' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_UIM_READ_TRANSPARENT_OUTPUT_TLV_RESPONSE_IN_INDICATION_TOKEN,
                                              &buffer_len);
            if (buffer && qmi_message_uim_read_transparent_output_response_in_indication_token_validate (buffer, buffer_len)) {
                self->arg_response_in_indication_token_set = TRUE;

                /* Read the guint32 variable from the buffer */
                qmi_utils_read_guint32_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_response_in_indication_token));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Response In Indication Token' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_UIM_READ_TRANSPARENT_OUTPUT_TLV_ENCRYPTED_DATA,
                                              &buffer_len);
            if (buffer && qmi_message_uim_read_transparent_output_encrypted_data_validate (buffer, buffer_len)) {
                self->arg_encrypted_data_set = TRUE;

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_encrypted_data = (gboolean)tmp;
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Encrypted Data' TLV", buffer_len);
                }
            }

        }
    } while (0);

    return self;
}

/*****************************************************************************/
/* REQUEST/RESPONSE: Qmi Message UIM Read Record */


/* --- Input -- */

struct _QmiMessageUimReadRecordInput {
    volatile gint ref_count;

    /* Response In Indication Token */
    gboolean arg_response_in_indication_token_set;
    guint32 arg_response_in_indication_token;

    /* Last Record */
    gboolean arg_last_record_set;
    guint16 arg_last_record;

    /* Record */
    gboolean arg_record_set;
    guint16 arg_record_record_number;
    guint16 arg_record_record_length;

    /* File */
    gboolean arg_file_set;
    guint16 arg_file_file_id;
    GArray *arg_file_file_path;

    /* Session Information */
    gboolean arg_session_information_set;
    guint8 arg_session_information_session_type;
    gchar *arg_session_information_application_identifier;
};

#define QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN 0x11
#define QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_LAST_RECORD 0x10
#define QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_RECORD 0x03
#define QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_FILE 0x02
#define QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_SESSION_INFORMATION 0x01

/**
 * qmi_message_uim_read_record_input_get_response_in_indication_token:
 * @self: a #QmiMessageUimReadRecordInput.
 * @response_in_indication_token: a placeholder for the output #guint32, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Response In Indication Token' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_record_input_get_response_in_indication_token (
    QmiMessageUimReadRecordInput *self,
    guint32 *response_in_indication_token,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_response_in_indication_token_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Response In Indication Token' was not found in the message");
        return FALSE;
    }

    if (response_in_indication_token)
        *response_in_indication_token = self->arg_response_in_indication_token;

    return TRUE;
}

/**
 * qmi_message_uim_read_record_input_set_response_in_indication_token:
 * @self: a #QmiMessageUimReadRecordInput.
 * @response_in_indication_token: a #guint32.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Response In Indication Token' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_record_input_set_response_in_indication_token (
    QmiMessageUimReadRecordInput *self,
    guint32 response_in_indication_token,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_response_in_indication_token = response_in_indication_token;
    self->arg_response_in_indication_token_set = TRUE;

    return TRUE;
}

/**
 * qmi_message_uim_read_record_input_get_last_record:
 * @self: a #QmiMessageUimReadRecordInput.
 * @last_record: a placeholder for the output #guint16, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Last Record' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_record_input_get_last_record (
    QmiMessageUimReadRecordInput *self,
    guint16 *last_record,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_last_record_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Last Record' was not found in the message");
        return FALSE;
    }

    if (last_record)
        *last_record = self->arg_last_record;

    return TRUE;
}

/**
 * qmi_message_uim_read_record_input_set_last_record:
 * @self: a #QmiMessageUimReadRecordInput.
 * @last_record: a #guint16.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Last Record' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_record_input_set_last_record (
    QmiMessageUimReadRecordInput *self,
    guint16 last_record,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_last_record = last_record;
    self->arg_last_record_set = TRUE;

    return TRUE;
}

/**
 * qmi_message_uim_read_record_input_get_record:
 * @self: a #QmiMessageUimReadRecordInput.
 * @record_record_number: a placeholder for the output #guint16, or %NULL if not required.
 * @record_record_length: a placeholder for the output #guint16, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Record' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_record_input_get_record (
    QmiMessageUimReadRecordInput *self,
    guint16 *record_record_number,
    guint16 *record_record_length,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_record_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Record' was not found in the message");
        return FALSE;
    }

    if (record_record_number)
        *record_record_number = self->arg_record_record_number;
    if (record_record_length)
        *record_record_length = self->arg_record_record_length;

    return TRUE;
}

/**
 * qmi_message_uim_read_record_input_set_record:
 * @self: a #QmiMessageUimReadRecordInput.
 * @record_record_number: a #guint16.
 * @record_record_length: a #guint16.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Record' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_record_input_set_record (
    QmiMessageUimReadRecordInput *self,
    guint16 record_record_number,
    guint16 record_record_length,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_record_record_number = record_record_number;
    self->arg_record_record_length = record_record_length;
    self->arg_record_set = TRUE;

    return TRUE;
}

/**
 * qmi_message_uim_read_record_input_get_file:
 * @self: a #QmiMessageUimReadRecordInput.
 * @file_file_id: a placeholder for the output #guint16, or %NULL if not required.
 * @file_file_path: a placeholder for the output #GArray of #guint8 elements, or %NULL if not required. Do not free it, it is owned by @self.
 * @error: Return location for error or %NULL.
 *
 * Get the 'File' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_record_input_get_file (
    QmiMessageUimReadRecordInput *self,
    guint16 *file_file_id,
    GArray **file_file_path,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_file_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'File' was not found in the message");
        return FALSE;
    }

    if (file_file_id)
        *file_file_id = self->arg_file_file_id;
    if (file_file_path)
        *file_file_path = self->arg_file_file_path;

    return TRUE;
}

/**
 * qmi_message_uim_read_record_input_set_file:
 * @self: a #QmiMessageUimReadRecordInput.
 * @file_file_id: a #guint16.
 * @file_file_path: a #GArray of #guint8 elements. A new reference to @file_file_path will be taken.
 * @error: Return location for error or %NULL.
 *
 * Set the 'File' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_record_input_set_file (
    QmiMessageUimReadRecordInput *self,
    guint16 file_file_id,
    GArray *file_file_path,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_file_file_id = file_file_id;
    if (self->arg_file_file_path)
        g_array_unref (self->arg_file_file_path);
    self->arg_file_file_path = g_array_ref (file_file_path);
    self->arg_file_set = TRUE;

    return TRUE;
}

/**
 * qmi_message_uim_read_record_input_get_session_information:
 * @self: a #QmiMessageUimReadRecordInput.
 * @session_information_session_type: a placeholder for the output #QmiUimSessionType, or %NULL if not required.
 * @session_information_application_identifier: a placeholder for the output constant string, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Session Information' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_record_input_get_session_information (
    QmiMessageUimReadRecordInput *self,
    QmiUimSessionType *session_information_session_type,
    const gchar **session_information_application_identifier,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_session_information_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Session Information' was not found in the message");
        return FALSE;
    }

    if (session_information_session_type)
        *session_information_session_type = (QmiUimSessionType)(self->arg_session_information_session_type);
    if (session_information_application_identifier)
        *session_information_application_identifier = self->arg_session_information_application_identifier;

    return TRUE;
}

/**
 * qmi_message_uim_read_record_input_set_session_information:
 * @self: a #QmiMessageUimReadRecordInput.
 * @session_information_session_type: a #QmiUimSessionType.
 * @session_information_application_identifier: a constant string.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Session Information' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_record_input_set_session_information (
    QmiMessageUimReadRecordInput *self,
    QmiUimSessionType session_information_session_type,
    const gchar *session_information_application_identifier,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_session_information_session_type = (guint8)(session_information_session_type);
    g_free (self->arg_session_information_application_identifier);
    self->arg_session_information_application_identifier = g_strdup (session_information_application_identifier ? session_information_application_identifier : "");
    self->arg_session_information_set = TRUE;

    return TRUE;
}

GType
qmi_message_uim_read_record_input_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageUimReadRecordInput"),
                                          (GBoxedCopyFunc) qmi_message_uim_read_record_input_ref,
                                          (GBoxedFreeFunc) qmi_message_uim_read_record_input_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_uim_read_record_input_ref:
 * @self: a #QmiMessageUimReadRecordInput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageUimReadRecordInput *
qmi_message_uim_read_record_input_ref (QmiMessageUimReadRecordInput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_uim_read_record_input_unref:
 * @self: a #QmiMessageUimReadRecordInput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_uim_read_record_input_unref (QmiMessageUimReadRecordInput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        if (self->arg_file_file_path)
            g_array_unref (self->arg_file_file_path);
        g_free (self->arg_session_information_application_identifier);
        g_slice_free (QmiMessageUimReadRecordInput, self);
    }
}

/**
 * qmi_message_uim_read_record_input_new:
 *
 * Allocates a new #QmiMessageUimReadRecordInput.
 *
 * Returns: the newly created #QmiMessageUimReadRecordInput. The returned value should be freed with qmi_message_uim_read_record_input_unref().
 */
QmiMessageUimReadRecordInput *
qmi_message_uim_read_record_input_new (void)
{
    QmiMessageUimReadRecordInput *self;

    self = g_slice_new0 (QmiMessageUimReadRecordInput);
    self->ref_count = 1;
    return self;
}

static QmiMessage *
__qmi_message_uim_read_record_request_create (
    guint8 transaction_id,
    guint8 cid,
    QmiMessageUimReadRecordInput *input,
    GError **error)
{
    QmiMessage *self;

    self = qmi_message_new (QMI_SERVICE_UIM,
                            cid,
                            transaction_id,
                            QMI_MESSAGE_UIM_READ_RECORD);

    /* There is at least one mandatory TLV, don't allow NULL input */
    if (!input) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_ARGS,
                     "Message 'Read Record' has mandatory TLVs");
        qmi_message_unref (self);
        return NULL;
    }

    /* Try to add the 'Response In Indication Token' TLV */
    if (input->arg_response_in_indication_token_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        /* Write the guint32 variable to the buffer */
        if (buffer_len < 4)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN;
        else
            qmi_utils_write_guint32_to_buffer (
                &buffer_aux,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &(input->arg_response_in_indication_token));

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN:
            g_prefix_error (error, "Couldn't set the Response In Indication Token TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    }

    /* Try to add the 'Last Record' TLV */
    if (input->arg_last_record_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        /* Write the guint16 variable to the buffer */
        if (buffer_len < 2)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_LAST_RECORD;
        else
            qmi_utils_write_guint16_to_buffer (
                &buffer_aux,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &(input->arg_last_record));

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_LAST_RECORD:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_LAST_RECORD;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_LAST_RECORD,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_LAST_RECORD:
            g_prefix_error (error, "Couldn't set the Last Record TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    }

    /* Try to add the 'Record' TLV */
    if (input->arg_record_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        /* Write the guint16 variable to the buffer */
        if (buffer_len < 2)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_RECORD;
        else
            qmi_utils_write_guint16_to_buffer (
                &buffer_aux,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &(input->arg_record_record_number));
        /* Write the guint16 variable to the buffer */
        if (buffer_len < 2)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_RECORD;
        else
            qmi_utils_write_guint16_to_buffer (
                &buffer_aux,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &(input->arg_record_record_length));

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_RECORD:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_RECORD;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_RECORD,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_RECORD:
            g_prefix_error (error, "Couldn't set the Record TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    } else {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_ARGS,
                     "Missing mandatory TLV 'Record' in message 'Read Record'");
        qmi_message_unref (self);
        return NULL;
    }

    /* Try to add the 'File' TLV */
    if (input->arg_file_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        /* Write the guint16 variable to the buffer */
        if (buffer_len < 2)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_FILE;
        else
            qmi_utils_write_guint16_to_buffer (
                &buffer_aux,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &(input->arg_file_file_id));
        {
            guint file_path_i;
            guint8 file_path_n_items;

            /* Write the number of items in the array first */
            file_path_n_items = (guint8) input->arg_file_file_path->len;
            /* Write the guint8 variable to the buffer */
            if (buffer_len < 1)
                goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_FILE;
            else
                qmi_utils_write_guint8_to_buffer (
                    &buffer_aux,
                    &buffer_len,
                    &(file_path_n_items));

            for (file_path_i = 0; file_path_i < input->arg_file_file_path->len; file_path_i++) {
                /* Write the guint8 variable to the buffer */
                if (buffer_len < 1)
                    goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_FILE;
                else
                    qmi_utils_write_guint8_to_buffer (
                        &buffer_aux,
                        &buffer_len,
                        &(g_array_index (input->arg_file_file_path, guint8,file_path_i)));
            }
        }

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_FILE:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_FILE;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_FILE,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_FILE:
            g_prefix_error (error, "Couldn't set the File TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    } else {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_ARGS,
                     "Missing mandatory TLV 'File' in message 'Read Record'");
        qmi_message_unref (self);
        return NULL;
    }

    /* Try to add the 'Session Information' TLV */
    if (input->arg_session_information_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        if (buffer_len < 1)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_SESSION_INFORMATION;
        else {
            guint8 tmp;

            tmp = (guint8)input->arg_session_information_session_type;
            /* Write the guint8 variable to the buffer */
            qmi_utils_write_guint8_to_buffer (
                &buffer_aux,
                &buffer_len,
                &tmp);
        }
        /* Write the string variable to the buffer */
        if (!input->arg_session_information_application_identifier || buffer_len < 8 + strlen (input->arg_session_information_application_identifier))
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_SESSION_INFORMATION;
        else
            qmi_utils_write_string_to_buffer (
               &buffer_aux,
               &buffer_len,
               8,
               input->arg_session_information_application_identifier);

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_SESSION_INFORMATION:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_SESSION_INFORMATION;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_SESSION_INFORMATION,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_SESSION_INFORMATION:
            g_prefix_error (error, "Couldn't set the Session Information TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    } else {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_ARGS,
                     "Missing mandatory TLV 'Session Information' in message 'Read Record'");
        qmi_message_unref (self);
        return NULL;
    }

    return self;
}

/* --- Output -- */

struct _QmiMessageUimReadRecordOutput {
    volatile gint ref_count;

    /* Result */
    gboolean arg_result_set;
    QmiMessageResult arg_result;

    /* Card result */
    gboolean arg_card_result_set;
    guint8 arg_card_result_sw1;
    guint8 arg_card_result_sw2;

    /* Read Result */
    gboolean arg_read_result_set;
    GArray *arg_read_result;

    /* Additional Read Result */
    gboolean arg_additional_read_result_set;
    GArray *arg_additional_read_result;

    /* Response In Indication Token */
    gboolean arg_response_in_indication_token_set;
    guint32 arg_response_in_indication_token;
};

#define QMI_MESSAGE_UIM_READ_RECORD_OUTPUT_TLV_RESULT 0x02
#define QMI_MESSAGE_UIM_READ_RECORD_OUTPUT_TLV_CARD_RESULT 0x10
#define QMI_MESSAGE_UIM_READ_RECORD_OUTPUT_TLV_READ_RESULT 0x11
#define QMI_MESSAGE_UIM_READ_RECORD_OUTPUT_TLV_ADDITIONAL_READ_RESULT 0x12
#define QMI_MESSAGE_UIM_READ_RECORD_OUTPUT_TLV_RESPONSE_IN_INDICATION_TOKEN 0x13

/**
 * qmi_message_uim_read_record_output_get_result:
 * @self: a QmiMessageUimReadRecordOutput.
 * @error: Return location for error or %NULL.
 *
 * Get the result of the QMI operation.
 *
 * Returns: %TRUE if the QMI operation succeeded, %FALSE if @error is set.
 */
gboolean
qmi_message_uim_read_record_output_get_result (
    QmiMessageUimReadRecordOutput *self,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    /* We should always have a result set in the response message */
    if (!self->arg_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_MESSAGE,
                     "No 'Result' field given in the message");
        return FALSE;
    }

    if (self->arg_result.error_status == QMI_STATUS_SUCCESS) {
        /* Operation succeeded */
        return TRUE;
    }

    /* Report a QMI protocol error */
    g_set_error (error,
                 QMI_PROTOCOL_ERROR,
                 (QmiProtocolError) self->arg_result.error_code,
                 "QMI protocol error (%u): '%s'",
                 self->arg_result.error_code,
                 qmi_protocol_error_get_string ((QmiProtocolError) self->arg_result.error_code));
    return FALSE;
}

/**
 * qmi_message_uim_read_record_output_get_card_result:
 * @self: a #QmiMessageUimReadRecordOutput.
 * @card_result_sw1: a placeholder for the output #guint8, or %NULL if not required.
 * @card_result_sw2: a placeholder for the output #guint8, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Card result' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_record_output_get_card_result (
    QmiMessageUimReadRecordOutput *self,
    guint8 *card_result_sw1,
    guint8 *card_result_sw2,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_card_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Card result' was not found in the message");
        return FALSE;
    }

    if (card_result_sw1)
        *card_result_sw1 = self->arg_card_result_sw1;
    if (card_result_sw2)
        *card_result_sw2 = self->arg_card_result_sw2;

    return TRUE;
}

/**
 * qmi_message_uim_read_record_output_get_read_result:
 * @self: a #QmiMessageUimReadRecordOutput.
 * @read_result: a placeholder for the output #GArray of #guint8 elements, or %NULL if not required. Do not free it, it is owned by @self.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Read Result' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_record_output_get_read_result (
    QmiMessageUimReadRecordOutput *self,
    GArray **read_result,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_read_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Read Result' was not found in the message");
        return FALSE;
    }

    if (read_result)
        *read_result = self->arg_read_result;

    return TRUE;
}

/**
 * qmi_message_uim_read_record_output_get_additional_read_result:
 * @self: a #QmiMessageUimReadRecordOutput.
 * @additional_read_result: a placeholder for the output #GArray of #guint8 elements, or %NULL if not required. Do not free it, it is owned by @self.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Additional Read Result' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_record_output_get_additional_read_result (
    QmiMessageUimReadRecordOutput *self,
    GArray **additional_read_result,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_additional_read_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Additional Read Result' was not found in the message");
        return FALSE;
    }

    if (additional_read_result)
        *additional_read_result = self->arg_additional_read_result;

    return TRUE;
}

/**
 * qmi_message_uim_read_record_output_get_response_in_indication_token:
 * @self: a #QmiMessageUimReadRecordOutput.
 * @response_in_indication_token: a placeholder for the output #guint32, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Response In Indication Token' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_read_record_output_get_response_in_indication_token (
    QmiMessageUimReadRecordOutput *self,
    guint32 *response_in_indication_token,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_response_in_indication_token_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Response In Indication Token' was not found in the message");
        return FALSE;
    }

    if (response_in_indication_token)
        *response_in_indication_token = self->arg_response_in_indication_token;

    return TRUE;
}

GType
qmi_message_uim_read_record_output_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageUimReadRecordOutput"),
                                          (GBoxedCopyFunc) qmi_message_uim_read_record_output_ref,
                                          (GBoxedFreeFunc) qmi_message_uim_read_record_output_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_uim_read_record_output_ref:
 * @self: a #QmiMessageUimReadRecordOutput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageUimReadRecordOutput *
qmi_message_uim_read_record_output_ref (QmiMessageUimReadRecordOutput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_uim_read_record_output_unref:
 * @self: a #QmiMessageUimReadRecordOutput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_uim_read_record_output_unref (QmiMessageUimReadRecordOutput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        if (self->arg_read_result)
            g_array_unref (self->arg_read_result);
        if (self->arg_additional_read_result)
            g_array_unref (self->arg_additional_read_result);
        g_slice_free (QmiMessageUimReadRecordOutput, self);
    }
}

static gboolean
qmi_message_uim_read_record_input_response_in_indication_token_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Response In Indication Token' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Response In Indication Token' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_read_record_input_response_in_indication_token_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN,
                                      &buffer_len);
    if (buffer && qmi_message_uim_read_record_input_response_in_indication_token_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT32_FORMAT "", tmp);
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Response In Indication Token' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_read_record_input_last_record_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 2;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Last Record' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Last Record' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_read_record_input_last_record_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_LAST_RECORD,
                                      &buffer_len);
    if (buffer && qmi_message_uim_read_record_input_last_record_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Last Record' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_read_record_input_record_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 2;
    expected_len += 2;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Record' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Record' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_read_record_input_record_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_RECORD,
                                      &buffer_len);
    if (buffer && qmi_message_uim_read_record_input_record_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " record_number = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " record_length = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Record' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_read_record_input_file_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 2;
    {
        guint file_path_i;

        guint8 file_path_n_items;
        const guint8 *file_path_aux_buffer = &buffer[expected_len];
        guint16 file_path_aux_buffer_len;

        file_path_aux_buffer_len = ((buffer_len >= expected_len) ? buffer_len - expected_len : 0);
        if (file_path_aux_buffer_len < 1) {
            g_warning ("Cannot read the array size: expected '%u' bytes, but only got '%u' bytes",
                       1, file_path_aux_buffer_len);
            return FALSE;
        }

        expected_len += 1;
        /* Read the guint8 variable from the buffer */
        qmi_utils_read_guint8_from_buffer (
            &file_path_aux_buffer,
            &file_path_aux_buffer_len,
            &(file_path_n_items));

        for (file_path_i = 0; file_path_i < file_path_n_items; file_path_i++) {

            expected_len += 1;
        }
    }

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'File' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'File' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_read_record_input_file_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_FILE,
                                      &buffer_len);
    if (buffer && qmi_message_uim_read_record_input_file_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " file_id = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " file_path = '");
        {
            guint file_path_i;
            guint8 file_path_n_items;

            /* Read number of items in the array */
            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &(file_path_n_items));

            g_string_append (printable, "{");

            for (file_path_i = 0; file_path_i < file_path_n_items; file_path_i++) {
                g_string_append_printf (printable, " [%u] = '", file_path_i);

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, " '");
            }

            g_string_append (printable, "}");
        }        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'File' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_read_record_input_session_information_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;
    {
        guint8 size8;
        const guint8 *aux_buffer = &buffer[expected_len];
        guint16 aux_buffer_len;

        aux_buffer_len = ((buffer_len >= expected_len) ? buffer_len - expected_len : 0);
        if (aux_buffer_len < 1) {
            g_warning ("Cannot read the string size: expected '1' bytes, but only got '%u' bytes",
                       aux_buffer_len);
            return FALSE;
        }

        qmi_utils_read_guint8_from_buffer (&aux_buffer, &aux_buffer_len, &size8);
        expected_len += (1 + size8);
    }

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Session Information' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Session Information' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_read_record_input_session_information_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_SESSION_INFORMATION,
                                      &buffer_len);
    if (buffer && qmi_message_uim_read_record_input_session_information_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " session_type = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_UIM_SESSION_TYPE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_uim_session_type_get_string ((QmiUimSessionType)tmp));
#elif defined  __QMI_UIM_SESSION_TYPE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_uim_session_type_build_string_from_mask ((QmiUimSessionType)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiUimSessionType
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " application_identifier = '");

        {
            gchar *tmp;

            /* Read the string variable from the buffer */
            qmi_utils_read_string_from_buffer (
                &buffer,
                &buffer_len,
                8,
                0,
                &tmp);

            g_string_append_printf (printable, "%s", tmp);
            g_free (tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Session Information' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_read_record_output_card_result_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;
    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Card result' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Card result' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_read_record_output_card_result_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_READ_RECORD_OUTPUT_TLV_CARD_RESULT,
                                      &buffer_len);
    if (buffer && qmi_message_uim_read_record_output_card_result_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " sw1 = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " sw2 = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Card result' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_read_record_output_read_result_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    {
        guint read_result_i;

        guint16 read_result_n_items;
        const guint8 *read_result_aux_buffer = &buffer[expected_len];
        guint16 read_result_aux_buffer_len;

        read_result_aux_buffer_len = ((buffer_len >= expected_len) ? buffer_len - expected_len : 0);
        if (read_result_aux_buffer_len < 2) {
            g_warning ("Cannot read the array size: expected '%u' bytes, but only got '%u' bytes",
                       2, read_result_aux_buffer_len);
            return FALSE;
        }

        expected_len += 2;
        /* Read the guint16 variable from the buffer */
        qmi_utils_read_guint16_from_buffer (
            &read_result_aux_buffer,
            &read_result_aux_buffer_len,
            QMI_ENDIAN_LITTLE,
            &(read_result_n_items));

        for (read_result_i = 0; read_result_i < read_result_n_items; read_result_i++) {

            expected_len += 1;
        }
    }

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Read Result' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Read Result' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_read_record_output_read_result_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_READ_RECORD_OUTPUT_TLV_READ_RESULT,
                                      &buffer_len);
    if (buffer && qmi_message_uim_read_record_output_read_result_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        {
            guint read_result_i;
            guint16 read_result_n_items;

            /* Read number of items in the array */
            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &(read_result_n_items));

            g_string_append (printable, "{");

            for (read_result_i = 0; read_result_i < read_result_n_items; read_result_i++) {
                g_string_append_printf (printable, " [%u] = '", read_result_i);

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, " '");
            }

            g_string_append (printable, "}");
        }
        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Read Result' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_read_record_output_additional_read_result_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    {
        guint additional_read_result_i;

        guint16 additional_read_result_n_items;
        const guint8 *additional_read_result_aux_buffer = &buffer[expected_len];
        guint16 additional_read_result_aux_buffer_len;

        additional_read_result_aux_buffer_len = ((buffer_len >= expected_len) ? buffer_len - expected_len : 0);
        if (additional_read_result_aux_buffer_len < 2) {
            g_warning ("Cannot read the array size: expected '%u' bytes, but only got '%u' bytes",
                       2, additional_read_result_aux_buffer_len);
            return FALSE;
        }

        expected_len += 2;
        /* Read the guint16 variable from the buffer */
        qmi_utils_read_guint16_from_buffer (
            &additional_read_result_aux_buffer,
            &additional_read_result_aux_buffer_len,
            QMI_ENDIAN_LITTLE,
            &(additional_read_result_n_items));

        for (additional_read_result_i = 0; additional_read_result_i < additional_read_result_n_items; additional_read_result_i++) {

            expected_len += 1;
        }
    }

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Additional Read Result' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Additional Read Result' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_read_record_output_additional_read_result_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_READ_RECORD_OUTPUT_TLV_ADDITIONAL_READ_RESULT,
                                      &buffer_len);
    if (buffer && qmi_message_uim_read_record_output_additional_read_result_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        {
            guint additional_read_result_i;
            guint16 additional_read_result_n_items;

            /* Read number of items in the array */
            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &(additional_read_result_n_items));

            g_string_append (printable, "{");

            for (additional_read_result_i = 0; additional_read_result_i < additional_read_result_n_items; additional_read_result_i++) {
                g_string_append_printf (printable, " [%u] = '", additional_read_result_i);

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, " '");
            }

            g_string_append (printable, "}");
        }
        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Additional Read Result' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_read_record_output_response_in_indication_token_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Response In Indication Token' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Response In Indication Token' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_read_record_output_response_in_indication_token_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_READ_RECORD_OUTPUT_TLV_RESPONSE_IN_INDICATION_TOKEN,
                                      &buffer_len);
    if (buffer && qmi_message_uim_read_record_output_response_in_indication_token_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT32_FORMAT "", tmp);
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Response In Indication Token' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

struct message_read_record_context {
    QmiMessage *self;
    const gchar *line_prefix;
    GString *printable;
};

static void
message_read_record_get_tlv_printable (
    guint8 type,
    const guint8 *value,
    gsize length,
    struct message_read_record_context *ctx)
{
    const gchar *tlv_type_str = NULL;
    gchar *translated_value;

    if (!qmi_message_is_response (ctx->self)) {
        switch (type) {
        case QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN:
            tlv_type_str = "Response In Indication Token";
            translated_value = qmi_message_uim_read_record_input_response_in_indication_token_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_LAST_RECORD:
            tlv_type_str = "Last Record";
            translated_value = qmi_message_uim_read_record_input_last_record_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_RECORD:
            tlv_type_str = "Record";
            translated_value = qmi_message_uim_read_record_input_record_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_FILE:
            tlv_type_str = "File";
            translated_value = qmi_message_uim_read_record_input_file_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_READ_RECORD_INPUT_TLV_SESSION_INFORMATION:
            tlv_type_str = "Session Information";
            translated_value = qmi_message_uim_read_record_input_session_information_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    } else {
        switch (type) {
        case QMI_MESSAGE_UIM_READ_RECORD_OUTPUT_TLV_RESULT:
            tlv_type_str = "Result";
            translated_value = qmi_message_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_READ_RECORD_OUTPUT_TLV_CARD_RESULT:
            tlv_type_str = "Card result";
            translated_value = qmi_message_uim_read_record_output_card_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_READ_RECORD_OUTPUT_TLV_READ_RESULT:
            tlv_type_str = "Read Result";
            translated_value = qmi_message_uim_read_record_output_read_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_READ_RECORD_OUTPUT_TLV_ADDITIONAL_READ_RESULT:
            tlv_type_str = "Additional Read Result";
            translated_value = qmi_message_uim_read_record_output_additional_read_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_READ_RECORD_OUTPUT_TLV_RESPONSE_IN_INDICATION_TOKEN:
            tlv_type_str = "Response In Indication Token";
            translated_value = qmi_message_uim_read_record_output_response_in_indication_token_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    }

    if (!tlv_type_str) {
        gchar *value_str = NULL;

        value_str = qmi_message_get_tlv_printable (ctx->self,
                                                   ctx->line_prefix,
                                                   type,
                                                   value,
                                                   length);
        g_string_append (ctx->printable, value_str);
        g_free (value_str);
    } else {
        gchar *value_hex;

        value_hex = __qmi_utils_str_hex (value, length, ':');
        g_string_append_printf (ctx->printable,
                                "%sTLV:\n"
                                "%s  type       = \"%s\" (0x%02x)\n"
                                "%s  length     = %" G_GSIZE_FORMAT "\n"
                                "%s  value      = %s\n"
                                "%s  translated = %s\n",
                                ctx->line_prefix,
                                ctx->line_prefix, tlv_type_str, type,
                                ctx->line_prefix, length,
                                ctx->line_prefix, value_hex,
                                ctx->line_prefix, translated_value ? translated_value : "");
        g_free (value_hex);
        g_free (translated_value);
    }
}

static gchar *
message_read_record_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    GString *printable;

    printable = g_string_new ("");
    g_string_append_printf (printable,
                            "%s  message     = \"Read Record\" (0x0021)\n",
                            line_prefix);

    {
        struct message_read_record_context ctx;
        ctx.self = self;
        ctx.line_prefix = line_prefix;
        ctx.printable = printable;
        qmi_message_foreach_raw_tlv (self,
                                     (QmiMessageForeachRawTlvFn)message_read_record_get_tlv_printable,
                                     &ctx);
    }

    return g_string_free (printable, FALSE);
}

static QmiMessageUimReadRecordOutput *
__qmi_message_uim_read_record_response_parse (
    QmiMessage *message,
    GError **error)
{
    QmiMessageUimReadRecordOutput *self;

    g_return_val_if_fail (qmi_message_get_message_id (message) == QMI_MESSAGE_UIM_READ_RECORD, NULL);

    self = g_slice_new0 (QmiMessageUimReadRecordOutput);
    self->ref_count = 1;

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_UIM_READ_RECORD_OUTPUT_TLV_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_result_validate (buffer, buffer_len)) {
                self->arg_result_set = TRUE;

                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_status));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_code));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Result' TLV", buffer_len);
                }
            } else {
                g_set_error (error,
                             QMI_CORE_ERROR,
                             QMI_CORE_ERROR_TLV_NOT_FOUND,
                             "Couldn't get the Result TLV: Not found");
                qmi_message_uim_read_record_output_unref (self);
                return NULL;
            }

        }
    } while (0);

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_UIM_READ_RECORD_OUTPUT_TLV_CARD_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_uim_read_record_output_card_result_validate (buffer, buffer_len)) {
                self->arg_card_result_set = TRUE;

                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_card_result_sw1));
                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_card_result_sw2));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Card result' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_UIM_READ_RECORD_OUTPUT_TLV_READ_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_uim_read_record_output_read_result_validate (buffer, buffer_len)) {
                self->arg_read_result_set = TRUE;

                {
                    guint read_result_i;
                    guint16 read_result_n_items;

                    /* Read number of items in the array */
                    /* Read the guint16 variable from the buffer */
                    qmi_utils_read_guint16_from_buffer (
                        &buffer,
                        &buffer_len,
                        QMI_ENDIAN_LITTLE,
                        &(read_result_n_items));

                    self->arg_read_result = g_array_sized_new (
                        FALSE,
                        FALSE,
                        sizeof (guint8),
                        (guint)read_result_n_items);

                    for (read_result_i = 0; read_result_i < read_result_n_items; read_result_i++) {
                        guint8 read_result_aux;

                        /* Read the guint8 variable from the buffer */
                        qmi_utils_read_guint8_from_buffer (
                            &buffer,
                            &buffer_len,
                            &(read_result_aux));
                        g_array_insert_val (self->arg_read_result, read_result_i, read_result_aux);
                    }
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Read Result' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_UIM_READ_RECORD_OUTPUT_TLV_ADDITIONAL_READ_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_uim_read_record_output_additional_read_result_validate (buffer, buffer_len)) {
                self->arg_additional_read_result_set = TRUE;

                {
                    guint additional_read_result_i;
                    guint16 additional_read_result_n_items;

                    /* Read number of items in the array */
                    /* Read the guint16 variable from the buffer */
                    qmi_utils_read_guint16_from_buffer (
                        &buffer,
                        &buffer_len,
                        QMI_ENDIAN_LITTLE,
                        &(additional_read_result_n_items));

                    self->arg_additional_read_result = g_array_sized_new (
                        FALSE,
                        FALSE,
                        sizeof (guint8),
                        (guint)additional_read_result_n_items);

                    for (additional_read_result_i = 0; additional_read_result_i < additional_read_result_n_items; additional_read_result_i++) {
                        guint8 additional_read_result_aux;

                        /* Read the guint8 variable from the buffer */
                        qmi_utils_read_guint8_from_buffer (
                            &buffer,
                            &buffer_len,
                            &(additional_read_result_aux));
                        g_array_insert_val (self->arg_additional_read_result, additional_read_result_i, additional_read_result_aux);
                    }
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Additional Read Result' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_UIM_READ_RECORD_OUTPUT_TLV_RESPONSE_IN_INDICATION_TOKEN,
                                              &buffer_len);
            if (buffer && qmi_message_uim_read_record_output_response_in_indication_token_validate (buffer, buffer_len)) {
                self->arg_response_in_indication_token_set = TRUE;

                /* Read the guint32 variable from the buffer */
                qmi_utils_read_guint32_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_response_in_indication_token));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Response In Indication Token' TLV", buffer_len);
                }
            }

        }
    } while (0);

    return self;
}

/*****************************************************************************/
/* REQUEST/RESPONSE: Qmi Message UIM Get File Attributes */


/* --- Input -- */

struct _QmiMessageUimGetFileAttributesInput {
    volatile gint ref_count;

    /* Response In Indication Token */
    gboolean arg_response_in_indication_token_set;
    guint32 arg_response_in_indication_token;

    /* File */
    gboolean arg_file_set;
    guint16 arg_file_file_id;
    GArray *arg_file_file_path;

    /* Session Information */
    gboolean arg_session_information_set;
    guint8 arg_session_information_session_type;
    gchar *arg_session_information_application_identifier;
};

#define QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN 0x10
#define QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_FILE 0x02
#define QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_SESSION_INFORMATION 0x01

/**
 * qmi_message_uim_get_file_attributes_input_get_response_in_indication_token:
 * @self: a #QmiMessageUimGetFileAttributesInput.
 * @response_in_indication_token: a placeholder for the output #guint32, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Response In Indication Token' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_get_file_attributes_input_get_response_in_indication_token (
    QmiMessageUimGetFileAttributesInput *self,
    guint32 *response_in_indication_token,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_response_in_indication_token_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Response In Indication Token' was not found in the message");
        return FALSE;
    }

    if (response_in_indication_token)
        *response_in_indication_token = self->arg_response_in_indication_token;

    return TRUE;
}

/**
 * qmi_message_uim_get_file_attributes_input_set_response_in_indication_token:
 * @self: a #QmiMessageUimGetFileAttributesInput.
 * @response_in_indication_token: a #guint32.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Response In Indication Token' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_uim_get_file_attributes_input_set_response_in_indication_token (
    QmiMessageUimGetFileAttributesInput *self,
    guint32 response_in_indication_token,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_response_in_indication_token = response_in_indication_token;
    self->arg_response_in_indication_token_set = TRUE;

    return TRUE;
}

/**
 * qmi_message_uim_get_file_attributes_input_get_file:
 * @self: a #QmiMessageUimGetFileAttributesInput.
 * @file_file_id: a placeholder for the output #guint16, or %NULL if not required.
 * @file_file_path: a placeholder for the output #GArray of #guint8 elements, or %NULL if not required. Do not free it, it is owned by @self.
 * @error: Return location for error or %NULL.
 *
 * Get the 'File' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_get_file_attributes_input_get_file (
    QmiMessageUimGetFileAttributesInput *self,
    guint16 *file_file_id,
    GArray **file_file_path,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_file_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'File' was not found in the message");
        return FALSE;
    }

    if (file_file_id)
        *file_file_id = self->arg_file_file_id;
    if (file_file_path)
        *file_file_path = self->arg_file_file_path;

    return TRUE;
}

/**
 * qmi_message_uim_get_file_attributes_input_set_file:
 * @self: a #QmiMessageUimGetFileAttributesInput.
 * @file_file_id: a #guint16.
 * @file_file_path: a #GArray of #guint8 elements. A new reference to @file_file_path will be taken.
 * @error: Return location for error or %NULL.
 *
 * Set the 'File' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_uim_get_file_attributes_input_set_file (
    QmiMessageUimGetFileAttributesInput *self,
    guint16 file_file_id,
    GArray *file_file_path,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_file_file_id = file_file_id;
    if (self->arg_file_file_path)
        g_array_unref (self->arg_file_file_path);
    self->arg_file_file_path = g_array_ref (file_file_path);
    self->arg_file_set = TRUE;

    return TRUE;
}

/**
 * qmi_message_uim_get_file_attributes_input_get_session_information:
 * @self: a #QmiMessageUimGetFileAttributesInput.
 * @session_information_session_type: a placeholder for the output #QmiUimSessionType, or %NULL if not required.
 * @session_information_application_identifier: a placeholder for the output constant string, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Session Information' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_get_file_attributes_input_get_session_information (
    QmiMessageUimGetFileAttributesInput *self,
    QmiUimSessionType *session_information_session_type,
    const gchar **session_information_application_identifier,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_session_information_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Session Information' was not found in the message");
        return FALSE;
    }

    if (session_information_session_type)
        *session_information_session_type = (QmiUimSessionType)(self->arg_session_information_session_type);
    if (session_information_application_identifier)
        *session_information_application_identifier = self->arg_session_information_application_identifier;

    return TRUE;
}

/**
 * qmi_message_uim_get_file_attributes_input_set_session_information:
 * @self: a #QmiMessageUimGetFileAttributesInput.
 * @session_information_session_type: a #QmiUimSessionType.
 * @session_information_application_identifier: a constant string.
 * @error: Return location for error or %NULL.
 *
 * Set the 'Session Information' field in the message.
 *
 * Returns: %TRUE if @value was successfully set, %FALSE otherwise.
 */
gboolean
qmi_message_uim_get_file_attributes_input_set_session_information (
    QmiMessageUimGetFileAttributesInput *self,
    QmiUimSessionType session_information_session_type,
    const gchar *session_information_application_identifier,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    self->arg_session_information_session_type = (guint8)(session_information_session_type);
    g_free (self->arg_session_information_application_identifier);
    self->arg_session_information_application_identifier = g_strdup (session_information_application_identifier ? session_information_application_identifier : "");
    self->arg_session_information_set = TRUE;

    return TRUE;
}

GType
qmi_message_uim_get_file_attributes_input_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageUimGetFileAttributesInput"),
                                          (GBoxedCopyFunc) qmi_message_uim_get_file_attributes_input_ref,
                                          (GBoxedFreeFunc) qmi_message_uim_get_file_attributes_input_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_uim_get_file_attributes_input_ref:
 * @self: a #QmiMessageUimGetFileAttributesInput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageUimGetFileAttributesInput *
qmi_message_uim_get_file_attributes_input_ref (QmiMessageUimGetFileAttributesInput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_uim_get_file_attributes_input_unref:
 * @self: a #QmiMessageUimGetFileAttributesInput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_uim_get_file_attributes_input_unref (QmiMessageUimGetFileAttributesInput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        if (self->arg_file_file_path)
            g_array_unref (self->arg_file_file_path);
        g_free (self->arg_session_information_application_identifier);
        g_slice_free (QmiMessageUimGetFileAttributesInput, self);
    }
}

/**
 * qmi_message_uim_get_file_attributes_input_new:
 *
 * Allocates a new #QmiMessageUimGetFileAttributesInput.
 *
 * Returns: the newly created #QmiMessageUimGetFileAttributesInput. The returned value should be freed with qmi_message_uim_get_file_attributes_input_unref().
 */
QmiMessageUimGetFileAttributesInput *
qmi_message_uim_get_file_attributes_input_new (void)
{
    QmiMessageUimGetFileAttributesInput *self;

    self = g_slice_new0 (QmiMessageUimGetFileAttributesInput);
    self->ref_count = 1;
    return self;
}

static QmiMessage *
__qmi_message_uim_get_file_attributes_request_create (
    guint8 transaction_id,
    guint8 cid,
    QmiMessageUimGetFileAttributesInput *input,
    GError **error)
{
    QmiMessage *self;

    self = qmi_message_new (QMI_SERVICE_UIM,
                            cid,
                            transaction_id,
                            QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES);

    /* There is at least one mandatory TLV, don't allow NULL input */
    if (!input) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_ARGS,
                     "Message 'Get File Attributes' has mandatory TLVs");
        qmi_message_unref (self);
        return NULL;
    }

    /* Try to add the 'Response In Indication Token' TLV */
    if (input->arg_response_in_indication_token_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        /* Write the guint32 variable to the buffer */
        if (buffer_len < 4)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN;
        else
            qmi_utils_write_guint32_to_buffer (
                &buffer_aux,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &(input->arg_response_in_indication_token));

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN:
            g_prefix_error (error, "Couldn't set the Response In Indication Token TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    }

    /* Try to add the 'File' TLV */
    if (input->arg_file_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        /* Write the guint16 variable to the buffer */
        if (buffer_len < 2)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_FILE;
        else
            qmi_utils_write_guint16_to_buffer (
                &buffer_aux,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &(input->arg_file_file_id));
        {
            guint file_path_i;
            guint8 file_path_n_items;

            /* Write the number of items in the array first */
            file_path_n_items = (guint8) input->arg_file_file_path->len;
            /* Write the guint8 variable to the buffer */
            if (buffer_len < 1)
                goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_FILE;
            else
                qmi_utils_write_guint8_to_buffer (
                    &buffer_aux,
                    &buffer_len,
                    &(file_path_n_items));

            for (file_path_i = 0; file_path_i < input->arg_file_file_path->len; file_path_i++) {
                /* Write the guint8 variable to the buffer */
                if (buffer_len < 1)
                    goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_FILE;
                else
                    qmi_utils_write_guint8_to_buffer (
                        &buffer_aux,
                        &buffer_len,
                        &(g_array_index (input->arg_file_file_path, guint8,file_path_i)));
            }
        }

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_FILE:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_FILE;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_FILE,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_FILE:
            g_prefix_error (error, "Couldn't set the File TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    } else {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_ARGS,
                     "Missing mandatory TLV 'File' in message 'Get File Attributes'");
        qmi_message_unref (self);
        return NULL;
    }

    /* Try to add the 'Session Information' TLV */
    if (input->arg_session_information_set) {
        guint8 buffer[1024];
        guint16 buffer_len = 1024;
        guint8 *buffer_aux = buffer;

        if (buffer_len < 1)
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_SESSION_INFORMATION;
        else {
            guint8 tmp;

            tmp = (guint8)input->arg_session_information_session_type;
            /* Write the guint8 variable to the buffer */
            qmi_utils_write_guint8_to_buffer (
                &buffer_aux,
                &buffer_len,
                &tmp);
        }
        /* Write the string variable to the buffer */
        if (!input->arg_session_information_application_identifier || buffer_len < 8 + strlen (input->arg_session_information_application_identifier))
            goto ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_SESSION_INFORMATION;
        else
            qmi_utils_write_string_to_buffer (
               &buffer_aux,
               &buffer_len,
               8,
               input->arg_session_information_application_identifier);

        if (FALSE) {
            ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_SESSION_INFORMATION:
            g_set_error (error, QMI_CORE_ERROR, QMI_CORE_ERROR_TLV_TOO_LONG, "result larger then 1024 bytes");
            goto OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_SESSION_INFORMATION;
        }

        g_assert (buffer_len <= 1024);
        if (!qmi_message_add_raw_tlv (self,
                                      (guint8)QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_SESSION_INFORMATION,
                                      buffer,
                                      (1024 - buffer_len),
                                      error)) {
            OUT_ERR_EMIT_BUFFER_OVERFLOW_QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_SESSION_INFORMATION:
            g_prefix_error (error, "Couldn't set the Session Information TLV: ");
            qmi_message_unref (self);
            return NULL;
        }
    } else {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_ARGS,
                     "Missing mandatory TLV 'Session Information' in message 'Get File Attributes'");
        qmi_message_unref (self);
        return NULL;
    }

    return self;
}

/* --- Output -- */

struct _QmiMessageUimGetFileAttributesOutput {
    volatile gint ref_count;

    /* Result */
    gboolean arg_result_set;
    QmiMessageResult arg_result;

    /* Card result */
    gboolean arg_card_result_set;
    guint8 arg_card_result_sw1;
    guint8 arg_card_result_sw2;

    /* File Attributes */
    gboolean arg_file_attributes_set;
    guint16 arg_file_attributes_file_size;
    guint16 arg_file_attributes_file_id;
    guint8 arg_file_attributes_file_type;
    guint16 arg_file_attributes_record_size;
    guint16 arg_file_attributes_record_count;
    guint8 arg_file_attributes_read_security_attributes_logic;
    guint16 arg_file_attributes_read_security_attributes;
    guint8 arg_file_attributes_write_security_attributes_logic;
    guint16 arg_file_attributes_write_security_attributes;
    guint8 arg_file_attributes_increase_security_attributes_logic;
    guint16 arg_file_attributes_increase_security_attributes;
    guint8 arg_file_attributes_deactivate_security_attributes_logic;
    guint16 arg_file_attributes_deactivate_security_attributes;
    guint8 arg_file_attributes_activate_security_attributes_logic;
    guint16 arg_file_attributes_activate_security_attributes;
    GArray *arg_file_attributes_raw_data;

    /* Response In Indication Token */
    gboolean arg_response_in_indication_token_set;
    guint32 arg_response_in_indication_token;
};

#define QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_OUTPUT_TLV_RESULT 0x02
#define QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_OUTPUT_TLV_CARD_RESULT 0x10
#define QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_OUTPUT_TLV_FILE_ATTRIBUTES 0x11
#define QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_OUTPUT_TLV_RESPONSE_IN_INDICATION_TOKEN 0x12

/**
 * qmi_message_uim_get_file_attributes_output_get_result:
 * @self: a QmiMessageUimGetFileAttributesOutput.
 * @error: Return location for error or %NULL.
 *
 * Get the result of the QMI operation.
 *
 * Returns: %TRUE if the QMI operation succeeded, %FALSE if @error is set.
 */
gboolean
qmi_message_uim_get_file_attributes_output_get_result (
    QmiMessageUimGetFileAttributesOutput *self,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    /* We should always have a result set in the response message */
    if (!self->arg_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_INVALID_MESSAGE,
                     "No 'Result' field given in the message");
        return FALSE;
    }

    if (self->arg_result.error_status == QMI_STATUS_SUCCESS) {
        /* Operation succeeded */
        return TRUE;
    }

    /* Report a QMI protocol error */
    g_set_error (error,
                 QMI_PROTOCOL_ERROR,
                 (QmiProtocolError) self->arg_result.error_code,
                 "QMI protocol error (%u): '%s'",
                 self->arg_result.error_code,
                 qmi_protocol_error_get_string ((QmiProtocolError) self->arg_result.error_code));
    return FALSE;
}

/**
 * qmi_message_uim_get_file_attributes_output_get_card_result:
 * @self: a #QmiMessageUimGetFileAttributesOutput.
 * @card_result_sw1: a placeholder for the output #guint8, or %NULL if not required.
 * @card_result_sw2: a placeholder for the output #guint8, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Card result' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_get_file_attributes_output_get_card_result (
    QmiMessageUimGetFileAttributesOutput *self,
    guint8 *card_result_sw1,
    guint8 *card_result_sw2,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_card_result_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Card result' was not found in the message");
        return FALSE;
    }

    if (card_result_sw1)
        *card_result_sw1 = self->arg_card_result_sw1;
    if (card_result_sw2)
        *card_result_sw2 = self->arg_card_result_sw2;

    return TRUE;
}

/**
 * qmi_message_uim_get_file_attributes_output_get_file_attributes:
 * @self: a #QmiMessageUimGetFileAttributesOutput.
 * @file_attributes_file_size: a placeholder for the output #guint16, or %NULL if not required.
 * @file_attributes_file_id: a placeholder for the output #guint16, or %NULL if not required.
 * @file_attributes_file_type: a placeholder for the output #QmiUimFileType, or %NULL if not required.
 * @file_attributes_record_size: a placeholder for the output #guint16, or %NULL if not required.
 * @file_attributes_record_count: a placeholder for the output #guint16, or %NULL if not required.
 * @file_attributes_read_security_attributes_logic: a placeholder for the output #QmiUimSecurityAttributeLogic, or %NULL if not required.
 * @file_attributes_read_security_attributes: a placeholder for the output #QmiUimSecurityAttribute, or %NULL if not required.
 * @file_attributes_write_security_attributes_logic: a placeholder for the output #QmiUimSecurityAttributeLogic, or %NULL if not required.
 * @file_attributes_write_security_attributes: a placeholder for the output #QmiUimSecurityAttribute, or %NULL if not required.
 * @file_attributes_increase_security_attributes_logic: a placeholder for the output #QmiUimSecurityAttributeLogic, or %NULL if not required.
 * @file_attributes_increase_security_attributes: a placeholder for the output #QmiUimSecurityAttribute, or %NULL if not required.
 * @file_attributes_deactivate_security_attributes_logic: a placeholder for the output #QmiUimSecurityAttributeLogic, or %NULL if not required.
 * @file_attributes_deactivate_security_attributes: a placeholder for the output #QmiUimSecurityAttribute, or %NULL if not required.
 * @file_attributes_activate_security_attributes_logic: a placeholder for the output #QmiUimSecurityAttributeLogic, or %NULL if not required.
 * @file_attributes_activate_security_attributes: a placeholder for the output #QmiUimSecurityAttribute, or %NULL if not required.
 * @file_attributes_raw_data: a placeholder for the output #GArray of #guint8 elements, or %NULL if not required. Do not free it, it is owned by @self.
 * @error: Return location for error or %NULL.
 *
 * Get the 'File Attributes' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_get_file_attributes_output_get_file_attributes (
    QmiMessageUimGetFileAttributesOutput *self,
    guint16 *file_attributes_file_size,
    guint16 *file_attributes_file_id,
    QmiUimFileType *file_attributes_file_type,
    guint16 *file_attributes_record_size,
    guint16 *file_attributes_record_count,
    QmiUimSecurityAttributeLogic *file_attributes_read_security_attributes_logic,
    QmiUimSecurityAttribute *file_attributes_read_security_attributes,
    QmiUimSecurityAttributeLogic *file_attributes_write_security_attributes_logic,
    QmiUimSecurityAttribute *file_attributes_write_security_attributes,
    QmiUimSecurityAttributeLogic *file_attributes_increase_security_attributes_logic,
    QmiUimSecurityAttribute *file_attributes_increase_security_attributes,
    QmiUimSecurityAttributeLogic *file_attributes_deactivate_security_attributes_logic,
    QmiUimSecurityAttribute *file_attributes_deactivate_security_attributes,
    QmiUimSecurityAttributeLogic *file_attributes_activate_security_attributes_logic,
    QmiUimSecurityAttribute *file_attributes_activate_security_attributes,
    GArray **file_attributes_raw_data,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_file_attributes_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'File Attributes' was not found in the message");
        return FALSE;
    }

    if (file_attributes_file_size)
        *file_attributes_file_size = self->arg_file_attributes_file_size;
    if (file_attributes_file_id)
        *file_attributes_file_id = self->arg_file_attributes_file_id;
    if (file_attributes_file_type)
        *file_attributes_file_type = (QmiUimFileType)(self->arg_file_attributes_file_type);
    if (file_attributes_record_size)
        *file_attributes_record_size = self->arg_file_attributes_record_size;
    if (file_attributes_record_count)
        *file_attributes_record_count = self->arg_file_attributes_record_count;
    if (file_attributes_read_security_attributes_logic)
        *file_attributes_read_security_attributes_logic = (QmiUimSecurityAttributeLogic)(self->arg_file_attributes_read_security_attributes_logic);
    if (file_attributes_read_security_attributes)
        *file_attributes_read_security_attributes = (QmiUimSecurityAttribute)(self->arg_file_attributes_read_security_attributes);
    if (file_attributes_write_security_attributes_logic)
        *file_attributes_write_security_attributes_logic = (QmiUimSecurityAttributeLogic)(self->arg_file_attributes_write_security_attributes_logic);
    if (file_attributes_write_security_attributes)
        *file_attributes_write_security_attributes = (QmiUimSecurityAttribute)(self->arg_file_attributes_write_security_attributes);
    if (file_attributes_increase_security_attributes_logic)
        *file_attributes_increase_security_attributes_logic = (QmiUimSecurityAttributeLogic)(self->arg_file_attributes_increase_security_attributes_logic);
    if (file_attributes_increase_security_attributes)
        *file_attributes_increase_security_attributes = (QmiUimSecurityAttribute)(self->arg_file_attributes_increase_security_attributes);
    if (file_attributes_deactivate_security_attributes_logic)
        *file_attributes_deactivate_security_attributes_logic = (QmiUimSecurityAttributeLogic)(self->arg_file_attributes_deactivate_security_attributes_logic);
    if (file_attributes_deactivate_security_attributes)
        *file_attributes_deactivate_security_attributes = (QmiUimSecurityAttribute)(self->arg_file_attributes_deactivate_security_attributes);
    if (file_attributes_activate_security_attributes_logic)
        *file_attributes_activate_security_attributes_logic = (QmiUimSecurityAttributeLogic)(self->arg_file_attributes_activate_security_attributes_logic);
    if (file_attributes_activate_security_attributes)
        *file_attributes_activate_security_attributes = (QmiUimSecurityAttribute)(self->arg_file_attributes_activate_security_attributes);
    if (file_attributes_raw_data)
        *file_attributes_raw_data = self->arg_file_attributes_raw_data;

    return TRUE;
}

/**
 * qmi_message_uim_get_file_attributes_output_get_response_in_indication_token:
 * @self: a #QmiMessageUimGetFileAttributesOutput.
 * @response_in_indication_token: a placeholder for the output #guint32, or %NULL if not required.
 * @error: Return location for error or %NULL.
 *
 * Get the 'Response In Indication Token' field from @self.
 *
 * Returns: %TRUE if the field is found, %FALSE otherwise.
 */
gboolean
qmi_message_uim_get_file_attributes_output_get_response_in_indication_token (
    QmiMessageUimGetFileAttributesOutput *self,
    guint32 *response_in_indication_token,
    GError **error)
{
    g_return_val_if_fail (self != NULL, FALSE);

    if (!self->arg_response_in_indication_token_set) {
        g_set_error (error,
                     QMI_CORE_ERROR,
                     QMI_CORE_ERROR_TLV_NOT_FOUND,
                     "Field 'Response In Indication Token' was not found in the message");
        return FALSE;
    }

    if (response_in_indication_token)
        *response_in_indication_token = self->arg_response_in_indication_token;

    return TRUE;
}

GType
qmi_message_uim_get_file_attributes_output_get_type (void)
{
    static volatile gsize g_define_type_id__volatile = 0;

    if (g_once_init_enter (&g_define_type_id__volatile)) {
        GType g_define_type_id =
            g_boxed_type_register_static (g_intern_static_string ("QmiMessageUimGetFileAttributesOutput"),
                                          (GBoxedCopyFunc) qmi_message_uim_get_file_attributes_output_ref,
                                          (GBoxedFreeFunc) qmi_message_uim_get_file_attributes_output_unref);

        g_once_init_leave (&g_define_type_id__volatile, g_define_type_id);
    }

    return g_define_type_id__volatile;
}

/**
 * qmi_message_uim_get_file_attributes_output_ref:
 * @self: a #QmiMessageUimGetFileAttributesOutput.
 *
 * Atomically increments the reference count of @self by one.
 *
 * Returns: the new reference to @self.
 */
QmiMessageUimGetFileAttributesOutput *
qmi_message_uim_get_file_attributes_output_ref (QmiMessageUimGetFileAttributesOutput *self)
{
    g_return_val_if_fail (self != NULL, NULL);

    g_atomic_int_inc (&self->ref_count);
    return self;
}

/**
 * qmi_message_uim_get_file_attributes_output_unref:
 * @self: a #QmiMessageUimGetFileAttributesOutput.
 *
 * Atomically decrements the reference count of @self by one.
 * If the reference count drops to 0, @self is completely disposed.
 */
void
qmi_message_uim_get_file_attributes_output_unref (QmiMessageUimGetFileAttributesOutput *self)
{
    g_return_if_fail (self != NULL);

    if (g_atomic_int_dec_and_test (&self->ref_count)) {
        if (self->arg_file_attributes_raw_data)
            g_array_unref (self->arg_file_attributes_raw_data);
        g_slice_free (QmiMessageUimGetFileAttributesOutput, self);
    }
}

static gboolean
qmi_message_uim_get_file_attributes_input_response_in_indication_token_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Response In Indication Token' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Response In Indication Token' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_get_file_attributes_input_response_in_indication_token_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN,
                                      &buffer_len);
    if (buffer && qmi_message_uim_get_file_attributes_input_response_in_indication_token_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT32_FORMAT "", tmp);
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Response In Indication Token' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_get_file_attributes_input_file_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 2;
    {
        guint file_path_i;

        guint8 file_path_n_items;
        const guint8 *file_path_aux_buffer = &buffer[expected_len];
        guint16 file_path_aux_buffer_len;

        file_path_aux_buffer_len = ((buffer_len >= expected_len) ? buffer_len - expected_len : 0);
        if (file_path_aux_buffer_len < 1) {
            g_warning ("Cannot read the array size: expected '%u' bytes, but only got '%u' bytes",
                       1, file_path_aux_buffer_len);
            return FALSE;
        }

        expected_len += 1;
        /* Read the guint8 variable from the buffer */
        qmi_utils_read_guint8_from_buffer (
            &file_path_aux_buffer,
            &file_path_aux_buffer_len,
            &(file_path_n_items));

        for (file_path_i = 0; file_path_i < file_path_n_items; file_path_i++) {

            expected_len += 1;
        }
    }

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'File' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'File' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_get_file_attributes_input_file_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_FILE,
                                      &buffer_len);
    if (buffer && qmi_message_uim_get_file_attributes_input_file_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " file_id = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " file_path = '");
        {
            guint file_path_i;
            guint8 file_path_n_items;

            /* Read number of items in the array */
            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &(file_path_n_items));

            g_string_append (printable, "{");

            for (file_path_i = 0; file_path_i < file_path_n_items; file_path_i++) {
                g_string_append_printf (printable, " [%u] = '", file_path_i);

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, " '");
            }

            g_string_append (printable, "}");
        }        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'File' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_get_file_attributes_input_session_information_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;
    {
        guint8 size8;
        const guint8 *aux_buffer = &buffer[expected_len];
        guint16 aux_buffer_len;

        aux_buffer_len = ((buffer_len >= expected_len) ? buffer_len - expected_len : 0);
        if (aux_buffer_len < 1) {
            g_warning ("Cannot read the string size: expected '1' bytes, but only got '%u' bytes",
                       aux_buffer_len);
            return FALSE;
        }

        qmi_utils_read_guint8_from_buffer (&aux_buffer, &aux_buffer_len, &size8);
        expected_len += (1 + size8);
    }

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Session Information' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Session Information' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_get_file_attributes_input_session_information_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_SESSION_INFORMATION,
                                      &buffer_len);
    if (buffer && qmi_message_uim_get_file_attributes_input_session_information_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " session_type = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_UIM_SESSION_TYPE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_uim_session_type_get_string ((QmiUimSessionType)tmp));
#elif defined  __QMI_UIM_SESSION_TYPE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_uim_session_type_build_string_from_mask ((QmiUimSessionType)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiUimSessionType
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " application_identifier = '");

        {
            gchar *tmp;

            /* Read the string variable from the buffer */
            qmi_utils_read_string_from_buffer (
                &buffer,
                &buffer_len,
                8,
                0,
                &tmp);

            g_string_append_printf (printable, "%s", tmp);
            g_free (tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Session Information' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_get_file_attributes_output_card_result_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 1;
    expected_len += 1;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Card result' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Card result' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_get_file_attributes_output_card_result_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_OUTPUT_TLV_CARD_RESULT,
                                      &buffer_len);
    if (buffer && qmi_message_uim_get_file_attributes_output_card_result_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " sw1 = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " sw2 = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

            g_string_append_printf (printable, "%u", (guint)tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Card result' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_get_file_attributes_output_file_attributes_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 2;
    expected_len += 2;
    expected_len += 1;
    expected_len += 2;
    expected_len += 2;
    expected_len += 1;
    expected_len += 2;
    expected_len += 1;
    expected_len += 2;
    expected_len += 1;
    expected_len += 2;
    expected_len += 1;
    expected_len += 2;
    expected_len += 1;
    expected_len += 2;
    {
        guint raw_data_i;

        guint16 raw_data_n_items;
        const guint8 *raw_data_aux_buffer = &buffer[expected_len];
        guint16 raw_data_aux_buffer_len;

        raw_data_aux_buffer_len = ((buffer_len >= expected_len) ? buffer_len - expected_len : 0);
        if (raw_data_aux_buffer_len < 2) {
            g_warning ("Cannot read the array size: expected '%u' bytes, but only got '%u' bytes",
                       2, raw_data_aux_buffer_len);
            return FALSE;
        }

        expected_len += 2;
        /* Read the guint16 variable from the buffer */
        qmi_utils_read_guint16_from_buffer (
            &raw_data_aux_buffer,
            &raw_data_aux_buffer_len,
            QMI_ENDIAN_LITTLE,
            &(raw_data_n_items));

        for (raw_data_i = 0; raw_data_i < raw_data_n_items; raw_data_i++) {

            expected_len += 1;
        }
    }

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'File Attributes' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'File Attributes' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_get_file_attributes_output_file_attributes_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_OUTPUT_TLV_FILE_ATTRIBUTES,
                                      &buffer_len);
    if (buffer && qmi_message_uim_get_file_attributes_output_file_attributes_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");
        g_string_append (printable, "[");
        g_string_append (printable, " file_size = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " file_id = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " file_type = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_UIM_FILE_TYPE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_uim_file_type_get_string ((QmiUimFileType)tmp));
#elif defined  __QMI_UIM_FILE_TYPE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_uim_file_type_build_string_from_mask ((QmiUimFileType)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiUimFileType
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " record_size = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " record_count = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT16_FORMAT "", tmp);
        }
        g_string_append (printable, "'");
        g_string_append (printable, " read_security_attributes_logic = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_UIM_SECURITY_ATTRIBUTE_LOGIC_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_uim_security_attribute_logic_get_string ((QmiUimSecurityAttributeLogic)tmp));
#elif defined  __QMI_UIM_SECURITY_ATTRIBUTE_LOGIC_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_uim_security_attribute_logic_build_string_from_mask ((QmiUimSecurityAttributeLogic)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiUimSecurityAttributeLogic
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " read_security_attributes = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

#if defined  __QMI_UIM_SECURITY_ATTRIBUTE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_uim_security_attribute_get_string ((QmiUimSecurityAttribute)tmp));
#elif defined  __QMI_UIM_SECURITY_ATTRIBUTE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_uim_security_attribute_build_string_from_mask ((QmiUimSecurityAttribute)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiUimSecurityAttribute
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " write_security_attributes_logic = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_UIM_SECURITY_ATTRIBUTE_LOGIC_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_uim_security_attribute_logic_get_string ((QmiUimSecurityAttributeLogic)tmp));
#elif defined  __QMI_UIM_SECURITY_ATTRIBUTE_LOGIC_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_uim_security_attribute_logic_build_string_from_mask ((QmiUimSecurityAttributeLogic)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiUimSecurityAttributeLogic
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " write_security_attributes = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

#if defined  __QMI_UIM_SECURITY_ATTRIBUTE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_uim_security_attribute_get_string ((QmiUimSecurityAttribute)tmp));
#elif defined  __QMI_UIM_SECURITY_ATTRIBUTE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_uim_security_attribute_build_string_from_mask ((QmiUimSecurityAttribute)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiUimSecurityAttribute
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " increase_security_attributes_logic = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_UIM_SECURITY_ATTRIBUTE_LOGIC_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_uim_security_attribute_logic_get_string ((QmiUimSecurityAttributeLogic)tmp));
#elif defined  __QMI_UIM_SECURITY_ATTRIBUTE_LOGIC_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_uim_security_attribute_logic_build_string_from_mask ((QmiUimSecurityAttributeLogic)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiUimSecurityAttributeLogic
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " increase_security_attributes = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

#if defined  __QMI_UIM_SECURITY_ATTRIBUTE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_uim_security_attribute_get_string ((QmiUimSecurityAttribute)tmp));
#elif defined  __QMI_UIM_SECURITY_ATTRIBUTE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_uim_security_attribute_build_string_from_mask ((QmiUimSecurityAttribute)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiUimSecurityAttribute
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " deactivate_security_attributes_logic = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_UIM_SECURITY_ATTRIBUTE_LOGIC_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_uim_security_attribute_logic_get_string ((QmiUimSecurityAttributeLogic)tmp));
#elif defined  __QMI_UIM_SECURITY_ATTRIBUTE_LOGIC_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_uim_security_attribute_logic_build_string_from_mask ((QmiUimSecurityAttributeLogic)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiUimSecurityAttributeLogic
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " deactivate_security_attributes = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

#if defined  __QMI_UIM_SECURITY_ATTRIBUTE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_uim_security_attribute_get_string ((QmiUimSecurityAttribute)tmp));
#elif defined  __QMI_UIM_SECURITY_ATTRIBUTE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_uim_security_attribute_build_string_from_mask ((QmiUimSecurityAttribute)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiUimSecurityAttribute
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " activate_security_attributes_logic = '");

        {
            guint8 tmp;

            /* Read the guint8 variable from the buffer */
            qmi_utils_read_guint8_from_buffer (
                &buffer,
                &buffer_len,
                &tmp);

#if defined  __QMI_UIM_SECURITY_ATTRIBUTE_LOGIC_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_uim_security_attribute_logic_get_string ((QmiUimSecurityAttributeLogic)tmp));
#elif defined  __QMI_UIM_SECURITY_ATTRIBUTE_LOGIC_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_uim_security_attribute_logic_build_string_from_mask ((QmiUimSecurityAttributeLogic)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiUimSecurityAttributeLogic
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " activate_security_attributes = '");

        {
            guint16 tmp;

            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

#if defined  __QMI_UIM_SECURITY_ATTRIBUTE_IS_ENUM__
            g_string_append_printf (printable, "%s", qmi_uim_security_attribute_get_string ((QmiUimSecurityAttribute)tmp));
#elif defined  __QMI_UIM_SECURITY_ATTRIBUTE_IS_FLAGS__
            {
                gchar *flags_str;

                flags_str = qmi_uim_security_attribute_build_string_from_mask ((QmiUimSecurityAttribute)tmp);
                g_string_append_printf (printable, "%s", flags_str);
                g_free (flags_str);
            }
#else
# error unexpected public format: QmiUimSecurityAttribute
#endif
        }
        g_string_append (printable, "'");
        g_string_append (printable, " raw_data = '");
        {
            guint raw_data_i;
            guint16 raw_data_n_items;

            /* Read number of items in the array */
            /* Read the guint16 variable from the buffer */
            qmi_utils_read_guint16_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &(raw_data_n_items));

            g_string_append (printable, "{");

            for (raw_data_i = 0; raw_data_i < raw_data_n_items; raw_data_i++) {
                g_string_append_printf (printable, " [%u] = '", raw_data_i);

                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);

                    g_string_append_printf (printable, "%u", (guint)tmp);
                }
                g_string_append (printable, " '");
            }

            g_string_append (printable, "}");
        }        g_string_append (printable, "'");
        g_string_append (printable, " ]");

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'File Attributes' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

static gboolean
qmi_message_uim_get_file_attributes_output_response_in_indication_token_validate (
    const guint8 *buffer,
    guint16 buffer_len)
{
    guint32 expected_len = 0;

    expected_len += 4;

    if (buffer_len < expected_len) {
        g_warning ("Cannot read the 'Response In Indication Token' TLV: expected '%u' bytes, but only got '%u' bytes",
                   expected_len, buffer_len);
        return FALSE;
    }

    if (buffer_len > expected_len) {
        g_debug ("Reading the 'Response In Indication Token' TLV: expected '%u' bytes, but got '%u' bytes",
                 expected_len, buffer_len);
        return TRUE;
    }

    return TRUE;
}


static gchar *
qmi_message_uim_get_file_attributes_output_response_in_indication_token_get_printable (
    QmiMessage *message,
    const gchar *line_prefix)
{
    const guint8 *buffer;
    guint16 buffer_len;

    buffer = qmi_message_get_raw_tlv (message,
                                      QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_OUTPUT_TLV_RESPONSE_IN_INDICATION_TOKEN,
                                      &buffer_len);
    if (buffer && qmi_message_uim_get_file_attributes_output_response_in_indication_token_validate (buffer, buffer_len)) {
        GString *printable;

        printable = g_string_new ("");

        {
            guint32 tmp;

            /* Read the guint32 variable from the buffer */
            qmi_utils_read_guint32_from_buffer (
                &buffer,
                &buffer_len,
                QMI_ENDIAN_LITTLE,
                &tmp);

            g_string_append_printf (printable, "%" G_GUINT32_FORMAT "", tmp);
        }

        /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
        if (buffer_len > 0) {
            g_warning ("Left '%u' bytes unread when getting the 'Response In Indication Token' TLV as printable", buffer_len);
        }

        return g_string_free (printable, FALSE);
    }

    return NULL;
}

struct message_get_file_attributes_context {
    QmiMessage *self;
    const gchar *line_prefix;
    GString *printable;
};

static void
message_get_file_attributes_get_tlv_printable (
    guint8 type,
    const guint8 *value,
    gsize length,
    struct message_get_file_attributes_context *ctx)
{
    const gchar *tlv_type_str = NULL;
    gchar *translated_value;

    if (!qmi_message_is_response (ctx->self)) {
        switch (type) {
        case QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_RESPONSE_IN_INDICATION_TOKEN:
            tlv_type_str = "Response In Indication Token";
            translated_value = qmi_message_uim_get_file_attributes_input_response_in_indication_token_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_FILE:
            tlv_type_str = "File";
            translated_value = qmi_message_uim_get_file_attributes_input_file_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_INPUT_TLV_SESSION_INFORMATION:
            tlv_type_str = "Session Information";
            translated_value = qmi_message_uim_get_file_attributes_input_session_information_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    } else {
        switch (type) {
        case QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_OUTPUT_TLV_RESULT:
            tlv_type_str = "Result";
            translated_value = qmi_message_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_OUTPUT_TLV_CARD_RESULT:
            tlv_type_str = "Card result";
            translated_value = qmi_message_uim_get_file_attributes_output_card_result_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_OUTPUT_TLV_FILE_ATTRIBUTES:
            tlv_type_str = "File Attributes";
            translated_value = qmi_message_uim_get_file_attributes_output_file_attributes_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        case QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_OUTPUT_TLV_RESPONSE_IN_INDICATION_TOKEN:
            tlv_type_str = "Response In Indication Token";
            translated_value = qmi_message_uim_get_file_attributes_output_response_in_indication_token_get_printable (
                                   ctx->self,
                                   ctx->line_prefix);
            break;
        default:
            break;
        }
    }

    if (!tlv_type_str) {
        gchar *value_str = NULL;

        value_str = qmi_message_get_tlv_printable (ctx->self,
                                                   ctx->line_prefix,
                                                   type,
                                                   value,
                                                   length);
        g_string_append (ctx->printable, value_str);
        g_free (value_str);
    } else {
        gchar *value_hex;

        value_hex = __qmi_utils_str_hex (value, length, ':');
        g_string_append_printf (ctx->printable,
                                "%sTLV:\n"
                                "%s  type       = \"%s\" (0x%02x)\n"
                                "%s  length     = %" G_GSIZE_FORMAT "\n"
                                "%s  value      = %s\n"
                                "%s  translated = %s\n",
                                ctx->line_prefix,
                                ctx->line_prefix, tlv_type_str, type,
                                ctx->line_prefix, length,
                                ctx->line_prefix, value_hex,
                                ctx->line_prefix, translated_value ? translated_value : "");
        g_free (value_hex);
        g_free (translated_value);
    }
}

static gchar *
message_get_file_attributes_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    GString *printable;

    printable = g_string_new ("");
    g_string_append_printf (printable,
                            "%s  message     = \"Get File Attributes\" (0x0024)\n",
                            line_prefix);

    {
        struct message_get_file_attributes_context ctx;
        ctx.self = self;
        ctx.line_prefix = line_prefix;
        ctx.printable = printable;
        qmi_message_foreach_raw_tlv (self,
                                     (QmiMessageForeachRawTlvFn)message_get_file_attributes_get_tlv_printable,
                                     &ctx);
    }

    return g_string_free (printable, FALSE);
}

static QmiMessageUimGetFileAttributesOutput *
__qmi_message_uim_get_file_attributes_response_parse (
    QmiMessage *message,
    GError **error)
{
    QmiMessageUimGetFileAttributesOutput *self;

    g_return_val_if_fail (qmi_message_get_message_id (message) == QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES, NULL);

    self = g_slice_new0 (QmiMessageUimGetFileAttributesOutput);
    self->ref_count = 1;

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_OUTPUT_TLV_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_result_validate (buffer, buffer_len)) {
                self->arg_result_set = TRUE;

                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_status));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_result.error_code));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Result' TLV", buffer_len);
                }
            } else {
                g_set_error (error,
                             QMI_CORE_ERROR,
                             QMI_CORE_ERROR_TLV_NOT_FOUND,
                             "Couldn't get the Result TLV: Not found");
                qmi_message_uim_get_file_attributes_output_unref (self);
                return NULL;
            }

        }
    } while (0);

    do {
        /* No Prerequisites for field */

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_OUTPUT_TLV_CARD_RESULT,
                                              &buffer_len);
            if (buffer && qmi_message_uim_get_file_attributes_output_card_result_validate (buffer, buffer_len)) {
                self->arg_card_result_set = TRUE;

                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_card_result_sw1));
                /* Read the guint8 variable from the buffer */
                qmi_utils_read_guint8_from_buffer (
                    &buffer,
                    &buffer_len,
                    &(self->arg_card_result_sw2));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Card result' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_OUTPUT_TLV_FILE_ATTRIBUTES,
                                              &buffer_len);
            if (buffer && qmi_message_uim_get_file_attributes_output_file_attributes_validate (buffer, buffer_len)) {
                self->arg_file_attributes_set = TRUE;

                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_file_attributes_file_size));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_file_attributes_file_id));
                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_file_attributes_file_type = (QmiUimFileType)tmp;
                }
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_file_attributes_record_size));
                /* Read the guint16 variable from the buffer */
                qmi_utils_read_guint16_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_file_attributes_record_count));
                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_file_attributes_read_security_attributes_logic = (QmiUimSecurityAttributeLogic)tmp;
                }
                {
                    guint16 tmp;

                    /* Read the guint16 variable from the buffer */
                    qmi_utils_read_guint16_from_buffer (
                        &buffer,
                        &buffer_len,
                        QMI_ENDIAN_LITTLE,
                        &tmp);
                    self->arg_file_attributes_read_security_attributes = (QmiUimSecurityAttribute)tmp;
                }
                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_file_attributes_write_security_attributes_logic = (QmiUimSecurityAttributeLogic)tmp;
                }
                {
                    guint16 tmp;

                    /* Read the guint16 variable from the buffer */
                    qmi_utils_read_guint16_from_buffer (
                        &buffer,
                        &buffer_len,
                        QMI_ENDIAN_LITTLE,
                        &tmp);
                    self->arg_file_attributes_write_security_attributes = (QmiUimSecurityAttribute)tmp;
                }
                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_file_attributes_increase_security_attributes_logic = (QmiUimSecurityAttributeLogic)tmp;
                }
                {
                    guint16 tmp;

                    /* Read the guint16 variable from the buffer */
                    qmi_utils_read_guint16_from_buffer (
                        &buffer,
                        &buffer_len,
                        QMI_ENDIAN_LITTLE,
                        &tmp);
                    self->arg_file_attributes_increase_security_attributes = (QmiUimSecurityAttribute)tmp;
                }
                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_file_attributes_deactivate_security_attributes_logic = (QmiUimSecurityAttributeLogic)tmp;
                }
                {
                    guint16 tmp;

                    /* Read the guint16 variable from the buffer */
                    qmi_utils_read_guint16_from_buffer (
                        &buffer,
                        &buffer_len,
                        QMI_ENDIAN_LITTLE,
                        &tmp);
                    self->arg_file_attributes_deactivate_security_attributes = (QmiUimSecurityAttribute)tmp;
                }
                {
                    guint8 tmp;

                    /* Read the guint8 variable from the buffer */
                    qmi_utils_read_guint8_from_buffer (
                        &buffer,
                        &buffer_len,
                        &tmp);
                    self->arg_file_attributes_activate_security_attributes_logic = (QmiUimSecurityAttributeLogic)tmp;
                }
                {
                    guint16 tmp;

                    /* Read the guint16 variable from the buffer */
                    qmi_utils_read_guint16_from_buffer (
                        &buffer,
                        &buffer_len,
                        QMI_ENDIAN_LITTLE,
                        &tmp);
                    self->arg_file_attributes_activate_security_attributes = (QmiUimSecurityAttribute)tmp;
                }
                {
                    guint raw_data_i;
                    guint16 raw_data_n_items;

                    /* Read number of items in the array */
                    /* Read the guint16 variable from the buffer */
                    qmi_utils_read_guint16_from_buffer (
                        &buffer,
                        &buffer_len,
                        QMI_ENDIAN_LITTLE,
                        &(raw_data_n_items));

                    self->arg_file_attributes_raw_data = g_array_sized_new (
                        FALSE,
                        FALSE,
                        sizeof (guint8),
                        (guint)raw_data_n_items);

                    for (raw_data_i = 0; raw_data_i < raw_data_n_items; raw_data_i++) {
                        guint8 raw_data_aux;

                        /* Read the guint8 variable from the buffer */
                        qmi_utils_read_guint8_from_buffer (
                            &buffer,
                            &buffer_len,
                            &(raw_data_aux));
                        g_array_insert_val (self->arg_file_attributes_raw_data, raw_data_i, raw_data_aux);
                    }
                }

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'File Attributes' TLV", buffer_len);
                }
            }

        }
    } while (0);

    do {
        /* Prerequisite.... */
        if (!(self->arg_result.error_status == QMI_STATUS_SUCCESS))
            break;

        {
            const guint8 *buffer;
            guint16 buffer_len;

            buffer = qmi_message_get_raw_tlv (message,
                                              QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES_OUTPUT_TLV_RESPONSE_IN_INDICATION_TOKEN,
                                              &buffer_len);
            if (buffer && qmi_message_uim_get_file_attributes_output_response_in_indication_token_validate (buffer, buffer_len)) {
                self->arg_response_in_indication_token_set = TRUE;

                /* Read the guint32 variable from the buffer */
                qmi_utils_read_guint32_from_buffer (
                    &buffer,
                    &buffer_len,
                    QMI_ENDIAN_LITTLE,
                    &(self->arg_response_in_indication_token));

                /* The remaining size of the buffer needs to be 0 if we successfully read the TLV */
                if (buffer_len > 0) {
                    g_warning ("Left '%u' bytes unread when getting the 'Response In Indication Token' TLV", buffer_len);
                }
            }

        }
    } while (0);

    return self;
}

/*****************************************************************************/
/* Service-specific printable: UIM */


gchar *
__qmi_message_uim_get_printable (
    QmiMessage *self,
    const gchar *line_prefix)
{
    if (qmi_message_is_indication (self)) {
        switch (qmi_message_get_message_id (self)) {
         default:
             return NULL;
        }
    } else {
        switch (qmi_message_get_message_id (self)) {
        case QMI_MESSAGE_UIM_RESET:
            return message_reset_get_printable (self, line_prefix);
        case QMI_MESSAGE_UIM_READ_TRANSPARENT:
            return message_read_transparent_get_printable (self, line_prefix);
        case QMI_MESSAGE_UIM_READ_RECORD:
            return message_read_record_get_printable (self, line_prefix);
        case QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES:
            return message_get_file_attributes_get_printable (self, line_prefix);
         default:
             return NULL;
        }
    }
}

gboolean
__qmi_message_uim_get_version_introduced (
    QmiMessage *self,
    guint *major,
    guint *minor)
{
    switch (qmi_message_get_message_id (self)) {
    case QMI_MESSAGE_UIM_RESET:
        *major = 1;
        *minor = 0;
        return TRUE;
    case QMI_MESSAGE_UIM_READ_TRANSPARENT:
        *major = 1;
        *minor = 0;
        return TRUE;
    case QMI_MESSAGE_UIM_READ_RECORD:
        *major = 1;
        *minor = 0;
        return TRUE;
    case QMI_MESSAGE_UIM_GET_FILE_ATTRIBUTES:
        *major = 1;
        *minor = 0;
        return TRUE;
    default:
        return FALSE;
    }
}

/*****************************************************************************/
/* CLIENT: QMI Client UIM */


/**
 * SECTION: qmi-client-uim
 * @title: QmiClientUim
 * @short_description: #QmiClient for the UIM service.
 *
 * #QmiClient which handles operations in the UIM service.
 */

G_DEFINE_TYPE (QmiClientUim, qmi_client_uim, QMI_TYPE_CLIENT);

static void
process_indication (QmiClient *self,
                    QmiMessage *message)
{
    switch (qmi_message_get_message_id (message)) {
        default:
            break;
    }
}

static void
qmi_client_uim_init (QmiClientUim *self)
{
}

static void
qmi_client_uim_class_init (QmiClientUimClass *klass)
{
    QmiClientClass *client_class = QMI_CLIENT_CLASS (klass);

    client_class->process_indication = process_indication;
}


/**
 * qmi_client_uim_reset_finish:
 * @self: a #QmiClientUim.
 * @res: the #GAsyncResult obtained from the #GAsyncReadyCallback passed to qmi_client_uim_reset().
 * @error: Return location for error or %NULL.
 *
 * Finishes an async operation started with qmi_client_uim_reset().
 *
 * Returns: a #QmiMessageUimResetOutput, or %NULL if @error is set. The returned value should be freed with qmi_message_uim_reset_output_unref().
 */
QmiMessageUimResetOutput *
qmi_client_uim_reset_finish (
    QmiClientUim *self,
    GAsyncResult *res,
    GError **error)
{
   if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (res), error))
       return NULL;

   return qmi_message_uim_reset_output_ref (g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (res)));
}

static void
reset_ready (
    QmiDevice *device,
    GAsyncResult *res,
    GSimpleAsyncResult *simple)
{
    GError *error = NULL;
    QmiMessage *reply;
    QmiMessageUimResetOutput *output;

    reply = qmi_device_command_finish (device, res, &error);
    if (!reply) {
        g_simple_async_result_take_error (simple, error);
        g_simple_async_result_complete (simple);
        g_object_unref (simple);
        return;
    }

    /* Parse reply */
    output = __qmi_message_uim_reset_response_parse (reply, &error);
    if (!output)
        g_simple_async_result_take_error (simple, error);
    else
        g_simple_async_result_set_op_res_gpointer (simple,
                                                   output,
                                                   (GDestroyNotify)qmi_message_uim_reset_output_unref);
    g_simple_async_result_complete (simple);
    g_object_unref (simple);
    qmi_message_unref (reply);
}

/**
 * qmi_client_uim_reset:
 * @self: a #QmiClientUim.
 * @unused: %NULL. This message doesn't have any input bundle.
 * @timeout: maximum time to wait for the method to complete, in seconds.
 * @cancellable: a #GCancellable or %NULL.
 * @callback: a #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: user data to pass to @callback.
 *
 * Asynchronously sends a Reset request to the device.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from.
 *
 * You can then call qmi_client_uim_reset_finish() to get the result of the operation.
 */
void
qmi_client_uim_reset (
    QmiClientUim *self,
    gpointer unused,
    guint timeout,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
    GSimpleAsyncResult *result;
    QmiMessage *request;
    GError *error = NULL;
    guint16 transaction_id;

    result = g_simple_async_result_new (G_OBJECT (self),
                                        callback,
                                        user_data,
                                        qmi_client_uim_reset);

    transaction_id = qmi_client_get_next_transaction_id (QMI_CLIENT (self));

    request = __qmi_message_uim_reset_request_create (
                  transaction_id,
                  qmi_client_get_cid (QMI_CLIENT (self)),
                  NULL,
                  &error);
    if (!request) {
        g_prefix_error (&error, "Couldn't create request message: ");
        g_simple_async_result_take_error (result, error);
        g_simple_async_result_complete_in_idle (result);
        g_object_unref (result);
        return;
    }

    qmi_device_command (QMI_DEVICE (qmi_client_peek_device (QMI_CLIENT (self))),
                        request,
                        timeout,
                        cancellable,
                        (GAsyncReadyCallback)reset_ready,
                        result);
    qmi_message_unref (request);
}


/**
 * qmi_client_uim_read_transparent_finish:
 * @self: a #QmiClientUim.
 * @res: the #GAsyncResult obtained from the #GAsyncReadyCallback passed to qmi_client_uim_read_transparent().
 * @error: Return location for error or %NULL.
 *
 * Finishes an async operation started with qmi_client_uim_read_transparent().
 *
 * Returns: a #QmiMessageUimReadTransparentOutput, or %NULL if @error is set. The returned value should be freed with qmi_message_uim_read_transparent_output_unref().
 */
QmiMessageUimReadTransparentOutput *
qmi_client_uim_read_transparent_finish (
    QmiClientUim *self,
    GAsyncResult *res,
    GError **error)
{
   if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (res), error))
       return NULL;

   return qmi_message_uim_read_transparent_output_ref (g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (res)));
}

static void
read_transparent_ready (
    QmiDevice *device,
    GAsyncResult *res,
    GSimpleAsyncResult *simple)
{
    GError *error = NULL;
    QmiMessage *reply;
    QmiMessageUimReadTransparentOutput *output;

    reply = qmi_device_command_finish (device, res, &error);
    if (!reply) {
        g_simple_async_result_take_error (simple, error);
        g_simple_async_result_complete (simple);
        g_object_unref (simple);
        return;
    }

    /* Parse reply */
    output = __qmi_message_uim_read_transparent_response_parse (reply, &error);
    if (!output)
        g_simple_async_result_take_error (simple, error);
    else
        g_simple_async_result_set_op_res_gpointer (simple,
                                                   output,
                                                   (GDestroyNotify)qmi_message_uim_read_transparent_output_unref);
    g_simple_async_result_complete (simple);
    g_object_unref (simple);
    qmi_message_unref (reply);
}

/**
 * qmi_client_uim_read_transparent:
 * @self: a #QmiClientUim.
 * @input: a #QmiMessageUimReadTransparentInput.
 * @timeout: maximum time to wait for the method to complete, in seconds.
 * @cancellable: a #GCancellable or %NULL.
 * @callback: a #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: user data to pass to @callback.
 *
 * Asynchronously sends a Read Transparent request to the device.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from.
 *
 * You can then call qmi_client_uim_read_transparent_finish() to get the result of the operation.
 */
void
qmi_client_uim_read_transparent (
    QmiClientUim *self,
    QmiMessageUimReadTransparentInput *input,
    guint timeout,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
    GSimpleAsyncResult *result;
    QmiMessage *request;
    GError *error = NULL;
    guint16 transaction_id;

    result = g_simple_async_result_new (G_OBJECT (self),
                                        callback,
                                        user_data,
                                        qmi_client_uim_read_transparent);

    transaction_id = qmi_client_get_next_transaction_id (QMI_CLIENT (self));

    request = __qmi_message_uim_read_transparent_request_create (
                  transaction_id,
                  qmi_client_get_cid (QMI_CLIENT (self)),
                  input,
                  &error);
    if (!request) {
        g_prefix_error (&error, "Couldn't create request message: ");
        g_simple_async_result_take_error (result, error);
        g_simple_async_result_complete_in_idle (result);
        g_object_unref (result);
        return;
    }

    qmi_device_command (QMI_DEVICE (qmi_client_peek_device (QMI_CLIENT (self))),
                        request,
                        timeout,
                        cancellable,
                        (GAsyncReadyCallback)read_transparent_ready,
                        result);
    qmi_message_unref (request);
}


/**
 * qmi_client_uim_read_record_finish:
 * @self: a #QmiClientUim.
 * @res: the #GAsyncResult obtained from the #GAsyncReadyCallback passed to qmi_client_uim_read_record().
 * @error: Return location for error or %NULL.
 *
 * Finishes an async operation started with qmi_client_uim_read_record().
 *
 * Returns: a #QmiMessageUimReadRecordOutput, or %NULL if @error is set. The returned value should be freed with qmi_message_uim_read_record_output_unref().
 */
QmiMessageUimReadRecordOutput *
qmi_client_uim_read_record_finish (
    QmiClientUim *self,
    GAsyncResult *res,
    GError **error)
{
   if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (res), error))
       return NULL;

   return qmi_message_uim_read_record_output_ref (g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (res)));
}

static void
read_record_ready (
    QmiDevice *device,
    GAsyncResult *res,
    GSimpleAsyncResult *simple)
{
    GError *error = NULL;
    QmiMessage *reply;
    QmiMessageUimReadRecordOutput *output;

    reply = qmi_device_command_finish (device, res, &error);
    if (!reply) {
        g_simple_async_result_take_error (simple, error);
        g_simple_async_result_complete (simple);
        g_object_unref (simple);
        return;
    }

    /* Parse reply */
    output = __qmi_message_uim_read_record_response_parse (reply, &error);
    if (!output)
        g_simple_async_result_take_error (simple, error);
    else
        g_simple_async_result_set_op_res_gpointer (simple,
                                                   output,
                                                   (GDestroyNotify)qmi_message_uim_read_record_output_unref);
    g_simple_async_result_complete (simple);
    g_object_unref (simple);
    qmi_message_unref (reply);
}

/**
 * qmi_client_uim_read_record:
 * @self: a #QmiClientUim.
 * @input: a #QmiMessageUimReadRecordInput.
 * @timeout: maximum time to wait for the method to complete, in seconds.
 * @cancellable: a #GCancellable or %NULL.
 * @callback: a #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: user data to pass to @callback.
 *
 * Asynchronously sends a Read Record request to the device.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from.
 *
 * You can then call qmi_client_uim_read_record_finish() to get the result of the operation.
 */
void
qmi_client_uim_read_record (
    QmiClientUim *self,
    QmiMessageUimReadRecordInput *input,
    guint timeout,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
    GSimpleAsyncResult *result;
    QmiMessage *request;
    GError *error = NULL;
    guint16 transaction_id;

    result = g_simple_async_result_new (G_OBJECT (self),
                                        callback,
                                        user_data,
                                        qmi_client_uim_read_record);

    transaction_id = qmi_client_get_next_transaction_id (QMI_CLIENT (self));

    request = __qmi_message_uim_read_record_request_create (
                  transaction_id,
                  qmi_client_get_cid (QMI_CLIENT (self)),
                  input,
                  &error);
    if (!request) {
        g_prefix_error (&error, "Couldn't create request message: ");
        g_simple_async_result_take_error (result, error);
        g_simple_async_result_complete_in_idle (result);
        g_object_unref (result);
        return;
    }

    qmi_device_command (QMI_DEVICE (qmi_client_peek_device (QMI_CLIENT (self))),
                        request,
                        timeout,
                        cancellable,
                        (GAsyncReadyCallback)read_record_ready,
                        result);
    qmi_message_unref (request);
}


/**
 * qmi_client_uim_get_file_attributes_finish:
 * @self: a #QmiClientUim.
 * @res: the #GAsyncResult obtained from the #GAsyncReadyCallback passed to qmi_client_uim_get_file_attributes().
 * @error: Return location for error or %NULL.
 *
 * Finishes an async operation started with qmi_client_uim_get_file_attributes().
 *
 * Returns: a #QmiMessageUimGetFileAttributesOutput, or %NULL if @error is set. The returned value should be freed with qmi_message_uim_get_file_attributes_output_unref().
 */
QmiMessageUimGetFileAttributesOutput *
qmi_client_uim_get_file_attributes_finish (
    QmiClientUim *self,
    GAsyncResult *res,
    GError **error)
{
   if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (res), error))
       return NULL;

   return qmi_message_uim_get_file_attributes_output_ref (g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (res)));
}

static void
get_file_attributes_ready (
    QmiDevice *device,
    GAsyncResult *res,
    GSimpleAsyncResult *simple)
{
    GError *error = NULL;
    QmiMessage *reply;
    QmiMessageUimGetFileAttributesOutput *output;

    reply = qmi_device_command_finish (device, res, &error);
    if (!reply) {
        g_simple_async_result_take_error (simple, error);
        g_simple_async_result_complete (simple);
        g_object_unref (simple);
        return;
    }

    /* Parse reply */
    output = __qmi_message_uim_get_file_attributes_response_parse (reply, &error);
    if (!output)
        g_simple_async_result_take_error (simple, error);
    else
        g_simple_async_result_set_op_res_gpointer (simple,
                                                   output,
                                                   (GDestroyNotify)qmi_message_uim_get_file_attributes_output_unref);
    g_simple_async_result_complete (simple);
    g_object_unref (simple);
    qmi_message_unref (reply);
}

/**
 * qmi_client_uim_get_file_attributes:
 * @self: a #QmiClientUim.
 * @input: a #QmiMessageUimGetFileAttributesInput.
 * @timeout: maximum time to wait for the method to complete, in seconds.
 * @cancellable: a #GCancellable or %NULL.
 * @callback: a #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: user data to pass to @callback.
 *
 * Asynchronously sends a Get File Attributes request to the device.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from.
 *
 * You can then call qmi_client_uim_get_file_attributes_finish() to get the result of the operation.
 */
void
qmi_client_uim_get_file_attributes (
    QmiClientUim *self,
    QmiMessageUimGetFileAttributesInput *input,
    guint timeout,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
    GSimpleAsyncResult *result;
    QmiMessage *request;
    GError *error = NULL;
    guint16 transaction_id;

    result = g_simple_async_result_new (G_OBJECT (self),
                                        callback,
                                        user_data,
                                        qmi_client_uim_get_file_attributes);

    transaction_id = qmi_client_get_next_transaction_id (QMI_CLIENT (self));

    request = __qmi_message_uim_get_file_attributes_request_create (
                  transaction_id,
                  qmi_client_get_cid (QMI_CLIENT (self)),
                  input,
                  &error);
    if (!request) {
        g_prefix_error (&error, "Couldn't create request message: ");
        g_simple_async_result_take_error (result, error);
        g_simple_async_result_complete_in_idle (result);
        g_object_unref (result);
        return;
    }

    qmi_device_command (QMI_DEVICE (qmi_client_peek_device (QMI_CLIENT (self))),
                        request,
                        timeout,
                        cancellable,
                        (GAsyncReadyCallback)get_file_attributes_ready,
                        result);
    qmi_message_unref (request);
}

